Introduction

Welcome to Relativity

Overview

Relativity Designer

Relativity DBA

Relativity DBMS

Undocumented Features

ODBC-Enabled Applications

Trademark Acknowledgments


Welcome to Relativity

Thank you for purchasing Relativity, Liant Software’s programming tool that allows core data from RM/COBOL and Micro Focus COBOL applications to be retooled as a full-featured relational database. Relativity makes integrating legacy data into distributed client/server applications a straightforward and efficient process.

About Relativity Documentation

This document, Relativity Database Administrator (DBA) Help (reldbdba.chm), is one of several HTML Help files for Relativity. A companion document is the Relativity Designer Help (reldbdsn.chm) file. Both these documentation resources provide detailed information on the features and options for the Relativity DBA and Designer, along with step-by-step procedures on how to accomplish specific tasks. An extensive glossary is also included.

For more information, see Using Relativity Help.

In addition to these HTML Help systems, the Relativity documentation set also consists of separate installation guides for each software component. These manuals, available as PDF files, describe how to install the Relativity software and verify that the installation was successful.

Technical Support

Liant Software offers various support options. For a complete list and a description of each, visit the Product Support section at the Liant web site: http://www.liant.com or see Relativity Product Support.

Copyright 1994-2008. Liant Software Corporation. All rights reserved.


Overview

See Also

The Relativity product set enables the construction of a true relational database using existing COBOL application data. Relativity provides a full-featured, Windows Open Services Architecture (WOSA), Open Database Connectivity (ODBC)-compliant relational database engine. Thus, Relativity allows SQL-based client access to COBOL application data without moving, converting, replicating, or re-engineering COBOL data files.

With Relativity providing SQL-based access to COBOL data files, any ODBC-enabled client/server development application or tool can be chosen to build applications for ad hoc reporting, decision support, and specialized data processing functions. Relativity enables any working application to benefit from client/server technology without rewriting or migrating that application.

The Relativity product set consists of three main software components:

· Relativity Designer

· Relativity DBA

· Relativity DBMS


Relativity Designer

The Relativity Designer is an interactive, Windows-based tool that enables the COBOL application developer to define and maintain a relational database system of tables using COBOL data.

The Relativity Designer creates the Relativity catalog by performing the following functions:

· Automatically extracts the definitions of data files from the COBOL programs into the Relativity catalog.

· Collects information regarding the data from the application developer.

· Allows the developer to define relational tables from existing COBOL data items within records of existing COBOL files.

If an owner group has been assigned to the catalog, only users who are members of that owner group may open the data source associated with the catalog using the Relativity Designer. Assignment of an owner thus protects the sensitive data in the catalog exposed by the Relativity Designer from access by users who are not owners. A password-protected log on procedure validates user identities whenever a Relativity data source is opened, as explained in Providing Data Security.

Information for Users of Prior Versions of the Relativity Designer: The Relativity version 11 release features an important change to the Relativity Designer interface. The Catalog window ("control central") is, by default, displayed in the new Windows XP Look & Feel layout mode and procedures in the help file are written for that mode.


Relativity DBA

The Relativity DBA (Database Administrator) is an interactive, Windows-based tool that enables the system administrator at the end-user location to maintain and manage the Relativity database and the security of the Relativity database.

The Relativity DBA provides the following functions:

· Defining and authorizing users of the database.

· Restricting the view of the data for individual groups of users.

· Maintaining the linkages between tables and physical COBOL data files.

· Defining date constants.

· Merging security and connection information into a new catalog (an optional function controlled by the catalog developer).

· Producing reports on security and connections.

The Relativity DBA can be used only by users who have the Use Administrator privilege for the catalog. The catalog owner has all privileges on a database, including the Use Administrator privilege. The owner may grant the Use Administrator privilege to an administrative group different from the owner group. This allows users from the administrative group to perform the administrative functions. A password-protected log on procedure validates user identities whenever a Relativity data source is opened, as explained in Providing Data Security.


Relativity DBMS

The Relativity DBMS (Database Management System) connects Windows client-based tool products to COBOL data files. The Relativity DBMS processes SQL requests from the ODBC-enabled application (or tool) and performs the necessary actions to respond to the request with data obtained from the COBOL data files.


Undocumented Features

For last-minute information on undocumented features to this Relativity release, please refer to the "Relativity Documentation" section of the Relativity README text file included in the installation.


ODBC-Enabled Applications

Relativity is compliant with Microsoft's Open Database Connectivity (ODBC) standard. Thus, any Windows-based ODBC-enabled application can access and manipulate COBOL data files using Relativity.

Supported client tools include: current versions of Microsoft Office, Visual Basic, Access, Word, Excel, and Query; Powersoft PowerMaker, PowerViewer, PowerBuilder; Lotus 1-2-3, Approach; Trinzic Forest &Trees; Wang OpenQuery; Crystal Report Writer; Borland ReportSmith; Intersolve Q+E; Cognos Impromptu; Microsoft dbWeb; and Microsoft Internet Information Services.

Note Support for 64-bit SQL Server is only available using the Relativity 64-bit Data Client.


Trademark Acknowledgments

All terms mentioned in this online documentation that are known to be trademarks have been appropriately capitalized. Liant Software Corporation cannot attest to the accuracy of this information. Use of a term in this online documentation should not be regarded as affecting the validity of any trademark.

· Relativity, RM/COBOL, RM/COBOL-85, and RM/InfoExpress are registered trademarks of Liant Software Corporation.

· Btrieve is a registered trademark of Pervasive Software.

· IBM is a registered trademark of International Business Machines.

· Micro Focus is a registered trademark of Micro Focus International Limited.

· Microsoft, Windows, Windows 2000, Windows XP, Windows Server 2003, Windows Vista, Windows Server 2008, Microsoft Access, Microsoft Excel, Microsoft Query, and Visual Basic are registered trademarks of Microsoft Corporation in the United States and/or other countries.

· Simba is a registered trademark of Simba Technologies.

· UNIX is a registered trademark in the United States and other countries, licensed exclusively through X/Open Company Ltd.

· Other companies mentioned herein own various trademarks.


Getting Started

Starting the Relativity DBA

Customizing the Initialization File (RELDBDBA.INI)

Configuring a Relativity Data Source

Setting Options

Using Relativity Help

Relativity Product Support


Starting the Relativity DBA

See Also

When you run the Relativity Setup program, Setup automatically creates a new program group and new program items for Relativity in Windows. For more information about starting and closing the Relativity DBA, choose one of the following tasks:

· Start the Relativity DBA from Windows

· Exit the Relativity DBA


Start the Relativity DBA from Windows

You can start the Relativity DBA in several ways:

1. Start and run Windows.

2. Do one of the following:

· Click the Windows Start menu, point to Programs, point to Liant, point to Relativity v x (where x is the version number of the product), and then click DBA.

· Click the Windows Start menu, choose Run and then enter reldbdba in the Run dialog box.

· Double-click reldbdba.exe in the Relativity directory.

· Double-click the Relativity DBA icon (if you created a shortcut).

The Welcome to Relativity DBA window opens.


Exit the Relativity DBA

When you finish working in a Relativity session, exit the Relativity DBA before you quit Windows.

There are several ways to exit Relativity. Choose the one that you prefer:

· On the File menu, click Exit. Shortcut: Ctrl+F4.

· Single-click the Control Menu icon at the far left of the title bar in the Relativity DBA window and then click Close from the menu.

Alternately, double-click the Control Menu icon.

· You can also quit Relativity by clicking the Close button at the far right of the title bar.


Customizing the Initialization File (RELDBDBA.INI)

An initialization file, with the name RELDBDBA.INI, is a text file that is used to contain configuration information for the Relativity DBA. The RELDBDBA.INI file must be located in the Windows directory. It is processed whenever the Relativity DBA is executed.

While it is possible to customize the RELDBDBA.INI to suit your needs, editing should be restricted to those features described specifically below:

· Configuring Report Capabilities

· File Menu Commands

· System Options

Other entries in the RELDBDBA.INI file are reserved for use by Relativity.


Configuring a Relativity Data Source

See Also

Microsoft's Open Database Connectivity (ODBC) interface requires that a data source be configured in order to allow data access. Configuring a data source involves setting the data source name (DSN) by which the data source will be known, optionally entering a textual description of the data source, entering any additional information required by a specific ODBC driver for connecting to the actual data, and setting any options supported by the specific ODBC driver. Data source configuration applies both to setting up a new data source or modifying an existing data source.

· In single-tier (that is, non-client/server) versions of Relativity, the Data Client data source can be configured within the Relativity DBA. The Relativity DBA assumes the currently selected Relativity DBMS as the ODBC driver.

· In client/server versions of Relativity, the Data Server data source is configured using the Relativity Server Administrator, a separate utility provided with the Relativity DBMS. The Data Client data source is subsequently associated with the Data Server data source from within the Relativity DBA.

Note If you installed the Relativity Server Administrator utility, you can start this program from within the Relativity DBA by clicking Server Admin on the Tools menu. The Select Server dialog box is displayed. (For more information, see the Server Administrator Help file, which is available either by clicking Help in the Select Server dialog or by choosing Server Admin Help File on the Help menu.)

Data source configuration also can be performed outside of Relativity, using the ODBC Administrator functions available from the Windows Control Panel (see the Data Sources (ODBC) applet; on Windows XP and Vista, the applet is found under Administrative Tools in the Control Panel). The ODBC Administrator, a standard ODBC program distributed with Relativity, requires selection of a particular ODBC driver.

Since data source configuration is always specific to a selected ODBC driver, any method of starting the process requires that you complete the same tasks when configuring a Relativity data source. For more information about configuring a Relativity data source, choose one of the following tasks:

· Setting up a new data source

· Opening a data source

· Closing a data source

Note to users of Microsoft Query in Office 97 For more information on things you should know before using Relativity data sources with Microsoft Query in Office 97, click here.


Setting Up a New Data Source

See Also

An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog.

To set up a new data source:

1. Start the Relativity DBA. The Relativity DBA window opens.

2. On the File menu, click New Data Source. (For further information, see also "Setting Up a New Relativity Data Source" under the For All Users | Adding, Modifying, and Deleting a Relativity Data Source topic in the Relativity DBMS Help file.)

Alternatively, from the Welcome to Relativity window, click the New option and select the appropriate driver if you have multiple drivers installed.

3. When you have completed setting up a new Relativity data source, the Open Relativity Data Source dialog box is displayed.

4. In the Data Source Name list, select the name of the data source you want to open.

Note If you have multiple drivers installed, a list box also will be available, where you can select the appropriate driver.

5. Click Open.

If security has been defined for the catalog, see Step 6. If no security has been defined, proceed to Step 7.

6. If security has been defined for the catalog associated with this data source, the Logon dialog box is displayed. Do one of the following:

· If an owner has been defined for the catalog, type the name of a user in the Name box in the Logon dialog box.

Note If privileges have been defined for the catalog, the user name must belong to an owner group. See Catalog Ownership and procedures on defining catalog ownership.

In the Password box, type the password of the user. An asterisk (*) character is displayed for each character entered.

Click OK. The Catalog window opens for the selected data source.

· If an owner has not been defined for the catalog, there are no restrictions on the characters typed in the Name box of the Logon dialog box. If the catalog has no owner, the Password box of the Logon dialog box is left blank.

Click OK. The Catalog window opens for the selected data source.

7. If security has not been defined for the catalog associated with this data source, the Catalog window opens.


Opening a Data Source

See Also

Once a catalog has been built that supports a particular Relativity database specified by the data source, you may open the data source.

To open and maintain an existing catalog that supports the Relativity database specified by the data source:

1. Start the Relativity DBA. The Relativity DBA window opens.

2. On the File menu, click Open Data Source to display the Open Relativity Data Source dialog box.

Alternatively, from the Welcome to Relativity window, click either the Recent or Existing option, select a data source from the list, and click OK. Proceed to Step 5.

3. In the Data Source Name list, select the name of the data source you want to open.

Note If you have multiple drivers installed, a list box also will be available, where you can select the appropriate driver.

4. Click Open.

If security has been defined for the catalog, see Step 5. If no security has been defined, proceed to Step 6.

5. If security has been defined for the catalog associated with this data source, the Logon dialog box is displayed. Do one of the following:

· If an owner has been defined for the catalog, type the name of a user in the Name box in the Logon dialog box.

Note If privileges have been defined for the catalog, the user name must belong to an owner group. See Catalog Ownership and procedures on defining catalog ownership.

In the Password box, type the password of the user. An asterisk (*) character is displayed for each character entered.

Click OK to accept the log on information. The Catalog window opens for the selected data source in the Relativity DBA window.

· If an owner has not been defined for the catalog, there are no restrictions on the characters typed in the Name box of the Logon dialog box. If the catalog has no owner, the Password box of the Logon dialog box is left blank.

Click OK. The Catalog window for the selected data source opens in the Relativity DBA window.

6. If security has not been defined for the catalog associated with this data source, the Catalog window opens.

Notes

· You also may quickly open a data source by selecting a data source from the most recently used list area on the File menu.

· When a data source is open, the Edit menu and Reports menu (if the Reports administrative privilege has been granted or the RELDBDBA.INI file has been configured), are active in the menu bar of the Relativity DBA window.


Closing a Data Source

See Also

To close a data source, do one of the following:

· On the File menu, click Close Data Source. Shortcut: Ctrl+D

· In the Catalog window, single-click the Control Menu icon at the far left of the title bar and then click Close from the menu.

Alternately, double-click the Control Menu icon.

· In the Catalog window, click the Close button at the far right of the title bar.

When you close a data source the Relativity DBA window remains open, allowing you to reopen the data source, open another data source, set up a new data source, or exit the Relativity DBA.


Using Microsoft Query with Relativity Data Sources

See Also

If you use Microsoft Query in the Office 97 product suite with Relativity data sources, you should be aware of the following issue:

· Microsoft Query uses only File data source names (DSNs), while Relativity data sources can be defined only as User or System DSNs. Beginning with version 2.44, Relativity eliminates this problem by automatically creating a File DSN having the same name as the User or System data source just created. However, in versions of Relativity prior to 2.44, a File DSN must be created manually to point to the User or System DSN as follows:

1. Click the Start button, point to Settings, and then click Control Panel.

2. Double-click 32bit ODBC.

3. Click the File DSN tab.

4. Find the location of the File DSNs on this Windows workstation.

5. Create a file in that directory named datasource.dsn, where datasource is the name that you want to give the data source. The file's contents should be the following:

[ODBC]
DSN=datasource

where datasource is the name of the User or System DSN.

6. The Query wizard in Microsoft Query will not work with Relativity data sources. When you select a data source from the Choose Data Source dialog box in Microsoft Query, make sure that you deselect the Use the Query Wizard to create/edit queries check box.


Setting Options

Relativity allows you to specify default settings for various configuration preferences related to the system, file connections, and security privileges.

To display the Options dialog box:

1. Click Options from the Tools menu.

2. In the left pane of the dialog box, click the name of the option to display the corresponding page of preferences in the right pane. In the case of the Relativity DBA, all the preferences are available on one page:

· System Options


System Options

See Also

The System page contains options that enable the user to specify settings for data source and system preferences, security privileges, and the selection of data file formats in Micro Focus COBOL.

The following table describes the options available on the System page.

Option

Description

Open Last Data Source on Startup

When this check box is selected, the information about the last data source processed is stored when exiting from the Relativity DBA. The next time the Relativity DBA is started, the stored data source information determines the data source to be automatically opened. The data source name and user name are shown at the bottom of the System page.

Use White Background on Grids

When this check box is selected, Relativity overrides the color choice (set on the Appearance tab of the Display Properties dialog box) with white on the grid area containing the table definitions, table names, and path names in the Edit Connections form. If this option is not selected, the background will be the same color as the top portion in the Edit Connections form.

Bypass Version Checking

This option is reserved for future use.

Independent 'SELECT' Privilege

In a Relativity data source, a given group may have access rights or privileges to a table and to a column within a table. By default, when the DBA is requested to give INSERT, UPDATE, REFERENCES, or DELETE privileges to a table or column, the DBA also automatically (and without being requested to do so) gives a SELECT privilege (an independent privilege) to that same table or column. This occurs because the INSERT, UPDATE, REFERENCES, or DELETE privileges are of little use if the data in the table or column cannot be seen as well.

When this option is enabled, the DBA will stop automatically granting the SELECT privilege when INSERT, UPDATE, REFERENCES, or DELETE privileges are granted.

To see how the Table and Column privileges (accessed through the Privilege list on the Edit Privileges form) are affected when this check box:

· is selected, click here.

· is not selected, click here.

Debug Log

This check box appears on the System page only when you have modified the [Administrator] section of the RELDBDBA.INI file by changing the value of the DebugLog= entry to YES.

Note This option is used for debugging purposes and runs the Relativity DBA in trace mode. It should be enabled only when directed by a Liant technical support analyst.

Data File Format

This list box indicates the data file format that is to be used to open Micro Focus COBOL indexed files. The Micro Focus file manager must know the format of the indexed file so that the proper indexed file support can be used. The valid values are < none >, BTRIEVE, C-ISAM, LEVELII COBOL, IDX4, IDX8, and Default.

Note These formats are available for selection only when Micro Focus COBOL is the COBOL dialect in use. For more information about how Relativity determines which indexed file format to request, click here.

Data Source Name

This option displays the name of the data source being processed by the Relativity DBA.

User Name

This option displays the name of the group or user logged on to use the data source.

OK, Cancel, Apply

These three buttons appear in the lower-right corner in the Options dialog box.

· The OK button closes the Options dialog box and saves any changes that you have made on the page.

· The Cancel button closes the Options dialog box without saving any changes you have made to the settings.

· The Apply button saves all the changes you have made without closing the Options dialog box.


Determining Micro Focus COBOL Indexed File Formats

Relativity must know the physical access name information (that is, the table connection) for the COBOL file that contains the actual data. For Micro Focus COBOL, the format of the indexed file also must be ascertained. The methods used depend on whether you are opening an existing or creating a new Micro Focus COBOL indexed file.

Opening Existing Micro Focus COBOL Indexed Files

When opening existing Micro Focus COBOL indexed files, the process used by Relativity to determine which indexed file format to request is as follows:

· The Relativity DBMS first checks for the file format enclosed in square brackets and appended to the path name. The file format can be either a name or a number representing the file format. Valid values include: BTRIEVE, C-ISAM, DEFAULT, IDX4, IDX8, and LEVELII COBOL. The numeric representation can be used to specify a file format that is not represented by these names. (See the Micro Focus COBOL documentation concerning the IDXFORMAT directive for more information.)

· If the file format is not present in the path name, the Relativity DBMS uses the value specified in the Data File Format list on the System page of the Options dialog box in the Relativity DBA. The valid values are < none >, BTRIEVE, C-ISAM, LEVELII COBOL, IDX4, IDX8, and Default.

· If the value of the file format specified in the Data File Format list on the System page of the Options dialog box is < none >, the same file format as the data source’s catalog is used.

Note The ability to specify the file format using the Data File Format list is useful if the file format of the catalog is different from that of the data files. While the file format could be appended to the path name as described above in the first item, using the method described in the second point applies the same file format to all the path names in the data source.

Creating a New Micro Focus COBOL Indexed File

When Relativity receives a request to create new tables, a new Micro Focus COBOL indexed file is created to store the table's data. The file format of this Micro Focus COBOL indexed file is determined as follows:

· First, the Relativity DBMS checks the file format selected in the New File Format list on the Micro Focus Options page of the Relativity Setup dialog box. (For further details, see the index entry, "MF COBOL options page", in the Relativity DBMS Help file. The information presented there is part of the topics discussed under For All Users | Connecting to a Relativity Data Source in that online Help file.)

· If the file format selected in the method described above is < none >, Relativity determines the file format using the Data File Format list on the System page of the Options dialog box in the Relativity DBA.

· If, by using the Data File Format list, the value of the file format is determined to be < none >, the format of the new file will be the same file format as the catalog of the data source.


Using Relativity Help

See Also

The Relativity DBA comes with extensive online assistance and step-by-step instructions.

You can access Help while using Relativity in a number of ways. The method you use often depends on the type of information for which you are searching.

· Help Contents. In the Relativity DBA main window, from the Help menu, click Contents to open the Relativity DBA online HTML Help system. The left side of the Help window (the navigational pane) contains the Contents, Index, Search, and Favorites tabs. The right side of the Help window (the topic pane) displays the currently selected Help topic. Across the top of the Help window is a group of buttons that help you navigate through the Help contents and perform other operations, such as printing a topic in the Help file. (For more information, see Help Button Bar.)

-  To browse through topics grouped by subject: Click the Contents tab. From here, you can go directly to more specific information and a list of all the Help topics by double-clicking any closed book icon. Then select the topic of interest from the expanded list and click the topic. The Help window for that topic appears in the topic pane.

-  To see a list of alphabetized index entries (or keywords): Click the Index tab to find specific topics listed alphabetically (the online index is arranged just like a book index). Type an entry or the first few letters of the word you want to search for, or scroll through the list. Then select the topic and click the Display command button. The content of the Help topic opens in the Help window.

-  To search for words or phrases that may be contained in a Help topic: Click the Search tab. Follow the instructions on your screen to complete this task.

-  To create a list of preferred Help topics: Click the Favorites tab. Follow the instructions on your screen to complete this task. Note that, by default, the contents of this tab is empty until you select topics to populate it. The content of the Favorites tab is automatically saved between sessions.

· Context-sensitive Help. While you are working in Relativity, you also can press F1 to access the associated Help topic for currently selected menu commands, toolbar buttons, dialog box options, and other screen elements.

· Tool tips. When you pause with the pointer (without the mouse button pressed) over an item on a toolbar, a small pop-up window that includes a brief description is displayed.

· Help button in a dialog box. If available, click the Help button in the dialog box you are using. A Help topic explaining the dialog box appears.

You can exit Relativity online Help from the Help window by clicking the Close button on the title bar or double-clicking the Control Menu icon at the left end of the title bar. To exit a context-sensitive Help window, if necessary, press the Esc key on the keyboard.

From the Relativity DBA Help menu, you can also access additional online Help files, if appropriate:

· Click DBMS Help File for information on using the Relativity Data Manager.

· Click Server Admin Help File for information on using the Relativity Server Administrator.


Help Button Bar

See Also

Several Help buttons enable you to move around the Relativity Help topics easily. These Help buttons, located on the button bar on the top of the Relativity Help window, provide the following actions.

Button

Action

Hide/Show

Click the Hide button to close the navigational pane (on the left) of the Help window. Only the button bar and the topic pane are visible. To restore the navigational pane, click the Show button.

Note Be default, all three panes of the Help window are displayed initially.

Previous

Click the Previous button to display the previous topic in a series of related topics. When the first topic in the series is reached, the Previous button appears dimmed and is unavailable.

Next

Click the Next button to display the next topic in a series of related topics. When the last topic in the series is reached, the Next button appears dimmed and is unavailable.

Back

Click the Back button to display the contents of the last Help topic viewed. Each time the Back button is chosen, topics are displayed one at a time moving backwards through the order in which topics were previously viewed.

Forward

Click the Forward button to navigate forward to the most recent Help topic viewed. Each time the Forward button is chosen, topics are displayed one at a time moving forwards through the order in which topics were previously viewed.

Print

If you are in the topic pane, click the Print button to display the standard Windows Print dialog box, which allows you to print a copy of the current Help topic.

Shortcut: Right-click the mouse button over a Help window and click Print from the context-sensitive menu that appears.

Note If you are on the Contents tab, click this button to print pages, headings, and subtopics, or the entire table of contents. If you are on the Index or Search tab, this button opens the standard Windows Print dialog box to print the current topic.

Options

Click the down arrow on the Options button to display a menu list that includes the following:

· Hide Tabs. Closes the navigational pane.

· Back. Jumps to the previous topic.

· Forward. Jumps to the next topic in a previously-viewed sequence.

· Home. Jumps to the designated home page of the Help system.

· Stop. Stops downloading file information.

· Refresh. Updates the topic that is currently displayed in the topic pane.

· Print. If you are on the Contents tab, provides options to print pages, headings, and subtopics, or the entire table of contents. If you are on the Index or Search tab, it opens the standard Windows Print dialog box to print the current topic.

If you are in the topic pane, click this option to display the standard Windows Print dialog box, which allows you to print a copy of the current Help topic.

· Internet Options. Opens the Internet Explorer Internet Options dialog box, allowing quick access to accessibility and other features.

· Search Highlight On/Off. Turns on or off highlighting for search terms.

Glossary

If available, the Glossary button displays the list of glossary terms associated with Relativity Help. Click any underlined term in the list to display a pop-up definition of that glossary term.


Relativity Product Support

Liant Software Corporation offers a variety of services to help you with your questions. The Relativity online HTML Help files and the installation manuals, which are provided in PDF format during installation, are designed to address the majority of users' questions. If, however, these sources do not answer your question or problem, please check the following:

· README files included with the Relativity DBA media.

· Frequently Asked Questions (FAQs) in the Relativity DBA online Help file.

· Liant web site at http://www.liant.com.

Contact Liant Software Corporation to obtain more information about Liant's technical support and training programs, as well as other products, upgrades, and services.


Frequently Asked Questions (FAQs)

The following are frequently asked questions about the Relativity DBA:

1. How do I define the owner of a catalog for the first time?

Answer: Click Change Catalog Owner on the File menu to display the Change Catalog Owner dialog box. Select a group name from the Current Owner box. If the box is empty, a group must first be defined. See Defining Groups and Users.

2. How do I define security for the Relativity DBA?

Answer: Security is defined with the assignment of privileges to groups. Click Privileges on the Edit menu to open the Edit Privileges form. The privileges of a group are defined in the Edit Privileges form. See Defining Group Privileges.


Contact Liant Software Corporation

Use any of the following methods to contact Liant Software Corporation:

By | At
E-mail | sales@liant.com
Web site | http://www.liant.com
Telephone | US | (1) 512-343-1010 (1) 800-762-6265 (800-RM-COBOL)
Fax | US | (1) 512-343-9487
Mail | Liant Software Corporation 5914 West Courtyard Drive, Suite 100 Austin, Texas 78730 USA Registered in England No. 2355483 Registered Office: Pellipar House, 1st Floor, 9 Cloak Lane, London, EC4R 2RU VAT Registration No. GB 503 3514 90


Using the Catalog Window

Relativity Catalogs


Relativity Catalogs

See Also

The function of the Relativity catalog is similar to that of the "system catalog" in a relational database management system. It serves as a repository for information regarding the structure of relational tables as well as operational information required by runtime components of Relativity, such as the query optimizer. Additionally, the Relativity catalog contains complete information regarding the physical COBOL file structure (that is, the COBOL file definition, or FD information) and information produced by the database design process (Relativity Designer) that defines the association between COBOL files and data elements, and the relational tables and their constituent columns. Together, all of this information allows Relativity to present the COBOL data files through an ODBC interface of an ODBC-enabled application as a relational database of well-normalized tables substantially independent of the original COBOL file structure of the application.

The Catalog window, which is displayed in the Relativity DBA main window when a database (the mechanism that supports the Relativity catalog specified by the ODBC data source) is opened, displays a subset of the activities related to structuring the COBOL data so that it can be viewed in a relational table. Within the Catalog window, lists of tables and reports can be viewed and opened. User information also can be viewed and changed.


Working with the Catalog Window

See Also

The Relativity DBA displays the Catalog window when the data source associated with the Relativity catalog is opened. Within the Catalog window, definitions of tables and reports are opened. You also can view group and user definitions

The Catalog window contains a set of three tabs. To select a tab in the Catalog window, click on it.

Tab | Displays a list of
Tables | Table definitions in the catalog.
Users | Groups and users defined for the catalog.
Reports | Defined reports.


Tables Tab

See Also

Selecting the Tables tab in the Catalog window allows you to see a list of tables currently defined in the catalog.

The Tables tab contains the following options.

Option

Description

Connections

The Connections button displays the Edit Connections form for the selected table. If a table is not selected in the Table Name area list, the Connections button is disabled.

Note The Connections command on the Edit menu provides the same functionality as the Connections button when a table is selected. If you choose the Connections command from the Edit menu without first selecting a table on the Tables tab, however, the Edit Connections form lists all the tables currently defined in the catalog.

Table Name

The Table Name area displays a list of tables currently defined in the catalog. A table may be selected by clicking once on the table name. Double-clicking a table name in the list is equivalent to selecting it and then clicking the Connections button.

Users and Reports

When you are on the Tables tab, you may click either of these tabs to go to the Users or Reports view of the Catalog window.


Users Tab

See Also

Selecting the Users tab in the Catalog window allows you to see a list of groups and users currently defined for the catalog, and it provides access to a variety of options available for working on them.

The Users tab contains the following options.

Option

Description

New

The New button displays the Edit Users form for the definition of a new group or user for the catalog.

Note The Users command on the Edit menu provides the same functionality as the New button.

Delete

The Delete button removes the selected group or user from the catalog. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.

Privileges

The Privileges button displays the Edit Privileges form for the selected group. If a group is not selected, the Privileges button is disabled.

Note The Privileges command on the Edit menu provides the same functionality as the Privileges button.

Users

The Users area displays a list of the groups and users currently defined in the catalog for the Relativity database. A group or user may be selected by clicking once on the group or user name. Double-clicking a group name is equivalent to selecting it and clicking the Privileges button. Double-clicking a user name simply selects the user name.

Note A group or user may be deleted from the catalog by selecting the group or user name and pressing the Del (Delete) key. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.

Tables and Reports

When you are on the Users tab, you may click either of these tabs to go to the Tables or Reports view of the Catalog window.


Reports Tab

See Also

Selecting the Reports tab in the Catalog window allows you to see a list of the report categories and the descriptions of the currently defined reports for each category, and provides access to a variety of options available for working on them.

The Reports tab contains the following options.

Option

Description

Print

The Print button displays the Print Options dialog box for the printing of the report selected from the list of reports displayed in the Reports tab.

Notes

· If a report category is selected instead of a specific report description, a Select Report dialog box is displayed first to allow selection of the specific report definition file to be printed.

· The Connections, Privileges, and Users commands on the Reports menu provide the same functionality as the Print button.

Export

The Export button displays the Save Export File As dialog box for the output of a comma-separated value (CSV) file. After you complete the Save Export File As dialog box, the Print Options dialog box is displayed. You must also print the report in order to write the CSV file. See Exporting Data to a Comma-Separated File for more information on how to export data.

Note If a report category is selected instead of a specific report description, the Select Report dialog box is displayed after you complete the Save Export File As dialog box. After you select a specific report definition file, the Print Options dialog box is displayed.

Open

The Open button provides the facility to do either of the following:

· Create a new report

· Modify a selected report

If a report category has been selected prior to clicking the Open button, the Select Report dialog box is displayed for selecting an existing report or creating a new report. If a specific report description has been selected prior to clicking the Open button, that report will be opened in the Report Editor for editing its description. The edited description may be saved as a new report, using Save As, or saved as the new layout for the same report, using Save.

Note The Edit command on the Reports menu provides the same functionality as the Open button.

Reports

The Reports area displays a list of the report categories and the descriptions of the currently defined reports for each category. A report category or a report description may be selected by clicking once on the desired item in the list.

Note A specific report description may be deleted by selecting the report description and pressing the Del (Delete) key. A message box will be displayed requesting confirmation of the delete report request. If the user confirms the deletion, the report definition files for that report are deleted. The Del key has no effect if a report category is selected.

Tables and Users

When you are on the Reports tab, you may click either of these tabs to go to the Tables or Users view of the Catalog window.


Establishing Table Connections

Establishing Table Connections, An Overview


Establishing Table Connections, An Overview

See Also

The Relativity DBA is used by the data system administrator to maintain the linkages between tables and physical COBOL files.

Relativity must know the physical access name information (that is, the table connection) for the COBOL file that contains the actual data. The table connection consists of two important items:

1. The path name (that is, the physical COBOL file-name) of a COBOL data file. For more information about how Relativity determines which indexed file format to request when opening a Micro Focus COBOL data file, click here.

2. The table name by which SQL statements can reference the data in the file.

Note Should file labels be in effect, the table connection also includes the name of the file label associated with the table connection.

Relativity distinguishes between the name of a table definition and the actual SQL table name. The table definition is manipulated in the Table form and is normally called a table within the Relativity Designer. Thus, several physical files that share the same COBOL file definition can be described by one Relativity table definition. The table connection is what an ODBC-enabled application actually "perceives" as a relational table.

In the Relativity DBA, table connections are established in the Edit Connections form. The Edit Connections form enables you to design and test a single table definition as well as change large numbers of table connections at one time.

For more information and procedures on how to work with table connections, choose one of the following topics:

· Display table connections for one table definition

· Add a table connection

· Delete a table connection

· Edit selected table connections

· Add table connections with matching patterns

· Delete table connections with matching patterns

· Edit table connections with matching patterns

· Exit the Edit Connections form

· Print Connections report

► Related Topic Relativity supports a set of stored procedures, identified with the prefix, DBA-, only if the user is the owner or a database administrator of the Relativity catalog. The DBA stored procedures deal with table definitions, table connections, and file names. All of the stored procedures are ODBC driver-specific. For more information, see "Stored Procedures" under the For Advanced Users | Relativity-Specific topic in the Relativity DBMS Help file.


Display table connections for one table definition

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition from the list and do the following:

· Click the plus sign [+] to display the table name(s).

· Click the plus sign [+] preceding the table name(s) to display the path name(s) and file label(s), if file labels are in effect.

The table names, path names, and file labels, which form the existing table connections for the selected table definition, are displayed in the expanded list. To view an example, click here.

Note Alternatively, you can open the Edit Connections form by selecting the table definition of interest from the Tables tab in the Catalog window and then clicking Connections. When this method is used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Add a table connection

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition from the list.

3. Click Add Table Connection on the Edit Connections form or click Add Table from the Connection menu on the menu bar. The Add Table Connection dialog box is displayed.

4. In the Table Name box, type the new table name.

5. In the Path Name box, type or select the path name from the list.

6. In the File Label box, type or select the file label from the list.

Note This box appears only if a file label item has been added to the FD on which this table is based.

7. Next, do one of the following:

· To accept the table name, path name, and file label (if one exists) in the Add Table Connection dialog box, click Add Connection. A new table connection for the table definition is displayed in the Edit Connections form.

Note All the changes that have been made are displayed in bold text in the Edit Connections form until they are saved.

· If you do not want to accept the entries, click Cancel on the Add Table Connection dialog box to cancel all selections and close the dialog box.

8. On the Edit Connections form, click Save Changes.

9. Click Close to exit the Edit Connections form.

Note Alternatively, you can open the Edit Connections form by selecting the table definition of interest from the Tables tab in the Catalog window and then clicking Connections. When this method is used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Delete a table connection

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition and click the plus sign [+] preceding the table definition to expand the list and display the table name(s) and path name(s) of the existing table connection(s) for the selected table definition.

3. Select one or more table connections to be deleted. Tip

4. Click Delete Table Connection on the Edit Connections form to delete the table connection (that is, the table name and the path name).

Note If the table connection being deleted is the only connection using a particular file path name, a message box will be displayed asking if the file connection should be deleted. Click Yes if you do not expect to use that file path name for a table connection to be added later. Click No if you would like the file path name to be available in the list for the Path Name box in the Add Table Connection dialog box for later use in adding a table connection.

5. Repeat this procedure for each table connection you wish to delete.

6. On the Edit Connections for, click Save Changes.

7. Click Close to exit the Edit Connections form.

Note Alternatively, you can open the Edit Connections form by selecting the table definition of interest from the Tables tab in the Catalog window and then clicking Connections. When this method is used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Edit selected table connections

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all currently existing table definitions for the catalog (to view an example, click here). Note that each item in this hierarchical list is preceded by a plus sign [+].

2. Select a table definition for which the path name is to be edited.

If you would like to expand the list and view the table connection(s) associated with the selected table, click the plus sign [+] preceding the table definition to display the table name(s). Click the plus sign preceding the table name(s) to display the path name(s) and file label(s), if file labels are in effect.

3. Click Edit Table Connection on the Edit Connections form. The Edit Selected Table Connections dialog box is displayed.

4. In the Path Name Replace box, type the path name that is to be replaced, or enter a character pattern to match within the path names (for example, *.*).

5. In the Path Name With box, type the characters within the path name that are the replacement characters for the character pattern matched in the Path Name Replace box.

6. If file labels are in effect, follow these steps:

a. In the File Label Replace box, type the file label that is to be replaced, or enter a character pattern to match within the file labels.

b. In the File Label With box, type the characters within the file label that are the replacement characters for the characters matched in the File Label Replace box.

c. Select the AND option to make replacements if the contents of both the Path Name Replace and File Label Replace boxes match an individual table connection. Or, select the OR option to make replacements if the contents of either the Path Name Replace or File Label Replace boxes match an individual table connection.

Note A File Label area may appear in the Edit Selected Table Connections dialog box if a file label item has been added to the FD on which the table is based.

7. Next, do one of the following:

· To accept the entries made in the Edit Selected Table Connections dialog box, click Edit Connections.

Note All the changes that have been made are displayed in bold text in the Edit Connections form until they are saved.

· If you do not want to accept the entries, click Cancel on the Edit Selected Table Connections dialog box to cancel all selections and close the dialog box.

8. On the Edit Connections form, click Save Changes.

9. Click Close to exit the Edit Connections form.

Note Alternatively, you can open the Edit Connections form by selecting the table definition of interest from the Tables tab in the Catalog window and then clicking Connections. When this method is used, the Edit Connections form displays only the associated table connection(s) of the selected table definition. By default, the table name is selected in the expanded hierarchical list. To view an example, click here.


Add table connections with matching patterns

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here).

Note A printed report of existing table connections may be helpful in completing the steps of this procedure. See Reporting for information on how to print a report of table connections.

2. Select a table definition and then click the plus sign [+} to expand the list of tables to display the table name(s) of the table connection(s) associated with the selected table.

3. Click Global Add on the Edit Connections form. The Add Connections Matching Pattern dialog box is displayed.

4. In the Connection Selection Options area, select the Match Table Name check box to specify replacement of matching patterns in the table names of table connections.

In the text box, type a character or characters to specify the matching pattern for the table names of the table connections that are to be added in the Edit Connections form. Leave the Match Table Name text box empty to match all table names.

5. In the Connection Selection Options area, select the Match Path Name check box to specify replacement of matching patterns in the path names of table connections.

In the text box, type a character or characters to specify the matching pattern for the path names of the table connections that are to be added in the Edit Connections form. Leave the Match Path Name text box empty to match all path names.

6. If the Match Table Name check box is selected in Step 4, follow these steps:

a. In the Table Name Replace box, type the matching pattern for the table names that are to be replaced when a table name for the new table connection is generated. For example, typing the two characters ^^ will define a null match at the end of the table name.

b. In the Table Name With box, type the characters that are to replace the characters matching the pattern specified in the Table Name Replace box. For example, typing the characters Budget will define the pattern to be inserted at the end of the matched table names.

7. If the Match Path Name check box is selected in Step 5, follow these steps:

a. In the Path Name Replace box, type the matching pattern for the path name that is to be replaced when a path name for the new table connection is generated. For example, typing the one character ^ will define a null match at the beginning of the path name.

b. In the Path Name With box, type the characters that are to replace the characters matching the pattern specified in the Path Name Replace box. For example, typing the characters budget\ will define the pattern to be inserted at the beginning of the matched path names.

8. Next, do one of the following:

· To accept the selections and entries in the Add Connections Matching Pattern dialog box, click Add Connections.

A Status Report dialog box is displayed, which shows a record of the action just taken. For example, the report will contain a diagnostic if a duplicate (non-unique) or an invalid table name is generated for one of the new table connections. In such cases, the offending item will not be added. Click the Close toolbar button to dismiss this dialog. (Each Status Report dialog box also allows you to save and print this information.)

· If you do not want to accept the entries, click Cancel on the Add Connections Matching Pattern dialog box to cancel all selections and close the dialog box.

9. On the Edit Connections form, click Save Changes.

10. Click Close to exit the Edit Connections form.


Delete table connections with matching patterns

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here).

Note A printed report of existing table connections may be helpful in completing the steps of this procedure. See Reporting for information on how to print a report of table connections.

2. Select a table definition and then click the plus sign [+} to expand the list and display the table name(s) of the table connection(s) associated with the selected table.

3. Click Global Delete on the Edit Connections form. The Delete Connections Matching Pattern dialog box is displayed.

4. In the Connection Selection Options area, select the Match Table Name check box to specify matching on the table names of table connections.

In the text box, type a character or characters to specify the matching pattern for the table names of the table connections that are to be deleted.

5. In the Connection Selection Options area, select the Match Path Name check box to specify matching on the path names of table connections.

In the text box, type a character or characters to specify the matching pattern for the path names of the table connections that are to be deleted.

Note If Match Table Name and Match Path Name matching patterns are specified, table connections that match on either the table name or the path name are selected for deletion.

6. Next, do one of the following:

· To accept the entries in the Delete Connections Matching Pattern dialog box, click Delete Connections.

A Status Report dialog box is displayed, which shows a record of the action just taken. Click the Close toolbar button to dismiss this dialog. (Each Status Report dialog box also allows you to save and print this information.)

· If you do not want to accept the entries, click Cancel on the Delete Connections Matching Pattern dialog box to cancel all selections and close the dialog box.

7. On the Edit Connections form, click Save Changes.

8. Click Close to exit the Edit Connections form.


Edit table connections with matching patterns

1. On the Edit menu, click Connections to open the Edit Connections form.

The Edit Connections form lists all the currently existing table definitions for the catalog (to view an example, click here).

Note A printed report of existing table connections may be helpful in completing the steps of this procedure. See Reporting for information on how to print a report of table connections.

2. Select a table definition and then click the plus sign [+} to expand the list and display the table name(s) of the table connection(s) associated with the selected table.

3. Click Global Edit on the Edit Connections form. The Edit Connections Matching Pattern dialog box is displayed.

4. In the Connection Selection Options area, select the Match Table Name check box to specify matching on the table names of table connections.

In the text box, type a character or characters to specify the matching pattern for the table names of the table connections that are to be edited.

5. In the Connection Selection Options area, select the Match Path Name check box to specify matching on the path names of table connections.

In the text box, type a character or characters to specify the matching pattern for the path names of the table connections that are to be edited.

Note If Match Table Name and Match Path Name matching patterns are specified, table connections that match on either the table name or the path name are selected for potential editing. Only table connections having a path name matched by the Path Name Replace matching pattern operation will be edited.

6. In the Path Name Replace box, type the matching pattern to define the character string to be replaced in the path name.

7. In the Path Name With box, type the characters that are to replace the characters matching the pattern specified in the Path Name Replace box.

8. Next, do one of the following:

· To accept the entries in the Edit Connections Matching Pattern dialog box, click Edit Connections.

A Status Report dialog box is displayed, which shows a record of the action just taken. Click the Close toolbar button to dismiss this dialog. (Each Status Report dialog box also allows you to save and print this information.)

· If you do not want to accept the entries, click Cancel on the Edit Connections Matching Pattern dialog box to cancel all selections and close the dialog box.

9. On the Edit Connections form, click Save Changes.

10. Click Close to exit the Edit Connections form.


Exit the Edit Connections form

· On the Edit Connections form toolbar, click Close to exit the Edit Connections form.


Print Connections report

1. On the Edit menu, click Connections to open the Edit Connections form.

2. Click Print on the Edit Connections form toolbar to display the Print Options dialog box.

The name of the default Connections report is displayed.

3. Adjust the print options, if necessary.

4. Click Start to obtain a printed copy of the default Connections report.

Note The default Connections report is specified by an entry in the RELDBDBA.INI file. Upon initial product setup, the default Connections report is Connections by Table Name. See Configuring Report Capabilities and Reporting for more information on other reports that can be printed.


Pattern Matching

See Also

The adding, editing, and deleting of various strings used in Relativity is controlled by the matching of patterns. Pattern matching provides a tool for string comparison between a pattern and a table name, a path name, or a file label (if file labels are in effect). These are collectively called "searched strings" in the examples provided.

In the Relativity DBA, pattern matching is used to add, edit, or delete a table connection.

Relativity pattern matching uses the concept of “regular expressions.” Regular expressions extend the conventional search criteria.

To view a table that shows the list of character(s) in a pattern and what they match in the searched string, click here.


Regular Expression Syntax Used in Pattern Matching

See Also

A regular expression is a pattern of text that consists of ordinary characters, for example, letters a through z, and special characters.

Character(s) | Matches in searched string
pattern | Matches pattern anywhere in the name.
\ | Marks the next character as either a special character, a literal, a back reference, or an octal escape. For example, 'd' matches the character "d". ' \d' matches a digit character. The sequence '\\' matches "\" and "\(" matches "(".
. | Matches any single character.
^ | Matches the position at the beginning of the searched string.
$ | Matches the position at the end of the searched string.
? | Matches the preceding subexpression zero or one time. For example, "mast(er)?" matches "mast" or "master". Also, see below for additional uses of ‘?’.
* | Matches the preceding subexpression zero or more times. For example, zo* matches "z" and "zoo".
+ | Matches the preceding subexpression one or more times. For example, 'zo+' matches "zo" and "zoo", but not "z".
{n} | Matches exactly n times, where n is a nonnegative integer. For example, ‘o{2}’ matches the two o’s in “zoo”, but not the o in “zero”.
{n,} | Matches at least n times, where n is a nonnegative integer. For example, ‘o{2,}’ matches all the o’s in “zooooom” but not the o in “zero”.
{n,m} | Matches at least n times and at most m times, where n and m are nonnegative integers (n <= m). For example, ‘o{2,4}’ matches the first four o’s in “zooooom”, but not the o in “zero”.
? | When ‘?’ immediately follows any of the qualifiers (*, +, ?, {n}, {n,}, {n,m}), the matching pattern is non-greedy. While the default pattern matching is to match as much of the searched string as possible, a non-greedy pattern matches as little of the searched string as possible. For example, ‘o+?’ matches a single o in “zooom”, while ‘o+’ matches all the o’s.
(pattern) | Matches pattern as a subexpression and remembers the match. The remembered match can be used in a following back reference (described below) or in the replacement string of a search and replace operation. To match the parentheses characters ( and ), use ‘\(‘ and ‘\)’.
x|y | Matches either x or y. For example, ‘MAST(ER|FILE)’ matches either “MASTER” or “MASTFILE”.
[charlist] | Matches any single character in charlist. For example, ‘[aeiou]’ matches the e in “Relativity”.
[^charlist] | Matches any single character not in charlist. For example, ‘[^aeiou]’ matches the R in “Relativity”.
[a-z] | Matches any single character in the specified character range. For example, ‘[a-z]’ matches any lowercase alphabetic character in the range “a” through “z” inclusive.
[^m-z] | Matches any single character not in the specified character range. For example, ‘[^m-z]’ matches any character except those in the range “m” through “z” inclusive.
\b | Matches a word boundary (the position between a word and a space). For example, “le\b” matches the “le” of “file” in the searched string “lengthy file name”, not the “le” in “lengthy”.
\b | Matches a non-word boundary. For example, “le\B” matches the “le” of “lengthy” in the searched string “lengthy file name”, not the “le” in “file”.
\d | Matches a digit character (equivalent to [0-9]).
\D | Matches a non-digit character (equivalent to [^0-9]).
\s | Matches a white space character.
\S | Matches a nonwhite space character.
\w | Matches any word character including underscore (equivalent to [A-Za-z0-9_]).
\W | Matches any non-word character (equivalent to [^A-Za-z0-9_]).
\num | Matches a back reference to a remembered match, where num is a positive integer. For example, ‘(.)\1’ matches two consecutive identical characters.


Pattern Matching Examples

For more information on pattern matching, choose one of the following examples:

· Pattern match anywhere

· Pattern match at beginning

· Pattern match at ending

· Pattern match entire searched string

· Match the beginning of a string

· Match the ending of a string

· Pattern match any single character

· Pattern match zero or more characters

· Pattern match any single digit

· Pattern match special character

· Pattern match any character in a range

· Pattern match any character outside a range

· Use back references in replacement strings


Pattern match anywhere

The pattern of character-string matches with a similar character-string found anywhere in searched string. The following examples illustrate the matching of a pattern located anywhere in the searched string.

Pattern | Searched String | Result
SALES | BSALES | Match
SALES | SALESFIL | Match
SALES | JSALESFL | Match
SALES | SALEFL | No match
SALES | salesfil | No match


Pattern match at beginning

The pattern of ^character-string matches with a similar character-string found at the beginning of the searched string. The following examples illustrate the matching of a pattern located at the beginning of the searched string.

Pattern | Searched String | Result
^SALES | BSALES | No match
^SALES | SALESFIL | Match
^SALES | JSALESFL | No match
^sales | SALESFL | No match


Pattern match at ending

The pattern of character-string$ matches with a similar character-string found at the end of the searched string. The following examples illustrate the matching of a pattern located at the end of the searched string.

Pattern | Searched String | Result
SALES$ | BSALES | Match
SALES$ | SALESFIL | No match
SALESR | JSALESFL | No match
Sales$ | PRSALES | No match


Pattern match entire searched string

The pattern of ^character-string$ matches with a similar character-string representing the entire searched string. The following examples illustrate the matching of a pattern equivalent to the entire searched string.

Pattern | Searched String | Result
^SALES$ | BSALES | No match
^SALES$ | SALESFIL | No match
^SALES$ | JSALESFL | No match
^SALES$ | SALES | Match
^sales$ | SALES | No match
^sales$ | sales | Match


Match the beginning of a string

The pattern of ^ represents a match at the beginning of the searched string. The following examples illustrate a match at the beginning of the searched string, allowing the insertion of the replacement string at the beginning of the searched string.

Pattern | Searched String | Replace with resort\
^ | salesfil | resort\salesfil
^ | orderfil | resort\orderfil
^ | cust2fil | resort\custfil
^ | CUST2FIL | resort\CUST2FIL


Match the ending of a string

The pattern of $ represents a match at the end of the searched string. The following examples illustrate a match at the end of the searched string, allowing the insertion of the replacement string at the end of the searched string.

Pattern | Searched String | Replace with .INX
$ | SALESFIL | SALESFIL.INX
$ | ORDERFIL | ORDERFIL.INX
$ | CUST2FIL | CUST2FIL.INX
$ | salesfil | salesfil.INX


Pattern match any single character

The pattern of . matches with any single character in the searched string. The following examples illustrate the matching a single character in the searched string.

Pattern | Searched String | Result
CUST.FIL | CUST1FIL | Match
CUST.FIL | CUST2FIL | Match
CUST.FIL | CUST45FIL | No match
PROD.FIL | PROD1FIL | Match
PROD.FIL | PROD2FIL | Match
PROD.FIL | PRODAAFIL | No match
Prod.fil | PROD3FIL | No match


Pattern match zero or more characters

Use the * character after the . character to represent a match with zero to more characters in the searched string. The following examples illustrate the matching of patterns containing the asterisk (*) character.

Pattern | Searched String | Result
\budget\.* | \budget\salesfil | Match
\budget\.* | \designer\orderfil | No match
\designer\.* | \designer\cust2fil | Match
\designer\.* | \budget\cust2fil.dat | No match
\.*\orderfil | \budget\orderfil | Match
\.*\orderfil | \designer\prod2fil | No match
\.*\prod2fil | \prod2fil | No match
\budget\.* | \designer\salesfil | No match


Pattern match any single digit

The pattern of \d represents a match with any digit, 0 through 9, within the searched string. The following examples illustrate the matching of patterns containing \d.

Pattern | Searched String | Result
CUST\dFIL | CUST1FIL | Match
CUST\dFIL | CUST2FIL | Match
CUST\dFIL | CUSTAFIL | No match
CUSTFIL\d | CUSTFIL3 | Match
CUSTFIL\d | CUST1FIL | No match
Custfil\d | CUSTFIL9 | No match


Pattern match special character

When a special character, such as ? * or [ , is preceded by a backslash (\), a match occurs if that special character is present in the indicated position of the searched string. The following examples illustrate the matching of patterns containing one of the special characters.

Pattern | Searched String | Result
CUST\*FIL | CUST*FIL | Match
CUST\*FIL | CUST2FIL | No match
Cust\*fil | CUST*FIL | No match


Pattern match any character in a range

The following examples illustrate the matching of patterns containing a range of characters. The pattern representation of a range consists of two characters separated by a hyphen and enclosed in brackets. For example, [1-5] indicates a range from '1' through '5'. The presence of any one of the characters in the range results in a match.

Pattern | Searched String | Result
CUST[1-5]FIL | CUST1FIL | Match
CUST[1-5]FIL | CUST4FIL | Match
CUST[1-5]FIL | CUST6FIL | No match
CUST1FL[A-Z] | CUST1FLB | Match
CUST1FL[A-Z] | CUST1FL2 | No match
CUST1FL[A-Z] | CUST1FLw | No match
CUST1FL[a-z] | CUST1FL4 | No match
CUST1FL[a-d0-9] | CUST1FL4 | Match
CUST1FL[A-D0-9] | CUST1FLL | No match
cust1fl[A-D0-9] | CUST1FLa | No match


Pattern match any character outside a range

The following examples illustrate the matching of patterns outside a range of characters. The presence of the caret ( ^ ) character after the left bracket and before the range pattern indicates that a match occurs when a character is not within the specified range. For example, [^4-9] indicates any character outside the range of '4' through '9'.

Pattern | Searched String | Result
CUST[^4-9]FIL | CUST1FIL | Match
CUST[^4-9]FIL | CUST2FIL | Match
CUST[^4-9]FIL | CUST6FIL | No match
CUS1FL[^A-Z] | CUST1FLA | No match
CUST1FL[^a-z] | cust1fla | No match
CUS1FL[^A-Z] | CUST1FL4 | Match
CUST1FL[^A-Z] | CUST1FLX | No match
CUST1FL[^a-z] | CUST1FLB | Match
CUST1FL[^a-z] | CUST1FLc | No match
CUST1FL[^a-z] | CUST1FL3 | Match
CUST1FL[^4-9A-D] | CUST1FL4 | No match
CUST1FL[^4-9A-D] | CUST1FLW | Match
CUST1FL[^4-9A-D] | CUST1FLg | Match
cust1fl[^4-8a-e] | CUST1FLA | No match


Use back references in replacement strings

The following examples illustrate the use of back references in a replacement string. Use the parentheses characters within the searched string to cause the subexpressions contained within the parentheses to be remembered. Subexpressions are numbered from left to right, starting with 1. Therefore, to refer to the leftmost remembered subexpression, use \1 in the replacement string, \2 for the second leftmost, and so forth.

Pattern | Searched String | Replacement | Result
(.+)(\d)(\.dat|\.DAT) | custfil5.dat | \1new\2\3 | Custfilenew5.dat
(First|1st)(.+)(Last|Final) | FirstThenLast | \3\2\1 | LastThenFirst
(First|1st)(.+)(Last|Final) | 1stThenFinal | \3\2\1 | FinalThen1st


Defining Security for Relativity Catalogs

Providing Data Security

Catalog Ownership

Database Administration

Defining Groups and Users

Defining Catalog Ownership

Defining Group Privileges


Providing Data Security

Relativity provides a security facility to protect data in the tables against unauthorized disclosure, alteration, or destruction.

For security purposes, a unit of data (or data object) ranges from an entire database to a specific column within a table of the database. A given user has different access privileges on different units of data. Access privileges (or privileges, for short) are the mechanism that provides data security for a Relativity database.

To provide data security:

1. Define groups and users. The first step in effective database administration is to design and establish the group structure; that is, the users and groups of users who are authorized access to the database. Groups and users are the basis for establishing security for your database. An individual user is identified by a user name. A group of users is identified by a group name. Each user name and group name within a Relativity catalog must be unique.

2. Define catalog ownership. In Relativity, a data source is the connection known to ODBC between a Windows workstation and a Relativity catalog. Before a Relativity data source associated with a catalog can be opened, a user name must be entered with a password via the Logon dialog box to identify the user requesting access to the database. If the user name and password are valid, the user may access the database, but only with the privileges assigned to the group to which that user belongs. This procedure prevents unauthorized persons from accessing the database or from accessing portions of the database for which they do not have access privileges. Passwords are assigned to groups and users when defining groups and users with Relativity. Assigned passwords are stored in an encrypted form in the catalog.

3. Define group privileges. Relativity allows you to establish specific permissions for groups and users. This is accomplished by granting privileges to groups, which is similar to the GRANT/REVOKE facilities in other relational database management systems.

In a Relativity catalog, privileges are assigned to a group of users. All users within a group inherit the privileges of the group. Not all groups associated with the Relativity database need access to all the data in the database. A group of users is given (that is, granted) privileges only to that data that is necessary for the group to carry out its work.

The Relativity software contains a group called <PUBLIC>. When a privilege is granted to the <PUBLIC> group, that privilege is granted to all users of the database. Thus, a privilege can be assigned to all users by granting that privilege to the <PUBLIC> group.

When granting privileges, it may be helpful to think of them in terms of a hierarchy, with the group that is the owner of the catalog having the highest level permissions, the group that administers the catalog having the next level of permissions, and a user group having the lowest level permissions (for example, the ability to access only one or more tables or columns).


Catalog Ownership

See Also

A Relativity catalog has an ownership property that enables one group of users to be specified as the owner of the catalog. An owner of a catalog is automatically granted all privileges for the database and can perform every operation that supports a Relativity database. There is no security for a Relativity database until an owner is assigned to the catalog. Assigning an owner establishes security and, initially, the owner of a catalog is the only group that can do anything with the Relativity database.

Duties of the owner of the Relativity catalog include:

1. Creating groups of users for this database.

2. Granting the privilege of executing the Relativity DBA software to a group (or groups).

3. Granting other privileges to the group executing the Relativity DBA.

4. Granting another group the authority to grant specified privileges to other groups.

5. Revoking privileges from a group.

In addition to these duties, once an owner is assigned, only users who are members of the owner group may open the data source associated with the catalog using the Relativity Designer. Thus, the owner is equivalent to the catalog developer and has all development responsibilities supported only by the Designer.


Database Administration

See Also

When starting the Relativity DBA, a group name or user name is entered with a password to identify the user requesting access to the Relativity DBA. When the user is not an owner of the catalog, the user's group must have been assigned the Use Administrator privilege.

The administrative privileges, usually restricted to the catalog developer and to the database administrator, deal with controlling access by creating groups and users and granting database access privileges. (Database access privileges deal with the Table and Column privileges granted to various groups and users depending on their needs.)

Major duties for managing a database include:

1. Executing the Relativity DBA software.

2. Creating groups of users for this database (if granted, the Create Group privilege).

3. Creating user IDs and passwords for members of a group (if granted, the Create Users privilege).

4. Granting the privilege of executing the Relativity DBA software to a group (or groups).

5. Granting another group the authority to grant specified privileges to other groups.

6. Granting the privileges of accessing specified tables in the Relativity database to a group (or groups).

7. Granting the privileges of accessing specified columns within tables of the Relativity database to a group (or groups).

8. Revoking privileges from a group.

9. Setting an expiration date for groups and users, as needed.

10. Deleting groups and users, as needed.

For more information on the types of privileges that can be granted to a group of users, click one of the following topics:

· Administrator Privileges

· Create Users Privilege

· Create Tables Privilege

· Table Privileges

· Column Privileges


Administrator Privileges

The four Administrator privileges available for a group all pertain to database administration operations:

1. Use Administrator. Enabling the Use Administrator privilege allows the group granted the privilege to use the Relativity DBA software on the specified catalog.

2. Create Groups. Enabling the Create Groups privilege permits the group granted the privilege to add new database groups to the catalog.

3. Date Constants. Enabling the Date Constants privilege allows the group granted the privilege to change the existing (default) values for the date constants of the database in the catalog. These date constants include 'Days' Base Date, 'YYYY' Base Year, 'YY' Base Year, 'YY' Century Cutoff, and configurable date formats.

4. Reports. Enabling the Reports privilege permits the group granted the privilege to create and use reports for information in the catalog.

Note The Administrator privileges cannot be assigned to the <PUBLIC> group.

For information on enabling Administrator privileges for a group, click here.


Create Users Privilege

Enabling the Create Users privilege allows the group granted the privilege to add new users to a specific database group in the catalog and to delete existing users from a specific group.

Because the Create Users privilege is granted only for specific groups, it is possible to have specialized administrators of the database. For example, there could be a SalesAdmin group that is granted the privilege to create new users only for the Sales group. The director of sales would then be made a member of the SalesAdmin group so that the director could add users to or delete users from the Sales group without having to request such changes from the main administrator.

Note The Create Users privilege cannot be assigned to the <PUBLIC> group.

For information on enabling the Create Users privilege for a group, click here.


Create Tables Privilege

Enabling the Create Tables privilege allows the group granted the privilege to add, edit, and delete table connections between the Relativity table definitions and the physical COBOL data files.

Note The Create Tables privilege cannot be assigned to the <PUBLIC> group.

For information on enabling the Create Tables privilege for a group, click here.


Table Privileges

In a Relativity database, a given group may have access rights or privileges to a table. In order to perform an SQL operation, such as SELECT, INSERT, UPDATE, or DELETE on a table, the user must belong to a group granted the corresponding privilege for the columns affected by the operation. Table privileges apply to all columns of a table. If the administrator wishes to grant access only to specific columns of a table, then Column privileges must be granted instead of Table privileges.

The following Table privileges are available for a group:

1. Table All. The Table All privilege enables all the Table privileges (Table Select, Table Insert, Table Update, Table References, and Table Delete) on all columns of a specified table. To read more about the special characteristics of the Table All privilege, click here.

2. Table Select. Enabling the Table Select privilege allows the group granted the privilege to access all of the columns of a specified table, including any columns added to that table later.

3. Table Insert. Enabling the Table Insert privilege permits the group granted the privilege to insert into all columns of a specified table, including any columns added to that table later.

4. Table Update. Enabling the Table Update privilege allows the group granted the privilege to update all columns of a specified table, including any columns added to that table later.

5. Table References. Enabling the Table References privilege allows the group granted the privilege to reference all columns of a specified table in integrity constraints, including all columns added to that table later. Integrity constraints may be specified in CREATE TABLE statements and could be used in a way that would obtain information about columns in another table for which a user would not otherwise have privileges.

6. Table Delete. Enabling the Table Delete privilege permits the group granted the privilege to delete a row from a specified table. Since deleting a row of a relational table is equivalent to deleting all columns of that row, this privilege exists only as a Table privilege; there is no corresponding Column Delete privilege.

Note Options selected on the System page in the Options dialog box affect the behavior of the Edit Privileges form.

For information on enabling the Table privileges for a group, click here.


Column Privileges

In a Relativity database, a given group may have access rights or privileges to a column within a table. In order to perform an SQL operation, such as SELECT, INSERT, or UPDATE on a column within a table, the user must belong to a group granted the corresponding privilege for the columns affected by the operation.

The following Column privileges are available for a group:

1. Column All. The Column All privilege enables all the Column privileges (Column Select, Column Insert, Column Update, and Column References) on specified columns of a specified table. To read more about the special characteristics of the Column All privilege, click here.

2. Column Select. Enabling the Column Select privilege permits the group granted the privilege to access specified columns of a specified table.

3. Column Insert. Enabling the Column Insert privilege allows the group granted the privilege to insert into specified columns of a specified table.

4. Column Update. Enabling the Column Update privilege permits the group granted the privilege to update specified columns of a specified table.

5. Column References. Enabling the Column References privilege allows the group granted the privilege to reference specified columns of a specified table in integrity constraints. Integrity constraints may be specified in CREATE TABLE statements and could be used in a way that would obtain information about columns in another table for which a user would not otherwise have privileges.

Notes

· There is no Column Delete privilege because the SQL DELETE statement deletes a row of a table, thus requiring delete privilege on all columns. You must use the Table Delete privilege described in Table Privileges to grant the privilege to delete rows of a table.

· Options selected on the System page in the Options dialog box affect the behavior of the Edit Privileges form.

For information on enabling the Column privileges for a group, click here.


Defining Groups and Users

See Also

Groups and users are assigned to a Relativity database with the appropriate actions in the Edit Users form.

To open the Edit Users form in the Relativity DBA window, do one of the following:

· On the Edit menu, click Users.

· From the Users tab in the Catalog window, click New.

For detailed information on defining groups and users, choose from the following topics:

· Add a database group to the catalog

· Add a user to a group

· Delete a database group from the catalog

· Delete a user from a group

· Change a group password

· Change a user password

· Reset a group password

· Reset a user password

· Print Users report


Add a database group to the catalog

1. On the Edit menu, click Users to open the Edit Users form.

You can also select a group from the Users tab in the Catalog window and then click New to open the Edit Users form for that group.

2. Click Add Group on the Edit Users form toolbar. The Add Database Group dialog box is displayed.

3. In the New Group Name box, type the name of the database group to be added to the catalog.

4. In the Password box, type the password for the new group. An asterisk (*) character is displayed for each character entered.

5. In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.

Note Both passwords entered in the Add Database Group dialog box must contain the same characters before the password is accepted for the group.

6. If needed, select the Use Expiration check box. By default, the current date is already entered in the Date box. Type a different expiration date or click the Calendar button to select a date.

7. Click OK to accept the new group name in the Add Database Group dialog box.


Add a user to a group

1. On the Edit menu, click Users to open the Edit Users form.

You can also select a user name from the Users tab in the Catalog window and then click New to open the Edit Users form for that user name.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed in the User Name column.

3. Click Add User on the Edit Users form toolbar. The Add Database User dialog box is displayed.

4. In the New User Name box, type the name of the user to be added to the selected group.

5. In the Password box, type the password for the new user. An asterisk (*) character is displayed for each character entered.

6. In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.

Note Both passwords entered in the Add Database User dialog box must be the same in order for the password to be accepted for the user.

7. If needed, select the Use Expiration check box. By default, the current date is already entered in the Date box. Type a different expiration date or click the Calendar button to select a date.

8. Click OK to accept the new user name into the selected group.


Delete a database group from the catalog

1. On the Edit menu, click Users to open the Edit Users form.

2. Select the database group in the Group Name column of the Edit Users form to be deleted from the current catalog.

3. Click Delete Group on the Edit Users form toolbar.

4. Click OK as the response to an inquiry message about deleting the entire group.

Note You may also delete a database group by selecting the group name on the Users tab in the Catalog window and then clicking the Delete button. A message box will be displayed requesting confirmation of the delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.


Delete a user from a group

1. On the Edit menu, click Users to open the Edit Users form.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed in the User Name column.

3. Select the user in the User Name column of the Edit Users form to be deleted from the selected group.

4. Click Delete User on the Edit Users form toolbar.

Note You may also delete a user from a group by selecting the user name on the Users tab in the Catalog window and then clicking the Delete button. If a user name has been selected, the user name is immediately deleted from the catalog without any confirmation message.


Change a group password

1. On the Edit menu, click Users to open the Edit Users form.

2. Select the group in the Group Name column of the Edit Users form whose password is to be changed.

3. Click Edit Group Password on the Edit Users form toolbar.

The Change Password dialog box is displayed with the name of the selected group in the User Name box.

4. In the New Password box, type the new password for the group. An asterisk (*) character is displayed for each character entered.

5. In the Verify Password box, type the new password for a second time to make sure that the password was typed correctly in the New Password box. An asterisk (*) character is displayed for each character entered.

6. Click OK to accept the new password for the specified group.

Note You can also reset a group password by not entering a password in either the New Password or Verify Password boxes, and then clicking OK in the Change Password dialog box. Leaving these boxes empty is equivalent to using the Reset Group Password button in the Edit Users form.


Change a user password

1. On the Edit menu, click Users to open the Edit Users form.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed in the User Name column of the Edit Users form.

3. Select one or more users in the User Name column of the Edit Users form whose password is to be changed.

4. Click Edit User Password on the Edit Users form toolbar.

The Change Password dialog box is displayed with the User Name box containing the name of the first selected user of the group.

5. In the New Password box, type the new password for the user specified in the User Name box. An asterisk (*) character is displayed for each character entered.

6. In the Verify Password box, type the new password for a second time to make sure that the password was typed correctly in the New Password box. An asterisk (*) character is displayed for each character entered.

7. Click OK to accept the new password and the verify password for the user specified in the User Name box.

Notes

· If more than one user was selected in step 3, the Change Password dialog box is displayed for the next selected user of the group. Repeat steps 5 through 7 for each of the selected users.

· You can also reset a user password by not entering a password in either the New Password or Verify Password boxes, and then clicking OK in the Change Password dialog box. Leaving these boxes empty is equivalent to using the Reset User Password button in the Edit Users form.


Reset a group password

1. On the Edit menu, click Users to open the Edit Users form.

2. Select the group in the Group Name column of the Edit Users form whose password is to be reset.

3. Click Reset Group Password on the Edit Users form toolbar.

Resetting a password for the selected group results in the group not having a password. The group can be assigned a new password by using the Change Password dialog box.

Note You can also reset a group password by using the Edit Group Password button. In that procedure, click OK in the Change Password dialog box without entering a password in either the New Password or Verify Password boxes.


Reset a user password

1. On the Edit menu, click Users to open the Edit Users form.

2. Select a group in the Group Name column of the Edit Users form. The existing users for that group are displayed.

3. Select one or more users in the User Name column of the Edit Users form whose password is to be reset.

4. Click Reset User Password on the Edit Users form toolbar.

Resetting a password for the selected users results in the users not having a password. The users can be assigned a new password by using the Change Password dialog box.

Note You can also reset a user password by using the Edit User Password button. In that procedure, click OK in the Change Password dialog box without entering a password in either the New Password or Verify Password boxes.


Print Users report

1. On the Edit menu, click Users to open the Edit Users form.

2. Click Print on the Edit Users form toolbar to display the Print Options dialog box.

The name of the default Users report is displayed along the top portion of the dialog box.

Note The default Users report is specified by an entry in the RELDBDBA.INI file. Upon initial product setup, the default Users report is All Users by User Name.

3. Adjust the print options, if necessary.

4. Click Start to obtain a copy of the default Users report.

Note See Configuring Report Capabilities and Reporting for more information on other reports that can be printed.


Defining Catalog Ownership

See Also

If a catalog is unowned, then a group is specified as the catalog owner by making the appropriate entries in the Change Catalog Owner dialog box.

If a catalog has an owner and the owner group (or a user of the owner group) is specified in the Logon dialog box, then the group owning the catalog is changed by making the appropriate entries in the Change Catalog Owner dialog box.

For detailed information about defining catalog ownership, see the following topics:

· Define owner of catalog

· Transfer ownership of catalog


Define owner of catalog

1. On the File menu of the Relativity DBA window, click Change Catalog Owner.

The Change Catalog Owner dialog box is displayed.

Note This command is available only if there is no owner or if logged on as the owner (or as a user of the owner group).

2. In the New Owner Name box, which contains the names of database groups associated with the current catalog, select an owner name from the list.

Note If this list is empty, you must first define one or more groups.

3. In the Password box, type the password for the group specified in the New Owner Name box. An asterisk (*) character is displayed for each character entered.

4. Click OK to accept the selected group as the new owner name and the password for the current catalog.

Ownership and a password have been established for the catalog for the first time. The owner group has all privileges for the Relativity database and all other groups have no privileges until the owner enables privileges for those groups.

Note After defining an owner of the catalog, it is recommended that you close the data source and then reopen it, logging in as a member of the owner group.


Transfer ownership of catalog

1. On the File menu, click Change Catalog Owner.

The Change Catalog Owner dialog box is displayed.

Note This command is available only if there is no owner or if logged on as the owner (or as a user of the owner group).

2. In the New Owner Name box, which contains the names of the database groups associated with the current catalog, select the name of the new owner from the list.

Note If the owner is not defined, you must define an owner of the catalog.

3. In the Password box, type the password for the group specified in the New Owner Name box. An asterisk (*) character is displayed for each character entered.

The entry in the Password box is compared with the password of the new owner group. The two passwords must be equal in order for the new owner to be accepted.

4. Click OK to accept the selected group as the new owner of the catalog.

Note After transferring ownership of the catalog, it is recommended that you close the data source. If you wish to continue working with the data source, you can then reopen the data source, logging in as whatever user is appropriate for the actions you plan to perform.


Defining Group Privileges

See Also

Groups are assigned privileges to a Relativity database with the appropriate actions in the Edit Privileges form. The granting of a privilege to a group of users provides a mechanism to protect data in a database. Instead of having access to all the data in a database, a granted privilege restricts the user's access only to the data needed to carry out the user's work.

When assigning privileges, there are three choices for each pairing of a group and a privilege, table, or column:

· Not Granted. The group does not have the selected privilege.

· Granted. The group has the selected privilege, but cannot grant it to other groups.

· With Grant. The group has the selected privilege and can grant that privilege to other groups.

To open the Edit Privileges form in the Relativity DBA window, do one of the following:

· On the Edit menu, click Privileges.

· In the Catalog window, click the Users tab, then click Privileges.

After all the privileges have been defined in the Edit Privileges form, click Save Changes on the Edit Privileges form toolbar to accept all privileges for the database groups of the current catalog.

For detailed information on enabling privileges, choose from the following topics:

· Define privilege structure within a database

· Enable Administrator Privileges

· Enable the Create Users Privilege

· Enable the Create Tables Privilege

· Enable Table Privileges

· Enable Column Privileges

· Print Privileges report


Define privilege structure within a database

The following actions define the structure of privileges for groups within a Relativity database:

1. Define groups and users of the database.

2. Define a group as the owner of the catalog. All privileges to the database are automatically given to the group having ownership of the catalog.

3. Close the data source.

4. Open the data source. In the Logon dialog box, type a user name that is a member of the group defined in step 2 as the owner of the catalog.

5. Enable the following privileges to the appropriate group or groups:

· Administrator privileges

· Create Users privilege

· Create Tables privilege

· Table privileges

· Column privileges

6. Assign appropriate privileges to the <PUBLIC> group. Privileges assigned to the <PUBLIC> group become privileges assigned to all users of the database.

Note Privileges are assigned from a grantor group. The grantor group is determined based on the log on information used prior to granting privileges. It may, therefore, be necessary during steps 5 and 6 to close and reopen the data source, logging in as a member of the desired grantor group.


Enable Administrator Privileges

1. On the Edit menu, click Privileges to open the Edit Privileges form.

Alternatively, select a group on the Users tab in the Catalog window and click the Privileges button.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group).

3. Select the Administrator privilege from the Privilege list.

The Create Groups, Date Constants, Reports, and Use Administrator privileges are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group has no Administrator privileges, so the Administrator privileges will be displayed in the Not Granted column. To view an example, click here.

4. Select one or more privileges in the Not Granted column that you wish to grant to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the privilege(s) to the Granted column.

6. To enable the grantee group to grant Administrator privileges to other groups, select one or more privileges in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the privilege(s) to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to a group.

· This button to the left of the With Grant column moves selected privilege(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected privilege(s) in the Granted column to the Not Granted column.


Enable the Create Users Privilege

1. On the Edit menu, click Privileges to open the Edit Privileges form.

Alternatively, select a group on the Users tab in the Catalog window and click the Privileges button.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group).

3. Select the Create Users privilege from the Privilege list.

The database groups defined for the current catalog, but not including the owner or currently logged in group, are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group does not have the Create Users privilege for any other group, so all group names will be displayed in the Not Granted column. To view an example, click here.

4. Select one or more groups in the Not Granted column for which the privilege to create users is to be granted to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the selected groups to the Granted column.

6. To enable the grantee group to grant the Create Users privilege to other groups, select one or more groups in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the selected groups to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected group(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected group(s) in the Granted column to the Not Granted column.


Enable the Create Tables Privilege

1. On the Edit menu, click Privileges to open the Edit Privileges form.

Alternatively, select a group on the Users tab in the Catalog window and click the Privileges button.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group).

3. Select the Create Tables privilege from the Privilege list.

The table definition names for the current database are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group does not have the ability to create tables, so all table definition names will be displayed in the Not Granted column. To view an example, click here.

4. Select one or more table definition names in the Not Granted column for which the privilege to create tables is to be granted to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the selected table definition names to the Granted column.

6. To enable the grantee group to grant the Create Tables privilege to other groups, select one or more table definition names in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the selected table definition names to the With Grant column.

Note Use the Move Left buttons to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected table definition name(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected table definition name(s) in the Granted column to the Not Granted column.


Enable Table Privileges

1. On the Edit menu, click Privileges to open the Edit Privileges form.

Alternatively, select a group on the Users tab in the Catalog window and click the Privileges button.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group).

3. Select a Table privilege (one that begins with the word "Table") from the Privilege list. (To read about the special characteristics of the Table All privilege, click here.)

The table names for the current database are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group has no Table privileges, so all table names will be displayed in the Not Granted column. To view an example, click here.

Note The setting of the Independent 'SELECT' Privileges check box on the System page in the Options dialog box affects the behavior of assigning and removing Table privileges.

4. Select one or more table names in the Not Granted column for which the selected Table privilege is to be granted to the grantee group.

5. Click the Move Right button at the right of the Not Granted column to move the selected table names to the Granted column.

The group has been given the selected Table privilege on all columns of the tables associated with the table names appearing in the Granted column of the Edit Privileges form.

The group does not have access rights to the tables associated with the table names appearing in the Not Granted column of the Edit Privileges form.

6. To enable the grantee group to grant the selected Table privilege to other groups, select one or more table names in the Granted column.

7. Click the Move Right button at the right of the Granted column to move the selected table names to the With Grant column.

Note Use the Move Left button(s) to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected table name(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected table name(s) in the Granted column to the Not Granted column.


Enable Column Privileges

1. On the Edit menu, click Privileges to open the Edit Privileges form.

Alternatively, select a group on the Users tab in the Catalog window and click the Privileges button.

2. Select a group from the Group list for which privileges are to be assigned (that is, the grantee group).

3. Select a Column privilege (one that begins with the word "Column") from the Privilege list. The Table list is displayed on the form. (To read about the special characteristics of the Column All privilege, click here.)

Note The setting of the Independent 'SELECT' Privilege check box on the System page in the Options dialog box affects the behavior of assigning and removing Column privileges.

4. Select a table name from the Table list.

The column names defined for the selected table are displayed in the Not Granted, Granted, or With Grant columns of the Edit Privileges form depending on their current privilege status. Initially, a group has no Column privileges, so all column names will be displayed in the Not Granted column. To view an example, click here.

5. Select one or more column names in the Not Granted column for which the selected Column privilege is to be granted to the grantee group for the selected table name.

6. Click the Move Right button at the right of the Not Granted column to move the selected column names to the Granted column.

The group has been given the selected Column privilege on all columns appearing in the Granted column of the Edit Privileges form.

The group does not have access rights to the columns appearing in the Not Granted column of the Edit Privileges form.

7. To enable the group to grant the selected Column privilege to other groups, select one or more column names in the Granted column.

8. Click the Move Right button at the right of the Granted column to move the selected column names to the With Grant column.

Note Use the Move Left button(s) to reduce privileges assigned to the selected group.

· This button to the left of the With Grant column moves selected column name(s) in the With Grant column to the Granted column.

· This button to the left of the Granted column moves selected column name(s) in the Granted column to the Not Granted column.


Print Privileges report

1. On the Edit menu, click Privileges to open the Edit Privileges form.

2. Click Print on the Edit Privileges form toolbar to display the Print Options dialog box.

The name of the default Privileges report is displayed along the top portion of the dialog box.

Note The default Privileges report is specified by an entry in the RELDBDBA.INI file. Upon initial product setup, the default Privileges report is Privileges by Grantee.

3. Adjust the print options, if necessary.

4. Click Start to obtain a printed copy of the default Privileges report.

Note See Configuring Report Capabilities and Reporting for information on other reports that can be printed.


Maintaining the Relativity Database

Maintaining the Relativity Database, An Overview

Defining Date Constants

Maintaining Character Sets

Defining Nonstandard Character Sets

Reporting


Maintaining the Relativity Database, An Overview

The Relativity DBA is used by the data system administrator to maintain and manage the use of a Relativity database. Administrative activities include the following:

· Establishing table connections

· Defining date constants

· Maintaining character sets and defining nonstandard character sets

· Reporting


Defining Date Constants

See Also

Relativity provides a set of six options that interpret the way in which COBOL dates are translated to SQL dates. These options, collectively known as date constants, are stored in the Relativity catalog. Date constants control the conversion in certain transforms and internal functions of COBOL data item values to SQL column date values.

The date constants can be adjusted using the Relativity DBA or the Relativity Designer to reflect common algorithms used in COBOL procedural code.

The Date Constants dialog box contains values for the date constants. The values and structures of the date constants can be changed by appropriate actions in the Date Constants dialog box:

· Define 'Days' Base Date

· Define 'YYYY' Base Year

· Define 'YY' Century Cutoff

· Define 'YY' Base Year

· Define Structure of 'YY' Dates

· Define Structure of 'YYYY' Dates


Define 'Days' Base Date

The 'Days' Base Date constant specifies the date used to interpret date values that represent an integer number of days from a base date in the Gregorian calendar. The default base year is 1899. The default base month is 12. The default base day is 30. Using the default, an integer value of zero in the COBOL data item thus represents the date 30 December 1899, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. In the Year box under 'Days' Base Date, click the arrows or type a four-digit year to specify the desired value for the year.

3. In the Month box under 'Days' Base Date, click the arrows or type a one- or two-digit day to specify the desired value for the month.

4. In the Day box under 'Days' Base Date, click the arrows or type a one- or two-digit day to specify the desired value for the day.

5. Click OK to accept the values specified for the 'Days' Base Date.


Define 'YYYY' Base Year

The 'YYYY' Base Year constant specifies the base year used to interpret date values containing a four-digit year. The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. In the 'YYYY' Base Year box, click the arrows or type a four-digit base year to specify the desired value for the 'YYYY' Base Year.

3. Click OK to accept the value specified for the 'YYYY' Base Year.


Define 'YY' Century Cutoff

The 'YY' Century Cutoff constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. Select the 'YY' Century Cutoff option. A 'YY' Century Cutoff box is displayed on the second line of the dialog box.

3. In the 'YY' Century Cutoff box, click the arrows or type a four-digit century cutoff year to specify the desired century cutoff value.

4. Click OK to accept the value specified for the Century Cutoff year.


Define 'YY' Base Year

The 'YY' Base Year constant specifies the base year used to interpret date values containing a two-digit year. The default base year is 1900. The base year is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. Select the 'YY' Base Year option.

3. In the 'YY' Base Year box, click the arrows or type a four-digit base year to specify the desired 'YY' Base Year value.

4. Click OK to accept the value specified for the 'YY' Base Year.


Define Structure of 'YY' Dates

The 'YY' Dates constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed. The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in their files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. From the 'YY' Dates list, select YYMMDD, MMDDYY, or DDMMYY.

3. Click OK to accept the selected 'YY' Dates structure.


Define Structure of 'YYYY' Dates

The 'YYYY' Dates constant specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed. The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in their files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

1. On the Tools menu, click Date Constants. The Date Constants dialog box is displayed.

2. From the 'YYYY' Dates list, select YYYYMMDD, MMDDYYYY, or DDMMYYYY.

3. Click OK to accept the selected YYYY Dates structure.


Maintaining Character Sets

See Also

Character sets provide a means of associating language characters with an 8-bit number to represent those characters in a data file. It is possible that the character set used to represent the data within a COBOL data file is different from the character set used by the ODBC application receiving the data.

The Character Set Maintenance dialog box provides Relativity with a mechanism for translating between the two character sets. However, Relativity must know the character set that is being used within the data file to represent the characters. (Note that this character set is initially determined in the Relativity Designer when the FD is imported by using the Advanced button in the Source Code Import wizard File Selection page for either .CBL and .RST files or .COB files. The character set may then be modified after import.)

For more information and procedures on how to maintain character sets, choose from one of the following topics:

· Add a standard character set. Relativity supports a large number of standard character sets. Before one of these standard character sets can be used, it must be added to the data source.

· Add a nonstandard character set. Occasionally, the data stored in a file does not match any of the supported character sets. In such cases, a nonstandard character set must be defined and imported into the Relativity data source before it can be used.

· Change existing character sets for a data source. If the actual character set that describes the characters in a data source’s files is different from the character set Relativity has recorded, the Character Set Maintenance dialog box can be used to change it.

· Change the location of the Euro character in a character set. Some COBOL applications supported the Euro character before the International Standard Organization decided its value in standard character sets. In these instances, Relativity needs to modify its understanding of the value of the character in the standard character set.


Add a standard character set

1. From the Tools menu, click Character Set. The Character Set Maintenance dialog box opens.

2. From the Character Set list, select the name of the desired character set.

3. In the Add New Character Set area, click Add. The selected character set will appear in the list of standard character sets.

4. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.


Add a nonstandard character set

1. From the Tools menu, click Character Set. The Character Set Maintenance dialog box opens.

2. In the Add New Character Set area, click Import. A standard Windows dialog box is displayed that allows you to enter the name of the file containing the definition of the nonstandard character set. To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.

3. Click Open. The new character set will appear in the Character Set list.

4. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.


Change existing character sets for a data source

1. From the Tools menu, click Character Set. The Character Set Maintenance dialog box opens.

2. Check the Character Set list to see whether the new character set is already in the data source. If the new character set is not present, follow the procedures either to add a standard character set or add a nonstandard character set. Then, continue with step 3.

3. In the Modify Existing FD Character Set area, in the Change From list, select the name of the character set that is currently associated with the file definitions.

4. From the To list, select the name of the character set that actually describes the data within the data source’s files.

5. Click the Change button. A Status Report dialog box shows a record of the action just taken.

6. Click the Close toolbar button to dismiss the Status Report dialog box.

7. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.


Change the location of the Euro character in a character set

1. From the Tools menu, click Character Set. The Character Set Maintenance dialog box opens.

2. From the Character Set list, select the character set having the definition for the Euro character that will change.

3. Check the Enable Euro check box in the Set Euro Character For Selected Character Set area.

4. In the edit box, enter the value that is used to represent the Euro character in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff).

5. Click the Update button to change the location.

6. Click the Close toolbar button to dismiss the Character Set Maintenance dialog box.

Note This functionality is available from the Character Set Maintenance dialog box only if the data source is using a Relativity v5 or later driver.


Defining Nonstandard Character Sets

See Also

Relativity supports many standard character sets. If you need to define a character set that is nonstandard, however, Relativity has the ability to map data stored in one character set to a different character set for display purposes. This is usually necessary when data that was initially stored using one character set standard must be displayed using another character set standard; for example, data stored on a UNIX server using an ISO 8859 standard character set that must be displayed on Windows using a Code Page standard character set. ISO 8859 and Code Page character set standards are similar, but not identical, in the 8-bit values that are used to represent the different display characters. When the standards disagree on the 8-bit values (known as Code Points), the actual character displayed (known as a Glyph) will be incorrect.

To describe a character set, Relativity uses a derivation of the Unicode Consortium’s Format A character set definitions.

When the mapping tables are created between two character sets, unused Code Points and Code Points with unmatched Glyphs have a simple, one-to-one mapping between the two character sets. This mapping proceeds from the lowest Code Point to the highest and is symmetrical. That is, a character that is read and mapped through these mapping tables will have the correct value stored on a subsequent UPDATE operation.

If the data within a file does not match any of the character sets already defined in Relativity, then the character set of the data file must be installed in the Relativity data source. By so doing, Relativity can build the mapping tables later.

For more information, choose from the following procedures:

· Define a nonstandard character set

· Modify an existing Relativity character set

· Import a standard character set not supported by Relativity


Unicode Consortium's Format A

Unicode Consortium’s Format A

Standard character sets in the Unicode Consortium’s Format A are available from ftp://ftp.unicode.org/Public/MAPPINGS. Relativity augments this format with a Charset and EndCharset clause to allow more than one character set to appear in the character set source file.

A character set source file is a simple text file with the extension of .cs. Comments may appear anywhere in the file and are introduced with the hash character (#) and extend to the end of the line. Numeric values may begin with ‘0x’ to indicate a hexadecimal constant, a ‘0’ only to indicate an octal constant, or ‘1’ through ‘9’ to indicate a decimal constant. Strings are delimited by quotes (“”).

One or more character sets may be in this file. The format of each character set is:

Charset "Character Set Name” character-set-number
code-point-value unicode-value
code-point-value unicode-value
.
.
.
EndCharset

where:

Character Set Name is a string that is the name of the character set to display in the Relativity Designer.

character-set-number is the number to assign to the character set. For character sets installed via the Relativity Designer, this value is ignored and assumed to be zero.

code-point-value is the 8-bit numeric value of the Glyph in the character set. A code-point-value that is not present in the character set is assumed to be unused.

unicode-value is the 16-bit numeric value of the Glyph in the Unicode standard. This value also may be a Unicode constant, in which case, it will be delimited by a less than symbol (<) and a greater than symbol (>). The most commonly used of these is the constant <NOT USED>, which indicates that the Code Point does not have a Glyph assigned to it.


Supported Standard Character Sets

Relativity supports the following standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |


Define a nonstandard character set

1. Using a text editor, edit a new file in which to place the character set. Name the file with the extension, .cs.

2. Insert the following line at the beginning of the file:

Charset "Character Set Name" 0x0

For Character Set Name, substitute the name for the character set that is to be visible from within the Select Character Set dialog box.

3. Insert up to 256 lines into the file, one for each character in the character set being described. On each line there must be two entries, separated by a space or a tab, with an optional third entry, also separated by a space or tab. The first entry on the line must be the 8-bit Code Point value for the entry. This corresponds to the numeric value of the character being described. The second entry is the 16-bit Unicode character for the character being defined. The third entry is an optional comment for the line, preceded by a hash (#) character.

For example, if the character set had a Euro Sign at position 128, the line for it would be:

128 8364 #EURO SIGN

Or, using hexadecimal notation:

0x80 0x20AC #EURO SIGN

For Code Points where there is not a defined character, use the text <NOT USED> for the second entry.

Note A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.

4. Following the lines describing the character set, insert the following line:

EndCharset

5. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.


Modify an existing Relativity character set

1. Edit the file wincs.cs in the installation directory.

2. Locate the character set to modify.

3. Select and copy the lines Charset and EndCharset of the desired character set and all the text in between.

4. Create a text file in which to place the modified character set and paste in the text from Step 3.

5. Locate the Charset line and change the text between the quotes to the name for the character set that is to be visible from within the Select Character Set dialog box. Change the number at the end of the line to 0x0.

6. Locate the lines for the Code Points to be changed in the character set. This can be done by examining first entry on each the line. This value is the numeric value for the character in the character set. For example, in most Latin-based character sets, the capital letter A has the Code Point value of 65 (or 0x41 hexadecimal).

7. Change the second entry on the line to the Unicode value for the new character to be at this Code Point. For example, if you want the character at Code Point 65 to be interpreted as a capital letter A with an Acute, change the line to the following:

0x41 0x00C1 #LATIN CAPITAL LETTER A WITH ACUTE

8. If necessary, insert a new line with the Code Point and Unicode entries for new Code Points.

Note A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition, or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.

9. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.


Import a standard character set not supported by Relativity

1. FTP to the site, ftp.unicode.org.

2. Change to the directory, Public/MAPPINGS.

3. Locate the character set you want, as follows:

· If the character set is a standard Microsoft Windows Code Page, change to the directory, VENDORS/MICSFT/WINDOWS.

· If the character set is a standard Microsoft DOS Code Page, change to the directory, VENDORS/MICSFT/PC.

· If the character set is an ISO 8859 character set, change to the directory, ISO8859.

· If the character set is none of the above, explore the other directories in ftp.unicode.org/Public/MAPPINGS in order to locate the desired character set. If you cannot find the character set you want, you must define a nonstandard character set or modify an existing Relativity character set.

4. Locate the file for the desired character set and download the file to your local machine. Name it with the extension, .cs.

5. Edit the file with a text editor, taking care to delete any control characters, usually marked with the characters ^D from the file.

6. Insert the following line at the beginning of the file:

Charset "Character Set Name" 0x0

For Character Set Name, substitute the name for the character set that is to be visible from within the Select Character Set dialog box.

7. At the end of the file, insert the following line:

EndCharset

8. Examine the remaining lines for any that are missing the second entry on the line. This second entry is the 16-bit Unicode character for the character being defined. In the definitions available on ftp.unicode.org, unused Code Points are left blank with the comment of UNDEFINED. Insert <NOT USED> as the second entry on the line.

Note A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition, or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.

9. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, click here.


Error Messages when Importing a Nonstandard Character Set

The following errors may be produced when importing a nonstandard character set into a Relativity data source:

· Redefinition of Character. Indicates that the value used in the code-point-value has appeared previously in the character set definition. A common cause of this problem is the omission of a unicode-value or code-point-value, causing the charset compiler to misinterpret the value. The code-point-value and unicode-value must appear in pairs.

· Syntax Error. Indicates that the character set does not conform to the format of a character set definition. This usually indicates that a numeric constant was not detected where it was expected.

· Unicode constant too large. Indicates that a unicode-value was larger than can be stored in 16-bits.

· Code Point constant too large. Indicates that a code-point-value was larger than can be stored in 8-bits. This message may indicate a missing value from a code-point-value and unicode-value pair.

· Illegal constant. Indicates that a decimal constant contained a nonnumeric character.

· Illegal hex constant. Indicates that a hexadecimal constant contained a non-hex character.

· Illegal octal constant. Indicates that an octal constant contained a non-octal character.

· Illegal string constant. Indicates that a string constant did not terminate before the end of a line.

· Unknown unicode constant. Indicates that a Unicode constant is recognized.

· Unknown keyword. Indicates that either the keyword Charset or EndCharset was not located where expected.

· Keyword too long. Indicates that a keyword was expected in the character set source file, but it was too large to be processed.

· String constant too long. Indicates that a string constant was too large to be processed.

· Illegal Unicode constant. Indicates that a Unicode constant did not have a closing delimiter (>) before the end of a line.

· Unicode constant too long. Indicates that a Unicode constant was too long to be processed.

· In Character Set Name, Unicode unicode-value duplicated at positions code-point-value and code-point-value. Indicates that the character set with the name Character Set Name has the same Unicode character in multiple Code Point locations. In order to create symmetrical mapping tables, a Unicode character may be used only once per character set.


Reporting

See Also

The Relativity DBA provides a set of reports that have been predefined to assist in reviewing three types of data in the Relativity catalog and maintaining that data, as required. The three report categories include the following:

1. Connections. The reports in this category describe the physical access names associated with table definitions.

2. Privileges. The reports in this category describe the security privileges assigned to database groups defined for the catalog.

3. Users. The reports in this category describe the groups and users defined for the catalog.

In the Relativity DBA, reports can be accessed in either of the following ways:

· Using the Reports tab in the Catalog window.

· Using commands from the Reports menu in the Relativity DBA window. The Reports menu is hidden unless both the following conditions are true:

-  The user is the owner, a member of the owner group, or has been granted the Reports administrative privilege.

-  The RELDBDBA.INI has been configured to allow reporting. See Configuring Report Capabilities.

Each of the Relativity predefined reports can be used "as is." Alternatively, the WYSIWYG Report Editor included with the Relativity DBA can be used either to create new reports based on the Relativity reports or to customize the Relativity reports. To access the Report Editor, take any of the following actions:

· On the Reports tab, select a specific report description and click Open.

· On the Reports tab, select a report category and again click Open. In this case, the Select Report dialog box opens where you may do either of the following:

-  In the File Name box, type a filename for a new report, click Open, and follow the prompts in the Report Editor wizard to create a new report.

-  In the List area, select and open an existing report as a starting point. (In the Report Editor, be sure to use the Save As command immediately to avoid overwriting an existing report.)

· Likewise, you can open the Report Editor by choosing the Edit command on the Reports menu and then clicking one of the submenus (Connections, Privileges, or Users). In this case, the Select Report dialog box again opens and you may follow the instructions described above.

For procedures on how to create and customize reports using the Report Editor, as well as how to print a report, choose from the following topics (or refer to the Report Editor online Help file):

· Create a new report

· Edit an existing report

· Print a report


Create a new report

1. On the Reports menu, point to Edit and then click one of the available report categories from the submenu.

Note The Edit submenu is hidden on the Reports menu unless you make changes to the RELDBDBA.INI file. For additional information on configuring the Edit command on the Reports menu, click here.

2. In the Select Report dialog box (the exact name of this dialog box will vary depending on the report category selected), specify a file by either one of the following actions:

· In the File Name box, type or a filename of the report definition file for the report being created. For the filename extension, either type the default extension shown in the Files of type list or omit the extension. If the extension is omitted, the default extension is supplied.

· Select an existing filename of a report definition file as a starting point for a new report. Be sure to use the Report Editor's Save As command immediately upon entry to avoid unintentionally overwriting an existing report.

3. In the Report Editor, design the desired report. (For assistance, refer to the Report Editor online Help file.)

4. On the Report Editor File menu, click Save As. The Save As dialog box is displayed.

5. In the Description box, enter a description of the report.

Note The newly created report will not be shown in the report descriptions listed on the submenus for the Connections, Privileges, or Users commands on the Reports menu until the data source is closed and reopened.

6. If necessary, adjust the filename and folder/directory options for the report definition file. The directory should be one that is searched for report file definitions.

7. Click OK.


Edit an existing report

1. On the Reports menu, point to Edit and then click one of the available report categories from the submenu.

Note The Edit command is hidden on the Reports menu unless changes are made to the RELDBDBA.INI file. For additional information on configuring the Edit command on the Reports menu, click here.

2. In the File Name box of the Select Report dialog box (the exact name of this dialog box will vary depending on the report category selected), specify a file by selecting or typing a filename of the report definition file for the report being edited. For the filename extension, either type the default extension shown in the Files of type list or omit the extension. If the extension is omitted, the default extension is supplied.

3. In the Report Editor, edit the selected report. (For assistance, refer to the Report Editor online Help file.)

4. On the Report Editor File menu, click Exit.

5. Click Yes in response to the message about saving changes.

Note If the description of the report is changed, the new description will not be shown in the reports listed on the submenus for the Connections, Privileges, or Users commands on the Reports menu until the data source is closed and reopened.


Print a report

Note The manner in which you print a report depends on whether you are using options on the Reports tab or from the Reports menu.

1. If you are using the Reports tab in the Catalog window, follow these steps:

a. Select the description of the report to be printed.

b. Click Print. The Print Options dialog box is displayed.

Note If you click Print when a report category is selected in the Reports tab rather than a specific report description, the Select Report dialog box is displayed. In this case, follow the instructions beginning with Step 2c.

c. Proceed to Step 3.

2. If you are using the Reports menu, following these steps:

a. Point to Connections, Privileges, or Users to display a submenu containing a list of report descriptions available for the selected report category.

b. Click one of the available report descriptions to be printed for that particular report category. The Print Options dialog box is displayed.

c. Proceed to Step 3.

3. Adjust the print options, if necessary.

4. Click Start. After retrieving information from the Relativity catalog, a message box is displayed. Printing status is updated as printing progresses.

5. To halt printing before normal termination, click Cancel.

Printing is complete when the message box disappears.

Note An alternative method of printing the default report for each report category, as specified in the RELDBDBA.INI file, is to click Print (or use Alt+P) from the following forms:

· Edit Connections form, to obtain the default Connections report (Connections by Table Name).

· Edit Privileges form, to obtain the default Privileges report (Privileges by Grantee).

· Edit Users form, to obtain the default Users report (All Users by User Name).


Configuring Report Capabilities

See Also

The Relativity DBA must be configured to allow reporting capabilities, which include the use of predefined reports as well as the ability to customize those reports or create new ones. The configuration requires making changes to the RELDBDBA.INI file, using a text editor.

Note The reporting capability in the Relativity DBA is subject to the Reports privilege, which is in the Administrator set of privileges. The Reports privilege may expose certain database objects for which a user group would otherwise have no authority.

For information on how to configure the reporting capabilities, choose one of the following tasks:

· Configure a default report to be run with the Print toolbar button

· Configure a Reports menu

· Configure the Export command on the Reports menu

· Configure the Edit command on the Reports menu


Configure a default report to be run with the Print toolbar button

Add or modify the following section to RELDBDBA.INI:

[DefaultReports]
Connections=Connections by Table Name
Privileges=Privileges by Grantee
Users=All Users by User Name

Note Connections by Table Name, Privileges by Grantee, and All Users by User Name are the descriptions of the recommended default reports for the Edit Connections form, Edit Privileges form, and the Edit Users form, respectively. You can, however, assign any of the predefined reports within a report category as the default for that report category. The description of the report, not the filename of the report file, is used to specify the default report.

The Print toolbar button appears on the Edit Connections form, the Edit Privileges form, and the Edit Users form. If the corresponding default report description is not specified in the RELDBDBA.INI file, however, the Print button does not appear on the toolbar.


Configure a Reports menu

Add one or more of the following lines to the [Administrator] section of the RELDBDBA.INI file:

EnableCustomUsers=Yes
EnableCustomConnections=Yes
EnableCustomPrivileges=Yes


Configure the Export command on the Reports menu

Add the following line to the [Administrator] section of the RELDBDBA.INI file:

EnableReportExport=Yes


Configure the Edit command on the Reports menu

Add one or more of the following lines to the [Administrator] section of the RELDBDBA.INI file:

EnableCustomEditUsers=Yes
EnableCustomEditConnections=Yes
EnableCustomEditPrivileges=Yes


Report Definition Files

See Also

Report definition files are the files that describe particular reports. The catalog distributor may have provided some predefined predefined report definition files along with the Relativity DBA so that the end-user can generate reports. The report definition files also can be created using the Create a new report procedure (if enabled in the RELDBDBA.INI file).

Report definition files have the following default extensions:

· rcl Connections Reports

· rpl Privileges Reports

· rul Users Reports

The Relativity DBA searches for report definition files at startup in three directories:

1. A directory specified in the RELDBDBA.INI file [Administrator] section as follows:

ReportDir=path

where path is the directory in which to search for reports.

2. The current directory specified at startup of the Relativity DBA.

3. The directory in which RELDBDBA.EXE is found.


Predefined files provided with the Relativity Designer

The following predefined files for the various report categories are provided with the Relativity Designer. These files may or may not be distributed to your end-user site.

Connections Reports

The Connections report category includes the following predefined files.

Filename | Report Description
contab1.rcl | Connections by Table Name (This is the default report for the Connections report category.)
contab2.rcl | Connections by Table Definition Name
contab3.rcl | Connections by Owner Name
contab4.rcl | Connections by File Access Name
contab5.rcl | Table List

Privileges Reports

The Privileges report category includes the following predefined files.

Filename | Report Description
grantee1.rpl | Privileges by Grantee (This is the default report for the Privileges report category.)
grantor1.rpl | Privileges by Grantor
object1.rpl | Privileges by Object

Users Reports

The Users report category includes the following predefined files.

Filename | Report Description
user1.rul | All Users by Group
user2.rul | All Users by User Name (This is the default report for the Users report category.)
user3.rul | All Users by Declared Order (Note that the name of this report implies that one can declare the order in which the report lists the users. In reality, users are listed in order of declaration; that is, by group ID and then by user ID order.)


Connections Report Features

See Also

The Connections report category provides detailed information about the association of SQL table names and the file physical access names maintained in a Relativity catalog. To view an example of this type of report, click here.

The following data elements are available in Connections reports.

Data Element Name | Types Available | Explanation
DatabaseQualifier | V | ODBC database qualifier for this catalog
DataSourceName | V | ODBC data source name for this catalog
FileAccessName | FVPEI | Physical access name for the file associated with the SQL table
OwnerName | FVPE | Name of the group that owns the table
ProductName | V | Name of the Relativity product used to print the report
ProductVersion | V | Version of the Relativity product used to print the report
TableDefinitionName | FVPEI | Table definition name (typically known as the table name in the Relativity Designer)
TableName | FVPE | SQL table name


Privileges Report Features

See Also

The Privileges report category provides detailed information about database, table, and column privileges maintained in a Relativity catalog. To view an example of this type of report, click here.

For more information about the privilege codes that can appear on the Privileges reports, click here.

The following data elements are available in Privileges reports.

Data Element Name | Types Available | Explanation
DatabaseQualifier | V | ODBC database qualifier for this catalog
DataSourceName | V | ODBC data source name for this catalog
Grantee | FVPEI | Name of the group granted the privilege
Grantor | FVPEI | Name of the group granting the privilege
ObjectType | FVPEI | Indicator explaining the PrivilegeObject: “Database”, “Define”, “Table”, “TableColumn”, or “User”
Privilege | F | Encoded string tersely describing the privilege
PrivilegeObject | FVPE | Name of the object to which the privilege applies: SQL table name, SQL tablename:columnname, Table definition name, User name, or “Database”
PrivilegeVerbose | F | Verbose description of the privilege
ProductName | V | Name of the Relativity product used to print the report
ProductVersion | V | Version of the Relativity product used to print the report


Users Report Features

See Also

The Users report category provides detailed information about users (a group is a user) maintained in a Relativity catalog. To view an example of this type of report, click here.

The following data elements are available in Users reports.

Data Element Name | Types Available | Explanation
DatabaseQualifier | V | ODBC database qualifier for this catalog
DataSourceName | V | ODBC data source name for this catalog
GroupName | FVPEI | User group name
IsGroup | FVPEI | Boolean indicator that this UserName is the group name
IsOwner | FVPE | Boolean indicator that this group is the catalog owner
ProductName | V | Name of the Relativity product used to print the report
ProductVersion | V | Version of the Relativity product used to print the report
UserName | FVPE | Individual user name


Exporting Data to a Comma-Separated File

See Also

Relativity uses the Report Editor to export data stored in a Relativity catalog to a comma-separated file that may be imported by most database, spreadsheet, and word processing products.

For procedures, on how to export data stored in a Relativity catalog, click here.


Export data stored in a Relativity catalog

1. On the Reports Menu, click Export. A check mark appears to the left of the command name to indicate that the Export feature is active.

Note The Export command is hidden unless changes are made to the RELDBDBA.INI file. For additional information on configuring the Export command on the Reports menu, click here.

Alternatively, from the Reports tab in the Catalog window, select the name of the report to be exported and click the Export button. Proceed to Step 4.

2. On the Reports menu, point to Connections, Privileges, or Users to display submenus containing a list of report descriptions for the selected report category.

3. Click one of the available report descriptions for the selected report category.

4. In the Save Export File As dialog box, select the name of the file into which the export (comma-separated) information is to be stored.

5. Click Save. The Print Options dialog box is displayed.

6. Adjust the print options, if necessary.

7. Click Start. After retrieving information from the Relativity catalog, a message box is displayed. Printing status is updated as printing progresses.

8. To halt printing and exporting before normal termination, click Cancel.

Printing and exporting are complete when the message box disappears.


Reference Information

Welcome to Relativity Window

Relativity DBA Window

Catalog Window

Options Dialog Box

Administration Forms

Dialog Boxes


Welcome to Relativity Window

See Also

The Welcome to Relativity window appears when you first install and start the Relativity DBA. From this window, you can set up and create a new data source, or open an existing or most recently used Relativity data source. After completing the first session with Relativity, the most recently used data source is always selected by default in this window when you start Relativity again.

Note The step-by-step procedures in the Relativity DBA Help file assume that you have disabled this window after the initial installation by clearing the Show Welcome at Startup check box. Subsequently, when you start Relativity, you will begin all operations in the main Relativity DBA window. You may, however, enable this capability again by choosing Welcome from the Tools menu.

The Welcome to Relativity window contains the following options.

Option

Description

Recent

Select the Recent option to open the data source that you have most recently used in the Relativity DBA. When you select this option, a numbered list--in the order of the most recently opened data sources--is displayed in the List area and the data source most recently used is highlighted.

To quickly reopen one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened.

Note This option corresponds to the Most Recently Used Data Source command on the File menu.

New

Select the New option to set up and create a new data source. (An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database.) If you have multiple drivers installed, select the appropriate driver from the List area and then create a new data source. For more information, see Setting Up a New Data Source.)

Note This option provides the same functionality as the New Data Source command on the File menu.

Existing

Select the Existing option to open and maintain an existing catalog that supports the Relativity database specified by the data source. When you select this option, a list of all the existing data sources is displayed in the List area. If you have multiple drivers installed, a list will appear in a box to the right of this option, indicating that the existing catalogs displayed are associated with the data source for the selected driver.

To quickly open one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened. For more information, see Opening a Data Source.)

Note This option provides the same functionality as the Open Data Source command on the File menu.

Driver

If multiple drivers are installed on your system, you can select the appropriate driver from the Driver list box in order to create and set up a new data source or open an existing data source.

List

The List area varies in its appearance depending on which of the following options is selected:

· If the New option is selected, the List area allows you to select the appropriate driver (if multiple drivers are installed on your system) and then create a new data source. To see an example, click here.

· If either the Recent or Existing option is selected, the List area allows you to quickly open an existing or reopen a most recently used data source. Note that if a data source is selected from this list, any open, existing data source is closed, and the selected data source is opened.

The data sources displayed in this list depend on which option is selected:

-  If the Existing option is selected, the list displays the available catalogs associated with the data source (for the selected driver, if necessary).

-  If the Recent option is selected, a numbered list displays up to the last four data sources recently opened by the Relativity Designer. The default number of data sources displayed is four. This number can be adjusted by adding the following entry (or modifying an existing entry) in the [DBA] section of the RELDBDBA.INI file:

RecentFileCount=n

where n is a number from 0 to 9.

Show Welcome at Startup

By default, this option is selected when you first install and start the Relativity DBA. If this option remains enabled, the Welcome to Relativity window displays each time you start the Relativity DBA. If you disable this option, you can choose Welcome from the Tools menu to enable it again.

Cancel

The Cancel button cancels all selections and closes the Welcome to Relativity window.

OK

· If you click OK after selecting the New option, you set up a new data source.

· If you click OK after selecting either the Existing or Recent option, the Catalog window for the specified data source is opened. Note that if security has been defined for the catalog associated with the data source, you must complete the Logon dialog box.


Relativity DBA Window

See Also

If you have disabled the Show Welcome at Startup option on the Welcome to Relativity window, the Relativity DBA window is displayed when you start the Relativity DBA. This main window contains four regions: title bar, menu bar, desktop area, and status bar. Each region has specific uses and functions. For information about the key components of the Relativity DBA window, click on that element in the image below or choose one of the following topics:

· Title Bar

· Menu Bar

· Status Bar

Note The Relativity DBA window displays the Catalog window when the data source associated with the Relativity catalog is opened.


Title Bar

The title bar, displayed at the top of the Relativity DBA window, contains the name "Relativity DBA." In addition, the title bar displays the name of the data source if any data source is open.

To move the Relativity DBA window to a different location:

1. Point the cursor at the text display section of the title bar.

2. Press and hold the primary mouse button.

3. Drag the window by moving the mouse.

4. Release the mouse button.

You can move, close, maximize, minimize, or restore the Relativity DBA window by using the four icons in the title bar.

Icon | Description
Control menu | The Control menu (also known as the System menu) icon is a pictorial equivalent of the Control menu used to manipulate the window. This icon is located at the far leftmost position on the title bar. The Control menu contains the menu commands: Restore, Move, Size, Minimize, Maximize, and Close.
 | The Minimize icon is a pictorial equivalent of the Minimize command to shrink a window to an icon. This icon is the third button from the right on the title bar.
 | The Maximize icon is a pictorial equivalent of the Maximize command to enlarge an icon to a window. This icon occupies the second button position from the right on the title bar.
 | The Restore icon is present when the window fills the inside of another window or if a window fills the screen. The Restore icon is a pictorial equivalent of the Restore command to restore an icon or maximized window to its previous window size.
 | You can also quit a program by clicking the Close icon at the far right of the title bar. Shortcut: Alt+F4


Menu Bar

The Relativity DBA menu bar, which is located below the title bar in the Relativity DBA window, contains the names of the menus. The menu bar contains the names File, Edit, Connection, Reports, Tools, Window, and Help.

Notes

· The Edit menu is unavailable until a data source is open in the Relativity DBA window.

· The Connection menu is unavailable until the Edit Connections form is displayed.

· The Reports menu is unavailable unless, using a text editor, you make changes to the RELDBDBA.INI file. Refer also to Configuring Report Capabilities.

Clicking a menu name displays a list of commands for accessing various Relativity DBA operations. Choose one of the following topics for more information about the commands located on each menu:

· File Menu

· Edit Menu

· Connection Menu

· Reports Menu

· Tools Menu

· Window Menu

· Help Menu

Note In addition to the drop-down menus on the menu bar, Relativity offers context-sensitive menus that pop up at the click of the right mouse button.


File Menu Commands

The commands displayed on the File menu of the Relativity DBA window depend on whether a data source has been opened and selected for processing.

Choose

To

New Data Source

Set up a new data source. (The Relativity DBA assumes the currently selected Relativity DBMS as the ODBC driver.) For further information, see also Setting Up a New Data Source in the Relativity DBA help file.

Open Data Source

Display the Open Relativity Data Source dialog box in order to select the name of the data source to be processed.

Shortcut: Ctrl+O

For further information, see Opening a Data Source.

Close Data Source

Terminate the processing of the data source identified by the name in the title bar of the Relativity DBA window. Any form that is open within the data source is also closed by clicking this command.

Shortcut: Ctrl+D

For further information, see Closing a Data Source.

Driver

Select an installed ODBC driver.

Note This command appears as an option only if multiple ODBC drivers have been installed for Relativity.

Merge Catalog

Note In order for this command to appear on the File menu, the catalog distributor must have included a rules file with the name RELDBUTL.INI along with your catalog. RELDBUTL.INI must exist in the Windows directory (for more details, click here.) Additionally, this command will appear only if a data source has not been opened in the Relativity DBA.

Launch the Catalog Merge capability, which takes any changes you have made related to maintaining groups and users, defining security privileges, or establishing table connections for your catalog and merges them into a new catalog. The Merge Catalog command can be used to move the security information (including user names) from one Relativity data source to another. This feature is useful in merging the user information of a Relativity application from a previous version to a newer version. This merge process should occur only when you receive an updated catalog from your distributor.

Change Catalog Owner

Display the Change Catalog Owner dialog box. The Change Catalog Owner dialog box displays options for a new owner name and an optional password. See Defining Catalog Ownership.

Most Recently Used Data Source

Display up to the last nine data sources opened by the Relativity DBA. If one of these data sources is selected, any existing data source is closed, and the selected data source is opened. The default number of data sources displayed is four. This number can be adjusted by adding the following entry (or modifying an existing entry) in the [DBA] section of the RELDBDBA.INI file:

RecentFileCount=n

where n is a number from 0 to 9.

Note To select a data source from the list, simply click the filename from the menu with the mouse or type the number that appears to the left of the name.

Exit

Terminate the execution of the Relativity DBA.

Shortcut: Ctrl+F4

See Starting the Relativity DBA.


Detailed Information about Merge Catalog

Before the Merge Catalog command will appear on the File menu, the RELDBUTL.EXE file must be in the same directory as the RELDBDBA.EXE file that is currently being run. Normal installation of the Relativity DBA installs the RELDBUTL.EXE file in the same directory as RELDBDBA.EXE. However, the RELDBUTL.EXE file might not be located there for several reasons, including any of the following:

· The user has deleted the file;

· The user has moved the file to another directory; or

· The catalog distributor may have modified the end-user installation process to omit the file.


Edit Menu Commands

The Edit menu is active in the menu bar of the Relativity DBA window when a data source has been opened for processing.

Choose | To
Connections | Display the Edit Connections form for the defining and editing of a table connection. A table connection is composed of a table name and a path name. The table name is the name of an SQL table. The path name is the physical filename of a data file. All table connections associated with the same Relativity table definition have identical characteristics except for the path name of the underlying data files. See Establishing Table Connections .
Privileges | Display the Edit Privileges form. Groups are assigned privileges to a Relativity catalog with appropriate actions in the Edit Privileges form. See Defining Group Privileges.
Users | Display the Edit Users form. Groups and users are assigned to a Relativity catalog with appropriate actions in the Edit Users form. See Defining Groups and Users.


Connection Menu Commands

See Also

The Connection menu is displayed in the menu bar of the Relativity DBA window when the Edit Connections form is displayed. The commands available on the Connection menu vary depending on which item is selected in the Edit Connections form:

· If the table definition is selected, the Add Table and Edit Table Connection commands are enabled.

· If a table name is selected, the Add Connection, Delete Table, and Rename commands are enabled.

· If the path name is selected, the Rename command is enabled.

· If file labels are in effect, the File Label command is enabled.

Choose

To

Add Table

Display the Add Table Connection dialog box. This dialog box contains options for the definition of a table connection for a selected table definition on the Edit Connections form.

Note The Add Table command provides the same functionality as the Add Table Connection button on the Edit Connections form toolbar.

Add Connection

Display the Add Table Connection dialog box if the selected table definition has a file label.

Notes

· This command does not appear unless the selected table definition has a file label.

· The Add Connection command provides the same functionality as the Add Table Connection button on the Edit Connections form toolbar.

Delete Table

Delete selected table connections for a selected table definition in the Edit Connections form.

Note The Delete Table command provides the same functionality as the Delete Table Connection button on the Edit Connections form toolbar.

Delete Connection

Delete the selected table connection if there are two path names associated with the same table name.

Notes

· This command does not appear unless the selected table name has more than one file label/path name connection.

· The Delete Connection command provides the same functionality as the Delete Table Connection button on the Edit Connections form toolbar.

Edit Table Connection

Display the Edit Selected Table Connections dialog box. This dialog box contains options for editing the path names and file label items, if defined, of selected table connections of a table definition.

Note The Edit Table Connection command provides the same functionality as the Edit Table Connection button on the Edit Connections form toolbar.

File Label

If file labels are in effect, display a dialog box where you can edit (enter) a file label for a specific table definition.

Note This command does not appear unless the selected table definition has a file label.

Rename

Depending on which item is selected, change the table name or path name (or file label, if file labels are in effect) by editing it. It is not necessary to specify a search and replace pattern.


Reports Menu Commands

The Reports menu of the Relativity DBA window contains commands that allow you to print existing reports related to Connections, Privileges, and Users as well as preview, export, or edit these reports. A report also may be printed from the Reports tab in the Catalog window.

The Reports menu is hidden in the Relativity DBA window unless both of the following are true:

1. You opened the data source and logged in as a user belonging to the owner group or as a user belonging to a group that has been granted the Reports administrative privilege.

2. You modified the RELDBDBA.INI file to configure some or all of the reporting features. See Configuring Report Capabilities for information on the necessary modifications.

Note The reporting capability in the Relativity DBA is subject to the Reports privilege, which is specified in the Administrator set of privileges. The Reports privilege may expose certain database objects for which a user group would otherwise have no authority. Therefore, the Reports privilege should only be granted to a trusted administrative group.

Choose | To
Connections | Display a submenu of reports related to table connections. When one of these reports is selected, the Print Options dialog box is displayed to allow printing of the report. See also Connections Report Features.
Privileges | Display a submenu of reports related to privileges. When one of these reports is selected, the Print Options dialog box is displayed to allow printing of the report. See also Privileges Report Features
Users | Display submenu selection of reports related to users. When one of these reports is selected, the Print Options dialog box is displayed to allow printing of the report. See also Users Report Features.
Export | Toggle the export facility on or off. When export is active, a check mark appears to the left of the Export command. When a report is selected from one of the submenus on the Connections, Privileges, or Users commands, those fields and variables included in the report will be exported to a comma-separated (.CSV) text file. See the Save Export File As dialog box, Exporting Data to a Comma-Separated File, and Reporting.
Preview | Modify the action of the Print command by allowing you to see how the report will look when it is printed. When the preview capability is active, a check mark appears to the left of the Preview command and the Preview button is selected in the Print Options dialog box. To disable the preview capability, click the Preview command again.
Edit | Displays a submenu that allows you to create a new report or modify an existing report related to Connections, Privileges, and Users. See Reporting.


Tools Menu Commands

The Tools menu of the Relativity DBA window contains the following commands.

Choose

To

Welcome

Display the Welcome to Relativity window, where you can create (set up) a new data source, and optionally select a driver if necessary, open an existing data source, or open a recently used data source. This window appears automatically when you first install and start the Relativity DBA.

Import Btrieve Keys

Note This feature is available only in Relativity for Micro Focus COBOL.

Specify a data file containing the Btrieve key structure in order to import that key structure into a Relativity catalog using the Btrieve Key Import for filename dialog box (Micro Focus COBOL Only). This procedure is generally needed only if the Btrieve data file was not constructed with COBOL or the key structure has been modified with third-party Btrieve products. If the COBOL SELECT statement was generated to match an existing Btrieve structure without knowing the order of the keys in the Btrieve data file, this process can be used to insure that the Relativity catalog matches the data.

To enable this option, you must set EnableBtrieveConversion=Yes in the [Administrator] section of the RELDBDBA.INI file found in your Windows directory.

Date Constants

Display the Date Constants dialog box. This dialog box enables the user to change the values of: (1) the four date constants, 'Days' Base Date, 'YYYY' Base Year, 'YY' Century Cutoff, and 'YY' Base Year, and (2) the structure of two date constants ('YY' Dates and 'YYYY' Dates). For further information, see Defining Date Constants.

Server Admin

Display the Select Server dialog box , where you can define a Windows NT or UNIX server for the Relativity Data Client data source and configure a Relativity Data Server data source on a Windows NT or UNIX server for the Data Client. It is also used to verify communications between a Relativity Data Client data source and the Relativity Data Server data source. (See also the online Server Administrator help file available from the Help menu.)

Options

Display the Options dialog box. The Options dialog box enables the user to select settings for various preferences. These settings become the default settings for the appropriate options. Refer also to Setting Options.

Shortcut: Ctrl+R


Window Menu Commands

The Window menu of the Relativity DBA window contains the following commands.

Note At the bottom of the Window menu is a list of the Catalog window and other forms that may be open for the data source that has been selected for processing. A check mark appears next to the name of the window or form that is active in the Relativity DBA main window. To activate any of these windows or forms (that is, to bring any of them to the front), simply click the filename from the list or type the number that appears to the left of the name.

Choose | To
Cascade | Arrange windows in an overlapping cascade so that titles remain visible.
Tile Horizontal | Arrange windows so that a full horizontal view is shown of the top portion of each window.
Tile Vertical | Arrange windows side by side so that each window is visible.
Arrange Icons | Move all icons to a row at the bottom of the Relativity DBA window.


Help Menu Commands

See Also

The Help menu of the Relativity DBA window contains the following commands.

Choose | To
Contents | Display the Relativity DBA Help contents. The Contents command performs the same function as the Contents button on the Help toolbar.
Search For Help On | Enable the user to search the Help information for specific topics. The Search for Help On command performs the same function as the Index button on the Help toolbar.
DBMS Help File | Launch the Relativity Database Management System (DBMS) help file for the currently selected ODBC driver. You select an ODBC driver on the File menu, in the Welcome to Relativity window when you open a data source, or in the Open Relativity Data Source dialog box.
Server Admin Help File | Launch the Server Administrator help file. See the Select Server dialog box.
About | Display the About dialog box, which includes the version number, copyright specifications, registration/serial number, catalog version number, and licensing information of the Relativity DBA product that is currently running.


Status Bar

The status bar, displayed at the bottom of the Relativity DBA window, displays information and messages to help the user of the Relativity DBA.

Note If the LED style indicator near the center turns yellow, Windows resources are too low to continue safely. Close some windows to reduce resource usage.


Catalog Window

In Relativity, the Catalog window is "control central" for the creation and maintenance of a Relativity catalog. Within the Catalog window, definitions of tables and reports can be viewed and opened. You can also view and change user definitions.

The Catalog window is displayed in the Relativity DBA main window when a data source is opened. It contains a title bar, status bar, and a set of three tabs:

· Tables

· Users

· Reports

The Catalog window also includes one or more buttons, whose name and function depend on the selected tab.

For more information, see Working with the Catalog Window.


Options Dialog Box

See Also

Relativity allows you to establish default settings for various options related to the system, security privileges, and the selection of data file formats in Micro Focus COBOL. You change most of these settings on the Options dialog box.

To access the Options dialog box in the Relativity DBA:

1. On the Tools menu, click Options.

2. In the left pane of the Options dialog box, click the topic or icon to display the corresponding page of preferences in the right pane. Note that in the Relativity DBA, there is only one page of options.


Administration Forms

See Also

Several forms support administration of a Relativity database. These forms are available in the Relativity DBA for end-user administration of Relativity databases. The administration forms are summarized below:

· The Edit Connections form displays the table connections for a table selected on the Tables tab in the Catalog window. This form supports adding, deleting, and modifying the connections between Relativity database tables and the COBOL data files that provide data for a particular table.

· The Edit Users form supports adding, deleting, and modifying authorized users of the Relativity database.

· The Edit Privileges form supports modifying the database security privileges assigned to any particular authorized user of the Relativity catalog.


Edit Connections Form

See Also

The Edit Connections form provides the facility to define and edit one or more table connections associated with a Relativity table definition.

Note Whenever the Edit Connections form is displayed, a Connections menu appears on the menu bar in the Relativity DBA window.

To open the Edit Connections form in the Relativity DBA window, choose one of the following methods:

· On the Edit menu, click Connections.

When this method is used, the Edit Connections form lists all currently existing table definitions. This list of table definitions is hierarchical in nature, in that when expanded, it displays the table connection (that is, the table name, path name, and file label, if file labels are in effect) for a specific table definition. A plus sign [+] precedes each item in the list. To expand the list, select an item and click the plus sign (to view an example, click here.). To collapse the list, click the minus sign [-].

Because all existing table definitions are accessible from this view, the Global Add, Global Delete, and Global Edit toolbar buttons are enabled.

Note If file labels are in effect, the table connection also includes the name of the file label associated with the table definition. (To view an example, click here.)

· From the Tables tab in the Catalog window, select a table definition and click the Connections button.

When this method is used, the Edit Connections form displays only the table definition currently selected on the Tables tab in the Catalog window.

Note If file labels are in effect, the table connection also includes the name of the file label associated with the table definition. (To view an example, click here.)

If you right-click any of the items in the list or expanded list, a pop-up context-sensitive menu is displayed for that item. Choose the command you need.

Note If the Print button is not available on the toolbar, see Configuring Report Capabilities.

The Edit Connections form contains the following options.

Option

Description

Click the Close toolbar button to close the Edit Connections form and save any changes you may have made.

Shortcut: Ctrl+F4

Click the Save Changes toolbar button to save any changes you may have made to the Edit Connections form without closing the form.

Shortcut: Alt+S

Click the Print toolbar button to display the Print Options dialog box and print the default Connections report (as specified in the RELDBDBA.INI file). The initial default Connections report is Connections by Table Name report.

Shortcut: Alt+P

Click the Global Add toolbar button to display the Add Connections Matching Pattern dialog box, which contains options for the addition of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Edit menu), the Global Add button is enabled for global manipulation.

Shortcut: Alt+G

Click the Global Delete toolbar button to display the Delete Connections Matching Pattern dialog box, which contains options for the deletion of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Edit menu), the Global Delete button is enabled for global manipulation.

Shortcut: Alt+T

Click the Global Edit toolbar button to display the Edit Connections Matching Pattern dialog box, which contains options for the editing of table connections based on the matching of patterns within the table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Edit menu), the Global Edit button is enabled for global manipulation.

Shortcut: Alt+F

Click the Add Table Connection toolbar button to display the Add Table Connection dialog box, which contains options for the definition of a table connection for a selected table definition on the Edit Connections form.

Shortcut: Alt+A

Click the Delete Table Connection toolbar button to delete selected table connections for a selected table definition in the Edit Connections form.

Shortcut: Alt+D

Click the Edit Table Connection toolbar button to display the Edit Selected Table Connections dialog box, which contains options for the editing of selected path names and file labels (if file labels are in effect) in selected table connections of a table definition in the Edit Connections form.

Shortcut: Alt+E

Table

The Table area contains the names of the Relativity table definitions associated with one or more table connections. A table connection is composed of a table name (the name of an SQL table), a path name (the physical file-name of the data file), and a file label (if file labels are in effect).

How the information is displayed depends on how you open the form:

· When the Edit Connections form is opened by choosing the Connections command from the Edit menu in the DBA window, this area displays a hierarchical list of all the currently existing table definitions. To view an example, click here.

A plus sign [+] precedes each table definition in the list. To expand an item and display the table connection for a specific table definition, click the plus sign. (Conversely, click the minus sign [-] to collapse an item in the expanded list.) To view an example, click here.

· When the Edit Connections form is opened from the Tables tab in the Catalog window, this area displays only the associated table connection (that is, the table name, the path name, which is the physical file-name of the data file, and a file label, if file labels are in effect) for the selected table definition. To view an example, click here.

Note If you right-click any of the items in the list or expanded list, a pop-up context-sensitive menu is displayed for that item.


Connections by Table Name Report

Clicking Print on the Edit Connections form toolbar causes the output of a printed report containing information about the association of SQL table names and the file physical access names maintained in a Relativity catalog. The initial default Connections report (as specified in the RELDBDBA.INI file) is the Connections by Table Name report.

The following is an example of a Connections by Table Name report.


Edit Users Form

See Also

The Edit Users form provides the facility to define and maintain groups and users for a Relativity database. A database group name is the name of a group of users associated with a catalog. A user name is the name of a user associated with a group with a database. Each group name and user name within a catalog must be unique.

To open the Edit Users form in the Relativity DBA window:

· On the Edit menu, click Users.

· From the Users tab in the Catalog window, click New.

Note If the Print button is not available on the toolbar, see Configuring Report Capabilities.

The Edit Users form contains the following options.

Option | Description
 | The Close toolbar button closes the Edit Users form and saves any changes that you may have made. Shortcut: Ctrl+F4
 | The Print toolbar button displays the Print Options dialog box and prints the default Users report (as specified in the RELDBDBA.INI file). The initial default Users report is the All Users by User Name report. Shortcut: Alt+P
 | The Add Group toolbar button causes the display of the Add Database Group dialog box with options for the addition of a new database group and an expiration date for catalog access. Shortcut: Alt+G
 | The Delete Group toolbar button causes the deletion of the selected group and all its users from the Edit Users form. Shortcut: Alt+T
 | The Edit Group Password toolbar button causes the display of the Change Password dialog box. This dialog box contains options for the definition of a new password, verification of an existing password, and an expiration date for catalog access for the selected group in the Edit Users form. Shortcut: Alt+E
 | The Reset Group Password toolbar button causes the removal of the current password for the selected group in the Edit Users form. Shortcut: Alt+X
 | The Add User toolbar button causes the display of the Add Database User dialog box. This dialog box contains options for the addition of a new user to the selected group and an expiration date for catalog access in the Edit Users form. Each user name must be unique within the catalog. Shortcut: Alt+U
 | The Delete User toolbar button causes the deletion of a selected user from a group in the Edit Users form. Shortcut: Alt+D
 | The Edit User Password toolbar button causes the display of the Change Password dialog box. This dialog box contains options for the definition of a new password, verification of the password, and an expiration date for catalog access for one or more selected users within a selected group in the Edit Users form. Shortcut: Alt+J
 | The Reset User Password toolbar button causes the removal of the current password for one or more selected users within a selected group in the Edit Users form. Shortcut: Alt+Y
Group Name | The Group Name attribute is the name of a user group associated with the catalog. Each group name and user name within a catalog must be unique.
User Name | The User Name attribute is the name of a user associated with the selected user group. Each user name and group name within a catalog must be unique.


All Users by User Name Report

Clicking Print on the Edit Users form toolbar causes the output of a printed report containing information about users (a group is a user) maintained in a Relativity catalog. The initial default Users report (as specified in the RELDBDBA.INI file) is the All Users by User Name report.

The following is an example of an All Users by User Name report.


Edit Privileges Form

See Also

The Edit Privileges form provides the facility to define and maintain privileges of groups associated with a Relativity table definition.

To open the Edit Privileges form in the Relativity DBA window, do one of the following:

· On the Edit menu, click Privileges.

· From the Users tab in the Catalog window, click Privileges.

Note If the Print button is not available on the toolbar, see Configuring Report Capabilities.

The Edit Privileges form contains the following options.

Option

Description

The Close toolbar button closes the Edit Privileges form and saves any changes that you have made. However, if you have made any changes to the form, a message box appears prompting you to commit the privilege changes:

· Selecting Yes accepts the changes and then closes the form.

· Selecting No closes the form without applying any of the changes.

· Selecting Cancel ignores any changes and leaves the form open.

Shortcut: Ctrl+F4

The Save Changes toolbar button accepts all privileges defined in the Edit Privileges form for the groups of a database.

Shortcut: Alt+S

The Print toolbar button displays the Print Options dialog box and prints the default Privileges report (as specified in the RELDBDBA.INI file). The initial default Privileges report is the Privileges by Grantee report.

Shortcut: Alt+P

Group

The Group list on the Edit Privileges form contains the names of database groups associated with the catalog. This list contains the groups defined in the Edit Users form and a group called <PUBLIC>. Privileges assigned to the <PUBLIC> group become privileges assigned to all users in the database.

Privilege

The Privilege list on the Edit Privileges form contains the privileges that can either be granted or not granted to a database group associated with the catalog. There are five types of privileges for a Relativity database:

· Administrator privileges

· Create Users privilege

· Create Tables privilege

· Table privileges

· Column privileges

Note When a Column privilege is selected, a Table list (described below) is displayed to the right of the Privilege list in the Edit Privileges form.

The privilege you select in the Privilege list determines what appears in the Not Granted, Granted, and With Grant columns. For more information, click here.

Table

The Table list on the Edit Privileges form contains the names of all tables within the database. When a table is selected, the Not Granted column contains the names of all columns within the specified table. The Table list is displayed only when a Column privilege is selected.

Not Granted

The Not Granted column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group does not have access rights.

Granted

The Granted column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights.

With Grant

The With Grant column on the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights. The group also has the ability to grant those access rights to another group.

The Move Right button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Not Granted column to the Granted column.

Note Using the Move Right button to move an item from the Not Granted column to the Granted column is the equivalent of the action performed by the SQL GRANT statement without the WITH GRANT OPTION phrase. That is, the privilege is now in the state of having been granted.

The Move Left button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Granted column to the Not Granted column.

Note Using the Move Left button to move an item from the Granted column to the Not Granted column is the equivalent of the action performed by the SQL REVOKE statement. That is, the privilege is now revoked and is in the state of being not granted.

The Move Right button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the Granted column to the With Grant column.

Note Using the Move Right button to move an item from the Granted column to the With Grant column is equivalent to having specified the WITH GRANT OPTION phrase in the SQL GRANT statement. That is, the privilege is now in the state of having been granted with the grant option.

The Move Left button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the With Grant column to the Granted column.

Note Using the Move Left button to move an item from the With Grant column to the Granted column is the equivalent of the action performed by the SQL REVOKE statement specifying the GRANT OPTION FOR phrase (REVOKE GRANT OPTION FOR privilege-list ON object FROM user-list). That is, the privilege is again in the state of having been granted without the grant option.


Privileges by Grantee Report

Clicking Print on the Edit Privileges form toolbar causes the output of a printed report containing information about database, table, and column privileges maintained in a Relativity catalog. The initial default Privileges report (as specified in the RELDBDBA.INI file) is the Privileges by Grantee report.

The following is an example of a Privileges by Grantee report. For a chart listing the Privilege codes, click here.


Dialog Boxes

For information about specific options in the dialog boxes provided in the Relativity DBA, select one of the following topics.

Add Connections Matching Pattern Dialog Box

Add Database Group Dialog Box

Add Database User Dialog Box

Add Table Connection Dialog Box

Btrieve Key Import for filename Dialog Box (Micro Focus COBOL Only)

Change Catalog Owner Dialog Box

Change Password Dialog Box

Character Set Maintenance Dialog Box

Date Constants Dialog Box

Delete Connections Matching Pattern Dialog Box

Edit Connections Matching Pattern Dialog Box

Edit Selected Table Connections Dialog Box

Logon Dialog Box

Open Relativity Data Source Dialog Box

Print Options Dialog Box

Printer Choice Dialog Box

Save Export File As Dialog Box

Select Btrieve Data File for filename Dialog Box (Micro Focus COBOL Only)

Select Character Set Dialog Box

Select Report Dialog Box

Select Server Dialog Box

Status Report Dialog Box


Add Connections Matching Pattern Dialog Box

See Also

The Add Connections Matching Pattern dialog box displays options for the addition of table connections based on the matching of patterns within table names in the Edit Connections form.

To display this dialog box, select a table definition or table name on the Edit Connections form and click the Global Add toolbar button.

The Add Connections Matching Pattern dialog box contains the following options.

Option

Description

Match Table Name

If the check box preceding the Match Table Name box is selected, you can enter the matching pattern for the table name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.

Match Path Name

If the check box preceding the Match Path Name is selected, you can enter the matching pattern for the path name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.

Match File Label

If the check box preceding the Match File Label box is selected, you can enter the matching pattern for the file label item in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based.

Table Name

· The Table Name Replace box contains the pattern to be matched within the table name for replacement in the generation of a table name for the new table connection.

· The Table Name with box contains the pattern that is to replace the matching characters specified in the Table Name Replace box. The resulting table name becomes the table name for the new table connection.

Path Name

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.

File Label

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the generation of a file label for the new table connection.

· The File Label with box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the file label for the new table connection.

Note This option appears only if a file label item has been added to the FD on which the table is based.

Add Connections

The Add Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you click Save Changes on the Edit Connections form.

Cancel

The Cancel button closes the Add Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Add Database Group Dialog Box

See Also

The Add Database Group dialog box displays options for the entry of a new group name, an optional password, and an expiration date for access to a catalog for the group name. The expiration feature allows a group’s access privileges to be terminated without actually deleting the group from the catalog. Consequently, the group could be authorized access later at the same security level.

Note If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, click the Add Group toolbar button on the Edit Users form.

The Add Database Group dialog box contains the following options.

Option

Description

New Group Name

In the New Group Name box, type the name of the new group to be added to the list of database groups associated with the catalog. Each group name and user name must be unique within a catalog.

Password

In the Password box, type the password for the new group. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database Group dialog box must contain the same characters before the password is accepted for the group.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this field box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Add Database Group dialog box by accepting the new group name in the dialog box.

Cancel

The Cancel button backs out of the Add Database Group dialog box by canceling all entries made within the dialog box.


Add Database User Dialog Box

See Also

The Add Database User dialog box displays options for the entry of a new user name, an optional password, and an expiration date for access to a catalog for the user name. The expiration feature allows a user’s access privileges to be terminated without actually deleting the user ID from the group. Consequently, the user could be authorized access later at the same security level in the group.

Note An expiration date set on a user applies only to that user within the group. An expiration date set on a group, however, applies to all members of the group. If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, click the Add User toolbar button on the Edit Users form.

The Add Database User dialog box contains the following options.

Option

Description

New User Name

In the New User Name box, type the name of the new user to be added to the selected database group within the catalog. Each group name and user name must be unique within a catalog.

Password

In the Password box, type the password for the new user. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database User dialog box must contain the same characters before the password is accepted for the user.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the user name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this field box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Add Database User dialog box by accepting the new user name into the selected group.

Cancel

The Cancel button backs out of the Add Database User dialog box by canceling all entries made within the dialog box.


Add Table Connection Dialog Box

See Also

The Add Table Connection dialog box displays options for the definition of a table connection to be established for the table definition selected in the Edit Connections form.

To display this dialog box, do one of the following:

· Click the Add Table Connection toolbar button on the Edit Connections form.

· Click the Add Connections command button in the Add Connections Matching Pattern dialog box.

The Add Table Connection dialog box is displayed for each new table connection whenever the path name (or file label, if in effect) is not modified (that is, when the path name and/or file label replace pattern match fails to find a matching string in the existing table connection path name and/or file label). This represents the case where a new table name would be equivalent to an existing table name. You can do one of the following:

· Click Cancel to skip this table connection.

· Click Add Connection to accept the table connection.

· Select a different path name and click Add Connection to accept the modified table connection.

The Add Table Connection dialog box contains the following options.

Option

Description

Table Name

In the Table Name box, type the table name of the SQL table to be associated with the table connection being added to the selected table definition in the Edit Connections form.

Path Name

In the Path Name box, type, or select from the list, the path name to the data file. This path name is associated with the table connection being added to the selected table definition in the Edit Connections form. The path name is the physical filename of the data file.

Each unique file path name used in a table connection is added to the file connection list in the catalog. This list is used to provide the list for the Path Name box in the Add Table Connection dialog box. When a table connection is deleted and no other table connection refers to its file connection entry, a message box prompts whether the file connection should be deleted. If the file connection is deleted, it will no longer be available in the list for the Path Name box of the Add Table Connection dialog box, thus requiring that it be retyped into the box if another table connection is later added that uses the same file path name.

File Label

In the File Label box, type, or select from the list, the file label to be associated with the table connection being added to the selected table definition in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based.

Add Connection

The Add Connection button completes the Add Table Connection dialog box by accepting all entries made within the dialog box.

Cancel

The Cancel button backs out of the Add Table Connection dialog box by canceling all entries made within the dialog box.


Btrieve Key Import for filename Dialog Box (Micro Focus COBOL Only)

Note This feature is available only in Relativity for Micro Focus COBOL.

The Btrieve Key Import for filename dialog box allows the selection of a Btrieve data file so that the file's key structure can be imported into a Relativity catalog .

To display this dialog box, click Import Btrieve Keys on the Tools menu and close the message box that indicates the importing process has been initiated.

The Btrieve Key Import for filename dialog box contains the following options.

Option | Description
Keys to Import | The Keys to Import allows you to specify the filename and path of the Btrieve data file having the key structure you want to import into a Relativity catalog. Note that this filename must have the suffix .dat.
Browse | The Browse button displays the Select Btrieve Data File for filename dialog box, for the selection of the desired file.
Update Keys | The Update Keys button performs the importing of keys on the specified file.
Cancel | The Cancel button backs out of the dialog box by canceling the selections made within the dialog box and closing the dialog.


Change Catalog Owner Dialog Box

See Also

The Change Catalog Owner dialog box displays options for a new owner name and an optional password for a Relativity catalog. Note the following:

· If a catalog is unowned, then a database group can be specified as the catalog owner by making the appropriate entries in this dialog box.

· If a catalog has an owner and either the owner group or a user of the owner group is specified in the Logon dialog box, then the group owning the catalog can be changed by making the appropriate entries in this dialog box.

To display this dialog box, choose Change Catalog Owner on the File menu.

The Change Catalog Owner dialog box contains the following options.

Option | Description
Current Owner | The Current Owner box contains the name of the current owner of the catalog. If there is no current owner, the Current Owner box contains the text, < No Owner >.
New Owner Name | In the New Owner Name list, select the name of the new owner of the catalog. This list contains the name of database groups associated with the current catalog.
Password | In the Password box, type the password for the new owner. An asterisk (*) character is displayed for each character entered. This entry is optional.
OK | The OK button completes the Change Catalog Owner dialog box by accepting all entries made in the dialog box.
Cancel | The Cancel button backs out of the Change Catalog Owner dialog box by canceling all entries made in the dialog box.


Change Password Dialog Box

See Also

The Change Password dialog box contains options for the definition of a new password, verification of an existing password, and an expiration date for access to a catalog for the selected group name or user name. The expiration feature allows access privileges for a user or group to be terminated without actually deleting the user or group from the catalog. Consequently, the user or group could be authorized access later at the same security level.

Note An expiration date set on a user applies only to that user within the group. An expiration date set on a group, however, applies to all members of the group. If the access date for a group has expired, all of the privileges of the users in that group have also expired.

To display this dialog box, click either Edit Group Password or Edit User Password toolbar buttons on the Edit Users form.

The Change Password dialog box contains the following options.

Option

Description

User Name

The User Name box displays the name of the group or user whose password is to be changed.

New Password

In the New Password box, type a new password for the selected group or user. An asterisk (*) character is displayed for each character entered. This entry is optional.

Verify Password

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Change Password dialog box must contain the same characters before the password is accepted for the group or user.

Use Expiration

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected user name or group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.

OK

The OK button completes the Change Password dialog box by accepting all entries made within the dialog box.

Cancel

The Cancel button backs out of the Change Password dialog box by canceling all entries made within the dialog box.


Character Set Maintenance Dialog Box

The Character Set Maintenance dialog box lists the character sets in use in a Relativity data source. This dialog box also allows you to perform the following tasks:

· Add both standard and nonstandard character sets to a Relativity data source.

· Modify the character set associated with file definitions.

· Alter the location of the Euro character within a character set.

To display this dialog box, choose Character Sets from the Tools Menu.

The Character Set Maintenance dialog box contains the following options.

Option

Description

Add New Character Set

Use the Add New Character Set area to add either a nonstandard character set or a standard character set, or both, to a data source.

· The From CS File option allows you to add a nonstandard character set by clicking the Import button. A standard Windows dialog box is displayed that allows you to enter the name of the desired character set file. When you click Open on that dialog box, the new character set will appear in the Character Set column. To see a list of errors that can occur when a nonstandard character set is imported into a Relativity data source, click here.

Note The Import button provides the same functionality as the New button on the Select Character Set dialog box.

· The From List of Standard Character Sets list box displays a list of standard character sets supported by Relativity. Select the desired character set file. When you click the Add button, the new character set will appear in the Character Set column.

Modify Existing FD Character Set

Use the Modify Existing FD Character Set area to change an existing character set for all file definitions in a data source when the wrong character set is associated with those FDs. First, select the name of the character set that is currently associated with the file definitions from the Change From list box. Next, select the name of the character set that actually describes the data within the data source's files from the To list box. Then click the Change button. A Status Report dialog box shows a record of the action just taken.

Note This capability is different from that described in the procedure on how to modify an existing Relativity character set in the topic, Defining Nonstandard Character Sets, which has to do with modifying a character set in some way to suit a particular need.

Set Euro Character For Selected Character Set

Use the Set Euro Character for Selected Character Set area to change the location of the Euro character in a character set. Some COBOL applications supported the Euro character before the International Standards Organization decided its value in standard character sets. In such cases, Relativity must modify its understanding of the value of the Euro character within the standard character set.

To do this, select the character set whose definition for the Euro character will change from the Character Set column. Check the Enable Euro check box. In the edit box, enter the value that is used to represent the Euro character in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff). Click the Update button to change the value. The new value will appear in the Euro list to the right of the character set name in the Character Set column.

Character Set and Euro

In this area, the Character Set column lists all the character sets used in the data source.

The Euro column shows the value that is used to represent the Euro character for the selected character set in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff).


Date Constants Dialog Box

See Also

The Date Constants dialog box enables you to change the values or structures of the date constants:

· 'Days' Base Date

· 'YYYY' Base Year

· 'YY' Century Cutoff

· 'YY' Base Year

· 'YY' Dates

· 'YYYY' Dates

To display this dialog box, choose Date Constants on the Tools menu.

The Date Constants dialog box contains the following options.

Option

Description

'Days' Base Date

The 'Days' Base Date is changed either by typing or clicking on the arrows to indicate the year, month, and day for the date constant 'Days' Base Date. This date constant specifies the date used to interpret date values that represent an integer number of days from a base date in the Gregorian calendar. The default base Year is 1899. The default base Month is 12. The default base Day is 30. Using the default, an integer value of zero in the COBOL data item thus represents the date 30 December 1899, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.

'YY' Base Year

The 'YY' Base Year box is displayed on the second line of the Date Constants dialog box when the 'YY' Base Year option button is selected. The 'YY' Base Year is changed either by typing a two-digit year or clicking on the arrows to indicate the two-digit year. This date constant specifies the base year used to interpret date values containing a two-digit year. The default base year is 1900. The base year is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.

The selection of the 'YY' Base Year option button displays the 'YY' Base Year box on the second line of the Date Constants dialog box.

'YYYY' Base Year

The 'YYYY' Base Year is changed either by typing or clicking on the arrows to indicate the four-digit base year. This date constant specifies the base year used to interpret date values containing a four-digit year. The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.

'YY' Century Cutoff

The 'YY' Century Cutoff box is displayed on the second line of the Date Constants dialog box in place of the 'YY' Base Year box when the 'YY' Century Cutoff option button is selected. The 'YY' Century Cutoff is changed either by typing a two-digit value or clicking on the arrows to indicate the two-digit century cutoff. This date constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.

The selection of the 'YY' Century Cutoff option button displays the 'YY' Century Cutoff box on the second line in the Date Constants dialog box in place of the 'YY' Base Year box.

'YY' Dates

The structure of 'YY' Dates is selected from the 'YY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed. The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in their files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit-day of the month).

'YYYY' Dates

The structure of 'YYYY' Dates is selected from the 'YYYY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed. The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in their files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

Defaults

The Defaults button resets the values in the Date Constants dialog box to the default values.

OK

The OK button completes the Date Constants dialog box by accepting the values and structures specified in the dialog box.

Cancel

The Cancel button backs out of the Date Constants dialog box by canceling all selections made within the dialog box.


Delete Connections Matching Pattern Dialog Box

See Also

The Delete Connections Matching Pattern dialog box displays options for the deletion of table connections based on the matching of patterns within table names and/or path names in the Edit Connections form.

To display this dialog box, select a table definition or table name and then click the Global Delete toolbar button on the Edit Connections form .

The Delete Connections Matching Pattern dialog box contains the following options.

Option | Description
Match Table Name | If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for deletion of the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for deletion of the table connection.
Match Path Name | If the check box preceding Match Path Name box is selected, the matching pattern must be present in the path name for deletion of the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for deletion of the table connection.
Delete Connections | The Delete Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes button on the Edit Connections form.
Cancel | The Cancel button closes the Delete Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Edit Connections Matching Pattern Dialog Box

See Also

The Edit Connections Matching Pattern dialog box displays options for the editing of table connections based on the matching of patterns within the table names and/or path names in the Edit Connections form.

To display this dialog box, select a table definition or table name and then click the Global Edit toolbar button on the Edit Connections form .

The Edit Connections Matching Pattern dialog box contains the following options.

Option

Description

Match Table Name

If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for editing of the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for editing of the table connection.

Match Path Name

If the check box preceding the Match Path Name box is selected, the matching pattern must be present in the path name for editing of the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for editing of the table connection.

Path Name

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.

Edit Connections

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes toolbar button on the Edit Connections form.

Cancel

The Cancel button closes the Edit Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Edit Selected Table Connections Dialog Box

See Also

The Edit Selected Table Connections dialog box edits the path names and/or file label items, if defined, of selected table connections of a table definition in the Edit Connections form.

To display this dialog box, click the Edit Table Connection toolbar button on the Edit Connections form.

The Edit Selected Table Connections dialog box contains the following options.

Option

Description

Path Name

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the selected table connection.

· The Path Name With box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the new path name for the selected table connection.

And / Or

· Select the AND option to make replacements if the contents of both the Path Name Replace and File Label Replace boxes match an individual table connection.

· Select the OR option to make replacements if the contents of either the Path Name Replace or File Label Replace boxes match an individual table connection.

File Label

Note This area is enabled only if a file label item has been added to the FD on which the table is based.

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the selected table connection.

· The File Label With box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the new file label for the selected table connection.

Edit Connections

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes toolbar button on the Edit Connections form.

Cancel

The Cancel button closes the Edit Selected Table Connections dialog box and cancels all entries made within the dialog box.


Logon Dialog Box

See Also

When security has been defined for a catalog associated with a data source, the Logon dialog box provides for the entry of a user name and an optional password in order to gain access to the catalog.

Note The password is optional only if there is no password associated with the user name.

To display this dialog box, click Open in the Open Relativity Data Source dialog box. (Note that security must have been defined for the catalog.)

The Logon dialog box contains the following options.

Option | Description
Name | In the Name box, type the name of the user of the catalog. If privileges have been defined for the catalog, the user name must belong to a group having the Use Administrator privilege.
Password | In the Password box, type the password for the group or user. An asterisk (*) character is played for each character entered. This entry is optional.
OK | The OK button completes the Logon dialog box by accepting all entries made within the dialog box.
Cancel | The Cancel button backs out of the Logon dialog box by canceling all entries made in the dialog box.


Open Relativity Data Source Dialog Box

See Also

The Open Relativity Data Source dialog box allows selection of the data source that is to be processed by Relativity.

To display this dialog box, do one of the following:

· Successfully complete setting up a new Relativity data source.

· Choose Open Data Source on the File menu or select one of the most recently opened data sources from the numbered list to open a data source.

· Select the Existing option in the Welcome to Relativity window, choose one of the listed data sources, and then click OK.

The Open Relativity Data Source dialog box contains the following options.

Option

Description

Driver

If multiple ODBC drivers are installed on your system, you can select the appropriate driver from this Driver list in order to create and set up a new data source or open an existing data source.

Data Source Name

In the Data Source Name list, select the name of the data source for processing by Relativity.

Open

· If security has been defined for the catalog associated with the data source, the Open button displays the Logon dialog box, which provides for the entry of a user name and an optional password for the specified catalog.

· If security has not been defined for the catalog, the Open button opens the Catalog window in the Relativity Designer window.

Cancel

The Cancel button backs out of the Open Relativity Data Source dialog box by canceling the selections made within the dialog box.


Print Options Dialog Box

See Also

The Print Options dialog box allows you to specify a printer (or other export module) and printing options for the printing of a selected report. The name of the report that was selected for printing or exporting to another type of media is shown at the top portion of this dialog box.

To display this dialog box, perform any of the following actions:

· Click Print on the Reports tab in the Catalog window when a specific report description is selected.

Note If you click Print when a report category is selected (rather than a specific report description), a Select Report dialog box is displayed initially (the exact name of this dialog varies depending on the report category selected). You can then type or select a filename of the report definition file for the report be printed and click Open to display the Print Options dialog box.

· Click a report from a submenu after pointing to Connections, Privileges, or Users on the Reports menu.

· Click the Print toolbar button on the Edit Connections form, the Edit Privileges form, or the Edit Users form.

· Click Open from the Select Report dialog box after a report description has been selected for printing.

· Click Save from the Save Export File As dialog box after a report description has been selected for exporting to a comma-separated file.

The Print Options dialog box contains the following options.

Option

Description

Export Media

Use the Export Media area to select where to send (direct) output: to a printer, print preview, or to a file. The name of the selected (or default) printer is displayed in the top portion of this area.

· Click the Change button to display the Printer Choice dialog box, which allows you to specify a different printer.

· In addition to sending output to a printer or print preview, you may also direct output to numerous other file formats, including a PostScript printer file (.prn), Rich Text (.rtf), HTML, Adobe PDF, Multi-MIME HTML, XML, bitmap, JPEG-picture, or metafile (EMF) files. When you select a file format from the Direct to drop-down list, you can click the Export Options button to specify additional options for that particular file format (export module). After setting your file format options, you will be prompted to specify a name for the file in a Save As dialog box, or, in the case of a PostScript (.prn) file, the File for Printing dialog box.

· The Save options permanently check box allows you to save the settings you have selected for the printer or other export media. Note that this check box is unavailable unless the printer (and any printer settings) or export module options have been changed in the Printer Choice dialog box.

Options

The Options area allows the selection of what portion of the report to print or direct to an export module (a group of pages beginning with a specific page number; all pages; or a range of pages).

Start

The Start button sends the print job to the selected printer or export module.

Cancel

The Cancel button cancels the operation so the job is not sent to the printer or export module.


Printer Choice Dialog Box

The Printer Choice dialog box allows you to specify a different printer than the one shown on the Print Options dialog box, to change printer settings, and to designate whether you want portions of the report to go to different printers. Changing the printer, any printer settings, and/or the type of export media enables the Save options permanently check box on the Print Options dialog box.

To display this dialog box, click the Change button in the Export Media area of the Print Options dialog box.

The Printer Choice dialog box contains the following options.

Option | Description
Printer Page-Independent | The Printer Page-Independent option in the Printer Choice area relates to the printing of all pages of a report. Selecting this option enables a Select button.
Printer Page-Dependent | The Printer Page-Dependent option in the Printer Choice area relates to the printing of the first and following pages of a report on different printers. Selecting this option enables two Select buttons.
Select | The Select button displays a standard Windows dialog box that allows you to specify a printer and define its properties and paper settings (paper size, paper source, and paper orientation).
OK | The OK button completes the Printer Choice dialog box by accepting the selections made within the dialog box.
Cancel | The Cancel button backs out of the Printer Choice dialog box by canceling the selections made within the dialog box.


Save Export File As Dialog Box

See Also

The Save Export File As dialog box is a standard Windows Save As dialog box, which allows you to specify the filename for an exported comma-separated file for a selected report.

To display this dialog box, click a report from one of the submenus after pointing to Connections, Privileges, or Users on the Reports menu, and the Export command has been selected. (A check mark appears to the left of the command name to indicate that the export option is active. The export selection can be toggled by clicking the Export command on the Reports menu.)

After the Save Export File As dialog box is completed, the Print Options dialog box is displayed.

The Save Export File As dialog box contains the following options.

Option

Description

Save in

In the Save in list, select the drive and folder in which you want to save the file.

The Save in list box lists the available folders and files. To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

The box below lists the folders and files in the selected location. To open any folder or file, click its name in the list. To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the options available from the View Menu toolbar button.

File name

In the File name list box, type the name of the file into which the export (comma-separated) information is to be saved. This filename must have the extension .csv.

Save as type

In the Save as type list, select the filename extension from the list or type an extension. The extension for a comma-separated file is .csv.

Save

The Save button completes the Save Export File As dialog box by accepting all selections made within the dialog box and displays the Print Options dialog box.

Cancel

The Cancel button closes the Save Export File As dialog box without saving any changes you have made.


Select Btrieve Data File for filename Dialog Box (Micro Focus COBOL Only)

Note This feature is available only in Relativity for Micro Focus COBOL.

The Select Btrieve Data File for filename dialog box allows the selection of a Btrieve data file so that the file's key structure can be imported into a Relativity catalog .

To display this dialog box, click Browse on the Btrieve Key Import for filename dialog box.

The Select Btrieve Data File for filename dialog box contains the following options.

Option

Description

Look in

In the Look in list, select the drive and folder containing the Btrieve data file having the key structure you want to import into the Relativity catalog.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the View Menu toolbar button.

File name

In the File name list box, type or select (from the List area) the filename to be assigned to the Relativity catalog into which the Btrieve data file key structure is to be imported. This filename must have the .dat suffix.

Files of type

In the Files of type list, select Btrieve Data Files (*.dat).

Open as read-only

The Open as read-only check box is not functional in this context and has no effect on the importing process.

Open

The Open button closes the Select Btrieve Data File for filename dialog box. The name of the selected file is displayed in the Keys to Import text box on the Btrieve Key Import for filename dialog box.

Cancel

The Cancel button backs out of the Select Btrieve Data File for filename dialog box by canceling the selections made within the dialog box.


Select Character Set Dialog Box

See Also

The Select Character Set dialog box permits the selection of the appropriate character set.

The Select Character Set dialog box is displayed when:

· Upgrading a catalog from a version of Relativity that did not include character set support to a version that does include character set support. The catalog conversion process will associate the selected character set with all of the file definitions in the catalog.

· More than one catalog is involved in an operation, and one or more of the catalogs has not been upgraded to the current version. For example, this would occur only if the catalog distributor has enabled the Catalog Merge capability. See the description of Merge Catalog on the File menu.

The Select Character Set dialog box contains the following options.

Option

Description

Character Set

In the Character Set box, type, or select from the list, the code pages that are known by Relativity. The defined code page number for each character set will be displayed to the right in parentheses. To view the standard character sets supported by Relativity, click here.

OK

The OK button completes the Select Character Set dialog box by associating the selected code page entries with all of the file definitions in the catalog.

New

The New button displays a standard Windows dialog box that allows you to specify the file that contains the character set you want to use. Character set files have the extension, .cs.

Note This button provides the same functionality as the Import button on the Character Set Maintenance dialog box.

Help

The Help button displays the related Help screen and provides information about the Select Character Set dialog box.

Cancel

The Cancel button backs out of the Select Character Set dialog box by canceling the selections made within the dialog box.


Select Report Dialog Box

See Also

The Select Report dialog box displays options for the selection of a Relativity report to edit. Note that the exact name of this dialog box varies depending on the report category selected.

To display this dialog box, point to Edit on the Reports menu. From the submenu that lists the report categories (Connections, Privileges, and Users), click the category of report to be edited.

The Select Report dialog box contains the following options.

Option

Description

Look in

The Look in list box indicates the current location of the report definition file for the specified report category.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.

Toolbar

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.

List

The List area displays a list of all the report definition files for the specified file type in the currently selected location. You can toggle the manner in which information is displayed in this area with the View Menu toolbar buttons.

File name

In the File name list box, type or select the filename of a report definition file. This filename must have the extension specified in the Files of type list.

Files of type

The Files of type list displays the default filename extension of the report definition file for the selected report category.

Open

When a report is specified in the File name box, click the Open button to access the Report Editor.

Cancel

The Cancel button backs out of the Select Report dialog box by canceling the selections made within the dialog box.

Preview

In the right half of the dialog box, the Preview area displays a thumbnail version and the name of the of the selected report definition file as you move from file to file in the List area.


Select Server Dialog Box

See Also

The Select Server dialog box is displayed when you launch the Relativity Server Administrator utility by clicking Server Admin on the Tools menu from within the Relativity DBA. (The Relativity Server Administrator utility applet, Relativity Server, is also accessible from the Windows Control Panel.)

Note This command and utility are available only in client/server configurations of Relativity.

This utility allows you to define a Windows NT or UNIX server for the Relativity Data Client data source and to configure a Relativity Data Server data source on a Windows NT or UNIX server for the Data Client. It is also used to verify communications between a Relativity Data Client data source and the Relativity Data Server data source.

For detailed information about the Relativity Server Administrator utility, see the Relativity Server Administrator online help file. (To access this help file, click either Help in this dialog box or Server Admin Help File from the Help menu in the Relativity DBA window.)


Status Report Dialog Box

Several batch file processes in the Relativity DBA report the successful completion of the operation when it is finished. In the Relativity DBA, the procedures related to the global adding and editing of table connections with matching patterns as well as those related to maintaining character sets report their results in a Status Report dialog box.

A Status Report dialog box contains the following information and options.

Option

Description

List

Each Status Report dialog box displays similar information in the List area: the type of operation, the location of the output file, if appropriate, the results of the operation, and any messages or possible errors that may be relevant.

Color values are used to display the results: blue text indicates the operation that was performed, black text indicates the results of the operation, and red text indicates any error or diagnostic messages that occurred.

The ending date and time are also included.

The Close toolbar button dismisses the Status Report dialog box.

The Save Changes toolbar button allows you to save the information displayed in this dialog box.

The Print toolbar button enables you to print the information in the dialog box.


Glossary of Terms

The glossary terms used in Relativity are listed below alphabetically.

88-level

AirlineDate

attribute

catalog

COBOL schema

COBOL schema file

COBOL table

CombineDateTime

Complement

ComputeCenturyDate

ComputeCenturyDateTime

ComputeDate

ComputeDateTime

ComputeODO

ComputeTime

Constrain property

condition item

condition-name

conditional variable

data item

data source

data-name

database

date constants

domain

file connection

file label item

filter

filter subexpression

function

function item

indexed file

internal function

ISAM file

IsNumeric

IsValidDate

item pattern

item set

LogicalAnd

LogicalOr

null

nullable

ODBC

ODBC data type

ODBC-enabled application

ODO control item

Open Database Connectivity

parallel OCCURS

RDBMS

record type

record type filter

redundant data items

relational database

relational database management system

relational table

Relativity Data Client

Relativity Data Manager

Relativity Data Server

Relativity DBMS

Relativity Symbol Table file

repeating data item

SQL

Structured Query Language

subscript item

subscripted data item

table

table connection

table definition

table filter

table name

transform

user data type


Add Connection (Add Table Connection Regular)

The Add Connection button completes the Add Table Connection dialog box by accepting all entries made within the dialog box.


Add Connections (Add Connections Matching Pattern)

The Add Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you click Save Changes on the Edit Connections form.


Add Connections Matching Pattern Dialog Box DBA See Also

Add table connections with matching patterns

Establishing Table Connections

Pattern Matching


Add Database Group Dialog Box DBA See Also

Defining Groups and Users


Add Database User Dialog Box DBA See Also

Defining Groups and Users


Add Group (Edit Users Form DBA)

The Add Group toolbar button causes the display of the Add Database Group dialog box with options for the addition of a new database group to the catalog.

Shortcut: Alt+G


Add New Character Set (Character Set Maintenance)

Use the Add New Character Set area to add either a nonstandard character set or a standard character set, or both, to a data source.

· The From CS File option allows you to add a nonstandard character set by clicking the Import button. A standard Windows dialog box is displayed that allows you to enter the name of the desired character set file. When you click Open on that dialog box, the new character set will appear in the Character Set column. To see a list of errors that can occur when a nonstandard character set is imported into a Relativity data source, click here.

Note The Import button provides the same functionality as the New button on the Select Character Set dialog box.

· The From List of Standard Character Sets list box displays a list of standard character sets supported by Relativity. Select the desired character set file. When you click the Add button, the new character set will appear in the Character Set column.


Add Table Connection Dialog Box DBA See Also

Add a table connection

Establishing Table Connections


Add Table Connection (Edit Connections Form DBA)

Click the Add Table Connection toolbar button to display the Add Table Connection dialog box, which contains options for the definition of a table connection for a selected table definition on the Edit Connections form.

Shortcut: Alt+A


Add User (Edit Users Form DBA)

The Add User toolbar button causes the display of the Add Database User dialog box. This dialog box contains options for the addition of a new user to the selected group in the Edit Users form. Each user name must be unique within the catalog.

Shortcut: Alt+U


Administration Forms DBA See Also

Options Dialog Box

Setting Options


Apply Command Button (System Options DBA)

The Apply button saves the settings specified for options in the Options dialog box without closing the dialog box.


Bypass Version Checking (System Options DBA)

This option is reserved for future use.


Cancel (Add Connections Matching Pattern)

The Cancel button closes the Add Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Cancel (Add Database Group)

The Cancel button backs out of the Add Database Group dialog box by canceling all entries made within the dialog box.


Cancel (Add Database User)

The Cancel button backs out of the Add Database User dialog box by canceling all entries made within the dialog box.


Cancel (Add Table Connection Regular)

The Cancel button backs out of the Add Table Connection dialog box by canceling all entries made within the dialog box.


Cancel (Change Catalog Owner)

The Cancel button backs out of the Change Catalog Owner dialog box by canceling all entries made in the dialog box.


Cancel (Change Password)

The Cancel button backs out of the Change Password dialog box by canceling all entries made within the dialog box.


Cancel Command Button (System Options DBA)

The Cancel button closes the Options dialog box without saving any changes.


Cancel (Date Constants)

The Cancel button backs out of the Date Constants dialog box by canceling all selections made within the dialog box.


Cancel (Delete Connections Matching Pattern)

The Cancel button closes the Delete Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Cancel (Edit Connections Matching Pattern)

The Cancel button closes the Edit Connections Matching Pattern dialog box by canceling all entries made within the dialog box.


Cancel (Edit Selected Table Connections)

The Cancel button closes the Edit Selected Table Connections dialog box and cancels all entries made within the dialog box.


Cancel (Logon)

The Cancel button backs out of the Logon dialog box by canceling all entries made in the dialog box.


Cancel (Open Relativity Data Source)

The Cancel button backs out of the Open Relativity Data Source dialog box by canceling the selections made within the dialog box.


Cancel (Printer Choice)

The Cancel button backs out of the Printer Choice dialog box by canceling the selections made within the dialog box.


Cancel (Print Options)

The Cancel button cancels the operation so the job is not sent to the printer or export module.


Cancel (Save Export File As)

The Cancel button closes the Save Export File As dialog box without saving any changes you have made.


Cancel (Select Character Set)

The Cancel button backs out of the Select Character Set dialog box by canceling the selections made within the dialog box.


Cancel (Select Report)

The Cancel button backs out of the Select Report dialog box by canceling the selections made within the dialog box.


Cancel (Welcome to Relativity Window)

The Cancel button cancels all selections and closes the Welcome to Relativity window.


Catalog Ownership DBA See Also

Database Administration

Defining Catalog Ownership

Defining Group Privileges

Defining Groups and Users


Categories of DSNS in DBA

ODBC introduced the differentiation of data source names (DSNs) beginning in version 2.5. DSNs are divided into three categories: User, System, and File.

· User DSNs are local to a computer and may be used only by the current user.

· System DSNs are local to a computer rather than dedicated to a user. The system, or any user having privileges, can use a data source set up with a system DSN.

· File DSNs are file-based data sources that may be shared among all users who have the same Relativity DBMS installed, which means they have access to the database. File DSNs need not be dedicated to a user or local to a computer.


Change Catalog Owner Dialog Box DBA See Also

Catalog Ownership

Defining Catalog Ownership


Change Password Dialog Box DBA See Also

Defining Groups and Users

Change a group password

Change a user password


Change (Print Options)

The Change button displays Printer Choice dialog box, which allows you to specify a different printer.


Character Set and Euro Columns (Character Set Maintenance)

In this area, the Character Set column lists all the character sets used in the data source.

The Euro column shows the value that is used to represent the Euro character for the selected character set in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff).


Character Set (Select Character Set)

In the Character Set box, type or select from the list the code pages that are known by Relativity. The defined code page number for each character set will be displayed to the right in parentheses. Relativity supports the following standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |


Close (Edit Connections Form DBA)

Click the Close toolbar button to close the Edit Connections form and save any changes that you may have made.

Shortcut: Ctrl+F4


Close (Edit Privileges Form DBA)

The Close toolbar button closes the Edit Privileges form. However, if you have made any changes to the form, a message box appears prompting you to commit the privilege changes:

· Selecting Yes accepts the changes and then closes the form.

· Selecting No closes the form without applying any of the changes.

· Selecting Cancel ignores any changes and leaves the form open.

Shortcut: Ctrl+F4.


Close (Edit Users Form DBA)

The Close toolbar button closes the Edit Users form and saves any changes that you have made.

Shortcut: Ctrl+F4


Closing a Data Source DBA See Also

Configuring a Relativity Data Source

Opening a Data Source


Column All

The Column ALL privilege is a shortcut method of assigning all the Column privileges (SELECT, INSERT, UPDATE, and REFERENCES) at one time. When the Column:ALL privilege is selected, the column names associated with the selected table are displayed in the leftmost applicable column; that is, if any Column privilege is not granted, the column names are displayed in the Not Granted column (but some individual privileges may be granted). If any Column privilege is not granted with grant, then column names are displayed in the Granted column (but some individual privileges may be granted with grant). Finally, if all Column privileges are granted with grant, column names are displayed in the With Grant column.

When Column:ALL is selected, a column name can be moved from the Not Granted column to the Granted column in order to grant all the individual Column privileges for the selected table to the selected group. Then the user may select an individual Column privilege, for example, Column:select, and move the same column name from the Granted column to the With Grant column. If the user then selects the Column:ALL privilege again, that column name will still be displayed in the Granted column (not the With Grant column), even though the group has with grant privilege for the Column:select privilege.

Then, the user may select an individual Column privilege, for example, Column:insert, and move the same column name from the Granted column to the Not Granted column. In this case, if the user then selects the Column:ALL privilege again, that column name will be displayed in the Not Granted column, even though the group still has the privileges other than Column:insert for the table. This is because the group no longer has all Column privileges for the table.

Moving a column name from the Granted column to the Not Granted column when Column:ALL is selected resets all the Column privileges to Not Granted (including any individual Column privileges that were assigned With Grant).


Configuring a Relativity Data Source DBA See Also

Defining Groups and Users

System Options


Configuring Report Capabilities DBA See Also

Customizing the Initialization File (RELDBDBA.INI)

Exporting Data to a Comma-Separated File

Report Definition Files

Reporting


Connection Menu Commands DBA See Also

Establishing Table Connections

Pattern Matching


Connections Report Features DBA See Also

Establishing Table Connections

Reporting


Connections (Tables Tab DBA)

The Connections button displays the Edit Connections form for the selected table. If a table is not selected in the Table Name area list, the Connections button is disabled.

Note The Connections command on the Edit menu provides the same functionality as the Connections button when a table is selected. If you choose the Connections command from the Edit menu without first selecting a table on the Tables tab, however, the Edit Connections form lists all the tables currently defined in the catalog.


Current Owner (Change Catalog Owner)

The Current Owner box contains the name of the current owner of the catalog. If there is no current owner, the Current Owner box contains the text, < No Owner >.


Database Administration DBA See Also

Catalog Ownership

Defining Group Privileges

Defining Groups and Users


Data File Format (System Options DBA)

The Data File Format list on the System page of the Options dialog box indicates the data file format that is to be used to open Micro Focus COBOL indexed files. The Micro Focus file manager must know the format of the indexed file so that the proper indexed file support can be used. The valid values are < none >, BTRIEVE, C-ISAM, LEVELII COBOL, IDX4, IDX8, and Default.

Note These formats are available for selection only when Micro Focus COBOL is the COBOL dialect in use. For more information about how Relativity determines which indexed file format to request, click here.


Data Source Name (Open Relativity Data Source)

In the Data Source Name list, select the name of the data source for processing by Relativity.


Data Source Name (System Options DBA)

The Data Source Name box on the System page of the Options dialog box displays the name of the data source being processed by the Relativity DBA.


Date Constants Dialog Box DBA See Also

Defining Date Constants


'Days' Base Date

The 'Days' Base Date is changed either by typing the value in the box or clicking on the arrows to indicate the year, month, and day for the date constant 'Days' Base Date. This date constant specifies the date used to interpret date values that represent an integer number of days from a base date in the Gregorian calendar. The default base year is 1899. The default base month is 12. The default base day is 30. Using the default, an integer value of zero in the COBOL data item thus represents the date 30 December 1899, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.


Debug Log (System Options DBA)

The Debug Log check box appears on the System page of the Options dialog box only when you have modified the [Administrator] section of the RELDBDBA.INI file by changing the value of the DebugLog= entry to YES.

Note This option is used for debugging purposes and runs the Relativity DBA in trace mode. It should be enabled only when directed by a Liant technical support analyst.


Defaults (Date Constants)

The Defaults button resets the values in the Date Constants dialog box to the default values.


Defining Catalog Ownership DBA See Also

Catalog Ownership

Defining Groups and Users


Defining Date Constants DBA See Also

Maintaining the Relativity Database


Defining Group Privileges DBA See Also

Privileges by Grantee Report

Privileges Report Features

System Options


Defining Groups and Users DBA See Also

All Users by User Name Report

Catalog Ownership

Database Administration

Defining Catalog Ownership


Defining Nonstandard Character Sets DBA See Also

Maintaining Character Sets


Definition Character Set for Select Character Set Dialog Box

Typically, a character set is a collection of graphical symbols, called Glyphs, which are used to communicate in a language. In order to represent the Glyphs in a computer, they must be associated with a numerical value, called a Code Point, for storage. In modern computers, the Code Points are stored in individual, 8-bit bytes of memory allowing 256 Glyphs to be represented. Relativity uses the term “character set” to refer to Glyphs and their associated Code Points.

On IBM PCs, the term “Code Page” is commonly used to describe this mapping of Glyphs to Code Points. However, on UNIX-based machines, it is more common to use the ISO 8859 standard to describe this mapping. Relativity provides character sets for both of these standards.

Relativity uses the character set of each file in order to interpret the Code Points stored within it. For example, if your data is in English and resides on Windows or DOS, selecting the character set for Code Page 437 would be appropriate. If your data is in English and resides on UNIX, the character set for ISO 8859-1 (otherwise known as Latin 1) would be appropriate.


Delete Connections (Delete Connections Matching Pattern)

The Delete Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes button on the Edit Connections form.


Delete Connections Matching Pattern Dialog Box DBA See Also

Delete table connections with matching patterns

Establishing Table Connections

Pattern Matching


Delete Group (Edit Users Form DBA)

The Delete Group toolbar button causes the deletion of the selected group and all its users from the Edit Users form.

Shortcut: Alt+T


Delete Table Connection (Edit Connections Form DBA)

Click the Delete Table Connection toolbar button to delete selected table connections for a selected table definition in the Edit Connections form.

Shortcut: Alt+D.


Delete User (Edit Users Form DBA)

The Delete User toolbar button causes the deletion of a selected user from a group in the Edit Users form.

Shortcut: Alt+D


Delete (Users Tab DBA)

The Delete button removes the selected group or user from the catalog. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.


Driver List Box (Welcome to Relativity Window)

If multiple drivers are installed on your system, you can select the appropriate driver from the Driver list box in order to create and set up a new data source or open an existing data source.


Driver (Open Relativity Data Source)

If multiple ODBC drivers are installed on your system, you can select the appropriate driver from this list in order to create and set up a new data source or open an existing data source.


Drives (Save Export File As)

In the Drives list, select the drive on which you want to save the file.


Drives (Select Report)

In the Drives list, select the drive containing the desired report definition files.


Edit Connections (Edit Connections Matching Pattern)

The Edit Connections button displays a Status Report dialog box, which shows a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes button on the Edit Connections form.


Edit Connections (Edit Selected Table Connections)

The Edit Connections button displays a Status Report dialog box, which displays a record of the action just taken. Note that changes reported on the Status Report dialog box are not committed to the catalog until you press the Save Changes button on the Edit Connections form.


Edit Connections Form DBA See Also

Connections by Table Name Report

Establishing Table Connections

Pattern Matching


Edit Connections Matching Pattern Dialog Box DBA See Also

Edit table connections with matching patterns

Establishing Table Connections

Pattern Matching


Edit Group Password (Edit Users Form DBA)

The Edit Group Password toolbar button causes the display of the Change Password dialog box. This dialog box contains options for the definition of a new password and verification of an existing password for the selected group in the Edit Users form.

Shortcut: Alt+E


Edit Privileges Form DBA See Also

Defining Group Privileges

Privileges by Grantee Report

System Options


Edit Selected Table Connections Dialog Box DBA See Also

Edit selected table connections

Establishing Table Connections


Edit Table Connection (Edit Connections Form DBA)

Click the Edit Table Connection toolbar button to display the Edit Selected Table Connections dialog box, which contains options for the editing of selected path names and file labels (if file labels are in effect) in selected table connections of a table definition in the Edit Connections form.

Shortcut: Alt+E


Edit User Password (Edit Users Form DBA)

The Edit User Password toolbar button causes the display of the Change Password dialog box. This dialog box contains options for the definition of a new password and a verify password for one or more selected users within a selected group in the Edit Users form.

Shortcut: Alt+J


Edit Users Form DBA See Also

All Users by User Name Report

Defining Groups and Users


Establishing Table Connections An Overview DBA See Also

Connections Report Features

Maintaining the Relativity Database, An Overview

Pattern Matching


Existing (Welcome to Relativity Window)

Select the Existing option to open and maintain an existing catalog that supports the Relativity database specified by the data source. When you select this option, a list of all the existing data sources are displayed in the List area. If you have multiple drivers installed, a list will appear in the window, indicating that the existing catalogs displayed are associated with the data source for the selected driver.

To quickly open one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened. For more information, see Opening a Data Source.

Note This option provides the same functionality as the Open Data Source command on the File menu.


Exporting Data to a Comma-Separated File DBA See Also

Configuring Report Capabilities

Reporting

Reports Menu Commands


Export Media (Print Options)

Use the Export Media area to select where to send (direct) output: to a printer, print preview, or to a file. The name of the selected (or default) printer is displayed in the top portion of this area.

Click the Change button to display the Printer Choice dialog box, which allows you to specify a different printer.

In addition to sending output to a printer or print preview, you may also direct output to numerous other file formats, including the following:

· PostScript printer file (.prn)

· Rich Text (.rtf)

· HTML

· Adobe PDF

· Multi-MIME HTML

· XML

· Bitmap

· JPEG-picture

· Metafile (EMF) files

When you select a file format from the drop-down list, you can click the Export Options button to specify additional options for that particular file format (export module). After setting your file format options, you will be prompted to specify a name for the file in a Save As dialog box, or, in the case of a PostScript (.prn) file, the File for Printing dialog box.


Export (Reports Tab DBA)

The Export button displays the Save Export File As dialog box for the output of a comma-separated value (CSV) file. After you complete the Save Export File As dialog box, the Print Options dialog box is displayed. You must also print the report in order to write the CSV file. See Exporting Data to a Comma-Separated File for more information on how to export data.

Note If a report category is selected instead of a specific report description, the Select Report dialog box is displayed after you complete the Save Export File As dialog box. After you select a specific report definition file, the Print Options dialog box is displayed.


File Label (Add Table Connection Regular)

In the File Label box, type, or select from the list, the file label to be associated with the table connection being added to the selected table definition in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based.


File Label AND OR Edit Selected Table Connections

· Select the AND option to make replacements if the contents of both the Path Name Replace and File Label Replace boxes match an individual table connection.

· Select the OR option to make replacements if the contents of either the Path Name Replace or File Label Replace boxes match an individual table connection.


File Label Replace With (Add Connections Matching Pattern)

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the generation of a file label for the new table connection.

· The File Label with box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting path name becomes the path name for the new table connection.

Note This option appears only if a file label item has been added to the FD on which the table is based.


File Label Replace With (Edit Selected Table Connections)

Note This area is enabled only if a file label item has been added to the FD on which the table is based.

· The File Label Replace box contains the pattern to be matched within the file label for replacement in the selected table connection.

· The File Label With box contains the pattern that is to replace the matching characters specified in the File Label Replace box. The resulting file label becomes the new file label for the selected table connection.


File Name (Save Export File As)

In the File name list box, type the name of the file into which the export (comma-separated) information is to be saved. This filename must have the extension .csv.


File name (Select Report)

In the File name list box, type or select the filename of a report definition file. This filename must have the extension specified in the Files of type list.


Files of type (Select Report)

The Files of type list displays the default filename extension of the report definition file for the selected report category.


Global Add (Edit Connections Form DBA)

Click the Global Add toolbar button to display the Add Connections Matching Pattern dialog box, which contains options for the addition of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Edit menu), the Global Add button is enabled for global manipulation.

Shortcut: Alt+G


Global Delete (Edit Connections Form DBA)

Click the Global Delete toolbar button to display the Delete Connections Matching Pattern dialog box, which contains options for the deletion of table connections based on the matching of patterns within table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Edit menu), the Global Delete button is enabled for global manipulation.

Shortcut: Alt+T


Global Edit (Edit Connections Form DBA)

Click the Global Edit toolbar button to display the Edit Connections Matching Pattern dialog box, which contains options for the editing of table connections based on the matching of patterns within the table names and/or path names on the Edit Connections form. When all existing table definitions are accessible from the Edit Connections form (for example, when the form is opened by the Connections command on the Edit menu), the Global Edit button is enabled for global manipulation.

Shortcut: Alt+F


Granted and Not Granted Privileges List

The privilege you select in the Privilege list determines what appears in the Not Granted, Granted, and With Grant columns, as described in the following table.

When you select the following privilege | These items appear in the Not Granted, Granted, and With Grant columns
Administrator | Privileges: Create Groups, Date Constants, Reports, Use Administrator
Create Users | Group names
Create Tables | Table definition names
Table | Table names
Column | Column names (from the table definition associated with the table name selected in the Table list that is displayed when a Column privilege is selected)


Granted (Edit Privileges Form DBA)

The Granted column in the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights.


Group List (Edit Privileges Form DBA)

The Group list in the Edit Privileges form contains the names of database groups associated with the catalog. This list contains the groups defined in the Edit Users form and a group called <PUBLIC>. Privileges assigned to the <PUBLIC> group become privileges assigned to all users in the database.


Group Name (Edit Users Form DBA)

The Group Name attribute on the Edit Users form is the name of a user group associated with the catalog. Each group name and user name within a catalog must be unique.


Help Button Bar DBA See Also

Using Relativity Help


Help Menu Commands DBA See Also

Using Relativity Help


Help (Select Character Set)

The Help button displays the related Help screen and provides information about the Select Character Set dialog box.


Independent 'SELECT' Privileges (System Options DBA)

In a Relativity data source, a given group may have access rights or privileges to a table and to a column within a table. By default, when the DBA is requested to give INSERT, UPDATE, REFERENCES, or DELETE privileges to a table or column, the DBA also automatically (and without being requested to do so) gives a SELECT privilege (an independent privilege) to that same table or column. This occurs because the INSERT, UPDATE, REFERENCES, or DELETE privileges are of little use if the data in the table or column cannot be seen as well.

When the Independent 'SELECT' Privilege option is enabled on the System page of the Options dialog box, the DBA will stop automatically granting the SELECT privilege when INSERT, UPDATE, REFERENCES, or DELETE privileges are granted.

To see how the Table and Column privileges (accessed through the Privilege list on the Edit Privileges form) are affected when this check box:

· is selected, click here.

· is not selected, click here.


List Area (Save Export As)

The List area displays all the folders and files in the selected location. To open any folder or file, click its name in the list. You can toggle the manner in which information is displayed in this area with the options available from the View Menu toolbar button.


List Area (Select Report)

The List area displays a list of all the report definition files for the specified file type in the currently selected location. You can toggle the manner in which information is displayed in this area with the List and Details toolbar buttons.


List Area (Welcome to Relativity Window)

If the New option is selected, the List area allows you to select the appropriate driver (if multiple drivers are installed on your system) and then create a new data source. To see an example, click here.

If either the Existing or Recent option is selected, the List area allows you to quickly open an existing or reopen a most recently used data source. Note that if a data source is selected from this list, any open, existing data source is closed, and the selected data source is opened.

The data sources displayed in this list depend on which option is selected:

· If the Existing option is selected, the list displays the available catalogs associated with the data source (for the selected driver, if necessary).

· If the Recent option is selected, the list displays up to the last four data sources recently opened by the Relativity DBA. The default number of data sources displayed is four. This number can be adjusted by adding the following entry (or modifying an existing entry) in the [DBA] section of the RELDBDBA.INI file:

RecentFileCount=n

where n is a number from 0 to 9.


Logon Dialog Box DBA See Also

Change Catalog Owner Dialog Box

Configuring a Relativity Data Source

Defining Catalog Ownership

Defining Groups and Users

Defining Security for Relativity Catalogs

Opening a Data Source

Setting Up a New Data Source


Look In (Select Report)

The Look in list box indicates the current location of the report definition file for the specified report category.

· To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

· To open the folder one level higher, click the Up One Level toolbar button.


Maintaining Character Sets DBA See Also

Defining Nonstandard Character Sets


Match File Label (Add Connections Matching Pattern)

If the check box preceding the Match File Label box is selected, you can enter the matching pattern for the file label item in the Edit Connections form.

Note This box appears only if a file label item has been added to the FD on which the table is based.


Match Path Name (Add Connections Matching Pattern)

If the check box preceding the Match Path Name box is selected, you can enter the matching pattern for the path name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.


Match Path Name (Delete Connections Matching Pattern)

If the check box preceding Match Path Name box is selected, the matching pattern must be present in the path name for deletion of the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for deletion of the table connection.


Match Path Name (Edit Connections Matching Pattern)

If the check box preceding the Match Path Name box is selected, the matching pattern must be present in the path name for editing of the table connection. The Match Path Name box specifies the matching pattern that must be present in the path name for editing of the table connection.


Match Table Name (Add Connections Matching Pattern)

If the check box preceding the Match Table Name box is selected, you can enter the matching pattern for the table name in the Edit Connections form. Each occurrence of the matching pattern within table names in the Edit Connections form results in the addition of a table connection with the specified table name and path name.


Match Table Name (Delete Connections Matching Pattern)

If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for deletion of the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for deletion of the table connection.


Match Table Name (Edit Connections Matching Pattern)

If the check box preceding the Match Table Name box is selected, the matching pattern must be present in the table name for editing of the table connection. The Match Table Name box specifies the matching pattern that must be present in the table name for editing of the table connection.


Modify Existing FD Character Set (Character Set Maintenance)

Use the Modify Existing FD Character Set area to change an existing character set for all file definitions in a data source when the wrong character set is associated with those FDs. First, select the name of the character set that is currently associated with the file definitions from the Change From list box. Next, select the name of the character set that actually describes the data within the data source's files from the To list box. Then click the Change button. A Status Report dialog box shows a record of the action just taken.

Note This capability is different from that described in the procedure on how to modify an existing Relativity character set, in the topic Defining Nonstandard Character Sets, which has to do with modifying a character set in some way to suit a particular need.


Move Left Button Not Granted and Granted (Edit Privileges Form DBA)

The Move Left button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Granted column to the Not Granted column.

Note Using this button to move an item from the Granted column to the Not Granted column is the equivalent of the action performed by the SQL REVOKE statement. That is, the privilege is now revoked and is in the state of being not granted.


Move Left Granted and With Grant (Edit Privileges Form DBA)

The Move Left button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the With Grant column to the Granted column.

Note Using this button to move an item from the With Grant column to the Granted column is the equivalent of the action performed by the SQL REVOKE statement specifying the GRANT OPTION FOR phrase (REVOKE GRANT OPTION FOR privilege-list ON object FROM user-list). That is, the privilege is again in the state of having been granted without the grant option.


Move Right Button Granted and With Grant (Edit Privileges Form DBA)

The Move Right button between the Granted and With Grant columns on the Edit Privileges form moves the selected item(s) from the Granted column to the With Grant column.

Note Using this button to move an item from the Granted column to the With Grant column is equivalent to having specified the WITH GRANT OPTION phrase in the SQL GRANT statement. That is, the privilege is now in the state of having been granted with the grant option.


Move Right Button Not Granted and Granted (Edit Privileges Form DBA)

The Move Right button between the Not Granted and Granted columns on the Edit Privileges form moves the selected item(s) from the Not Granted column to the Granted column.

Note Using this button to move an item from the Not Granted column to the Granted column is the equivalent of the action performed by the SQL GRANT statement without the WITH GRANT OPTION phrase. That is, the privilege is now in the state of having been granted.


Name (Logon)

In the Name box, type the name of the user of the catalog. If privileges have been defined for the catalog, the user name must belong to a group having the Use Administrator privilege.


New Group Name (Add Database Group)

In the New Group Name box, type the name of the new group to be added to the list of database groups associated with the catalog. Each group name and user name must be unique within a catalog.


New Owner Name (Change Catalog Owner)

In the New Owner Name list, select the name of the new owner of the catalog. This list contains the names of database groups associated with the current catalog.


New Password (Change Password)

In the New Password box, type the password for the new group or user. An asterisk (*) character is displayed for each character entered. This entry is optional.


New (Select Character Set)

The New button displays a standard Windows dialog box that allows you to specify the file that contains the character set you want to use. Character set files have the extension, .cs.

Note This button provides the same functionality as the Import button on the Character Set Maintenance dialog box.


New User Name (Add Database User)

In the New User Name box, type the name of the new user to be added to the selected database group within the catalog. Each group name and user name must be unique within a catalog.


New (Users Tab DBA)

The New button displays the Edit Users form for the definition of a new group or user for the catalog.

Note The Users command on the Edit menu provides the same functionality as the New button.


New (Welcome to Relativity Window)

Select the New option to set up and create a new data source. (An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database.) If you have multiple drivers installed, select the appropriate driver from the List area and then create a new data source. For more information, see Setting Up a New Data Source.)

Note This option provides the same functionality as the New Data Source command on the File menu.


Not Granted (Edit Privileges Form DBA)

The Not Granted column in the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group does not have access rights.


Not Selected SELECT Privileges DBA

Privilege | Action
Table: ALL Column: ALL | Adds or removes all related privileges.
Table: select Column: select | Adds 'SELECT' privilege or removes all privileges.
Table/Column: insert, update, references, delete | Adds named privilege and 'SELECT' privilege or removes only named privilege.


OK (Add Database Group)

The OK button completes the Add Database Group dialog box by accepting the new group name in the dialog box.


OK (Add Database User)

The OK button completes the Add Database User dialog box by accepting the new user name into the selected group.


OK (Change Catalog Owner)

The OK button completes the Change Catalog Owner dialog box by accepting all entries made in the dialog box.


OK (Change Password)

The OK button completes the Change Password dialog box by accepting all entries made within the dialog box.


OK Command Button (System Options DBA)

The OK button accepts all the selected options in the Options dialog box and closes the dialog box.


OK (Date Constants)

The OK button completes the Date Constants dialog box by accepting the values and structures specified in the dialog box.


OK (Logon)

The OK button completes the Logon dialog box by accepting all entries made within the dialog box.


OK (Printer Choice)

The OK button completes the Printer Choice dialog box by accepting the selections made within the dialog box.


OK (Select Character Set)

The OK button completes the Select Character Set dialog box by associating the selected code page entries with all of the file definitions in the catalog.


OK (Welcome to Relativity Window)

· If you click OK after selecting the New option, you set up a new data source.

· If you click OK after selecting either the Existing or Recent option, the Catalog window for the specified data source is opened. Note that if security has been defined for the catalog associated with the data source, you must complete the Logon dialog box.


Opening a Data Source DBA See Also

Configuring a Relativity Data Source

Starting the Relativity DBA


Open Last Data Source on Startup (System Options DBA)

When the Open Last Data Source on Startup check box is selected on the System page of the Options dialog box, the information about the last data source processed is stored when exiting from the Relativity DBA. The next time the Relativity DBA is started, the stored data source information determines the data source to be automatically opened. The data source name and user name are shown at the bottom of the System page.


Open (Open Relativity Data Source)

· If security has been defined for the catalog associated with the data source, the Open button displays the Logon dialog box, which provides for the entry of a user name and an optional password for the specified catalog.

· If security has not been defined for the catalog, the Open button opens the Catalog window in the Relativity DBA window with the Edit menu appearing in the menu bar.


Open Relativity Data Source Dialog Box DBA See Also

Defining Catalog Ownership


Open (Reports Tab DBA)

The Open button provides the facility to do either of the following:

· Create a new report

· Modify a selected report

If a report category has been selected prior to clicking the Open button, the Select Report dialog box is displayed for selecting an existing report or creating a new report. If a specific report description has been selected prior to clicking the Open button, that report will be opened in the Report Editor for editing its description. The edited description may be saved as a new report, using Save As, or saved as the new layout for the same report, using Save.

Note The Edit command on the Reports menu provides the same functionality as the Open button.


Open (Select Report)

When a report is specified in the File name box, click the Open button to access the Report Editor.


Options Area (Print Options)

The Options area allows the selection of what portion of the report to print or direct to an export module (a group of pages beginning with a specific page number; all pages; or a range of pages).


Options Dialog Box DBA See Also

System Options


Overview DBA See Also

ODBC-Enabled Applications

Trademark Acknowledgments


Password (Add Database Group)

In the Password box, type the password for the new group. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Add Database User)

In the Password box, type the password for the new user. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Change Catalog Owner)

In the Password box, type the password for the new owner. An asterisk (*) character is displayed for each character entered. This entry is optional.


Password (Logon)

In the Password box, type the password for the group or user. An asterisk (*) character is played for each character entered. This entry is optional.


Path Name (Add Table Connection Regular)

In the Path Name box, type, or select from the list, the path name to the data file. This path name is associated with the table connection being added to the selected table definition in the Edit Connections form. The path name is the physical filename of the data file.

Each unique file path name used in a table connection is added to the file connection list in the catalog. This list is used to provide the list for the Path Name box in the Add Table Connection dialog box. When a table connection is deleted and no other table connection refers to its file connection entry, a message box asks the user if the file connection should be deleted. If the file connection is deleted, it will no longer be available in the list for the Path Name box of the Add Table Connection dialog box, thus requiring that it be retyped into the box if another table connection is later added that uses the same file path name.


Path Name (Edit Connections Form DBA)

The Path Name attribute on the Edit Connections form is the physical filename of the data file.


Path Name Replace (Edit Selected Table Connections)

The Path Name Replace box contains the pattern to be matched within the path name for replacement in the selected table connection.


Path Name Replace With (Add Connections Matching Pattern)

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name with box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.


Path Name Replace With (Edit Connections Matching Pattern)

· The Path Name Replace box contains the pattern to be matched within the path name for replacement in the generation of a path name for the new table connection.

· The Path Name With box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the path name for the new table connection.


Path Name With (Edit Selected Table Connections)

The Path Name With box contains the pattern that is to replace the matching characters specified in the Path Name Replace box. The resulting path name becomes the new path name for the selected table connection.


Pattern Matching DBA See Also

Establishing Table Connections


Preview (Select Report)

In the right half of the dialog box, the Preview area displays a thumbnail version and the name of the of the selected report definition file as you move from file to file in the List area.


Print (Edit Connections Form DBA)

Click the Print toolbar button to display the Print Options dialog box and print the default Connections report (as specified in the RELDBDBA.INI file). The initial default Connections report is Connections by Table Name report.

Shortcut: Alt+P


Print (Edit Privileges Form DBA)

Click the Print button to display the Print Options dialog box and print the default Privileges report (as specified in the RELDBDBA.INI file). The initial default Privileges report is the Privileges by Grantee report.

Shortcut: Alt+P.


Print (Edit Users Form DBA)

Click the Print toolbar button to display the Print Options dialog box and print the default Users report (as specified in the RELDBDBA.INI file). The initial default Users report is the All Users by User Name report.

Shortcut: Alt+P


Printer Page Dependent (Printer Choice)

The Printer Page-Dependent option in the Printer Choice area relates to the printing of the first and following pages of a report on different printers. Selecting this option enables two Select buttons.


Printer Page Independent (Printer Choice)

The Printer Page-Independent option in the Printer Choice area relates to the printing of all pages of a report. Selecting this option enables a Select button.


Print Options Dialog Box DBA See Also

Exporting Data to a Comma-Separated File

Print a report

Reporting


Print (Reports Tab DBA)

The Print button displays the Print Options dialog box for the printing of the report selected from the list of reports displayed in the Reports tab.

Notes

· If a report category is selected instead of a specific report description, a Select Report dialog box is displayed first to allow selection of the specific report definition file to be printed.

· The Connections, Privileges, and Users commands on the Reports menu provide the same functionality as the Print button.


Privilege Codes

The following chart explains the privilege codes:

Code | Meaning
A | Use Relativity DBA
C | Modify Date Constants
G | Create New Groups
I | Insert
N | Create New User
P | Print Reports
R | Reference
S | Select
T | Select New Table Connections
U | Update
X | Delete

The code letter is followed by a "+" symbol if granted with the Grant option. The code letter is followed by a "-" symbol if revoked; however, the current system never sets revoked.


Privilege List (Edit Privileges Form DBA)

The Privilege list in the Edit Privileges form contains the privileges that can either be granted or not granted to a database group associated with the catalog. There are five types of privileges for a Relativity database:

1. Administrator privileges

2. Create Users privilege

3. Create Tables privilege

4. Table privileges

5. Column privileges

Note When a Column privilege is selected, a Table list is displayed to the right of the Privilege list in the Edit Privileges form. This list contains the names of all tables within the database. Upon selection of a table, the Not Granted column contains the names of all columns within the specified table.

The privilege you select in the Privilege list determines what appears in the Not Granted, Granted, and With Grant columns, as described in the following table.

When you select the following privilege | These items appear in the Not Granted, Granted, and With Grant columns
Administrator | Privileges: Create Groups, Date Constants, Reports, Use Administrator
Create Users | Group names
Create Tables | Table definition names
Table | Table names
Column | Column names (from the table definition associated with the table name selected in the Table list that is displayed when a Column privilege is selected)


Privileges Codes Table

The following table defines the privilege codes that can appear on the Privileges reports. A plus sign before the privilege code means "with grant" and a minus character means "not granted."

Code | Meaning
A | Use Relativity DBA
G | Create New Groups
C | Modify Date Constants
P | Print Reports
T | Create New Table Connections
S | Select
I | Insert
U | Update
R | Reference
X | Delete
N | Create User


Privileges Report Features DBA See Also

Defining Group Privileges

Reporting


Privileges (Users Tab DBA)

The Privileges button displays the Edit Privileges form for the selected group. If a group is not selected, the Privileges button is disabled.

Note The Privileges command on the Edit menu provides the same functionality as the Privileges button.


Recent (Welcome to Relativity Window)

Select the Recent option to open the data source that you have most recently used in the Relativity DBA. When you select this option, a numbered list--in the order of the most recently opened data sources--is displayed in the List area and the data source most recently used is highlighted.

To quickly reopen one of these data sources, click it. If one of these data sources is selected from this list, any open, existing data source is closed, and the selected data source is opened.

Note This option corresponds to the Most Recently Used Data Source command on the File menu.


Regular Expression Syntax Used in Pattern Matching DBA See Also

Pattern Matching Examples


Relativity Catalogs DBA See Also

Working with the Catalog Window


Relativity DBA Window See Also

Starting the Relativity DBA


Report Definition Files DBA See Also

Configuring Report Capabilities

Reporting


Reporting DBA See Also

Exporting Data to a Comma-Separated File


Report Name (Print Options)

The Report Name area indicates the name of the report that was selected for printing or exporting to another type of media in the Select Report dialog box.


Reports List (Reports Tab DBA)

The Reports area displays a list of the report categories and the descriptions of the currently defined reports for each category. A report category or a report description may be selected by clicking once on the desired item in the list.

Note A specific report description may be deleted by selecting the report description and pressing the Del (Delete) key. A message box will be displayed requesting confirmation of the delete report request. If the user confirms the deletion, the report definition files for that report are deleted. The Del key has no effect if a report category is selected.


Reports Tab DBA See Also

Exporting Data to a Comma-Separated File

Relativity Catalogs

Reporting

Reports Menu


Reset Group Password (Edit Users Form DBA)

The Reset Group Password toolbar button causes the removal of the current password for the selected group in the Edit Users form.


Reset User Password (Edit Users Form DBA)

The Reset User Password toolbar button causes the removal of the current password for one or more selected users within a selected group in the Edit Users form.


Save as Type (Save Export File As)

In the Save as type list, select the filename extension from the list or type an extension. The extension for a comma-separated file is .csv.


Save Changes (Edit Connections Form DBA)

Click the Save Changes toolbar button to save any changes you may have made to the Edit Connections form without closing the form.

Shortcut: Alt+S


Save Changes (Edit Privileges Form DBA)

The Save Changes toolbar button accepts all privileges defined in the Edit Privileges form for the groups of a database. Shortcut:

Alt+S.


Save Export File As Dialog Box DBA See Also

Exporting Data to a Comma-Separated File

Reporting


Save in (Save Export File As)

In the Save in list, select the drive and folder in which you want to save the file.

The Save in list box lists the available folders and files. To see where the current folder is located in the hierarchy of folders on your computer or to select a different folder, click the down arrow to the right of the box.

The List area below displays all the folders and files in the selected location. To open any folder or file, click its name in the list. To open the folder one level higher, click the Up One Level toolbar button. To toggle the manner in which information is displayed in this area, click the List and Details toolbar buttons.


Save Options Permanently (Print Options)

The Save options permanently check box allows you to save the settings you have selected for the printer or other export media. Note that this check box is unavailable unless the printer (and any printer settings) or export module options have been changed in the Printer Choice dialog box.


Save (Save Export File As)

The Save button completes the Save Export File As dialog box by accepting all selections made within the dialog box and displays the Print Options dialog box.


Select Character Set Dialog Box DBA See Also

Character Set Maintenance Dialog Box

Defining Nonstandard Character Sets


Selected SELECT Privileges DBA

Privilege | Action
Table: ALL Column: ALL | Adds or removes all related privileges.
Table: select Column: select | Adds or removes only 'SELECT' privileges.
Table/Column: insert, update, references, delete | Adds or removes only named privilege.


Select (Printer Choice)

The Select button displays a standard Windows dialog box that allows you to specify a printer and define its properties and paper settings (paper size, paper source, and paper orientation).


Select Report Dialog Box DBA See Also

Create a new report

Edit an existing report


Select Server Dialog Box DBA See Also

Configuring a Relativity Data Source


Set Euro Character (Character Set Maintenance)

Use the Set Euro Character for Selected Character Set area to change the location of the Euro character in a character set. Some COBOL applications supported the Euro character before the International Standards Organization decided its value in standard character sets. In such cases, Relativity must modify its understanding of the value of the Euro character within the standard character set.

To do this, select the character set whose definition for the Euro character will change from the Character Set column. Check the Enable Euro check box. In the edit box, enter the value that is used to represent the Euro character in the COBOL data file. The value must be a number between decimal 0 and 255 (hexadecimal 0x00 and 0xff). Click the Update button to change the value. The new value will appear in the Euro list to the right of the character set name in the Character Set column.


Setting Up a New Data Source DBA See Also

Configuring a Relativity Data Source

Starting the Relativity DBA


Show Welcome at Startup (Welcome to Relativity Window)

By default, the Show Welcome at Startup option is selected when you first install and start the Relativity DBA. If this option remains enabled, the Welcome to Relativity window displays each time you start the Relativity DBA. If you disable this option, you can choose Welcome from the Tools menu to enable it again.


Starting the Relativity DBA See Also

Configuring a Relativity Data Source

Customizing the Initialization File (RELDBDBA.INI)

Relativity DBA Window

Welcome to Relativity Window


Start (Print Options)

The Start button sends the print job to the selected printer or export module.


Supported standard character sets (Select Character Set)

Standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |


System Options DBA See Also

Defining Group Privileges

Determining Micro Focus COBOL Indexed File Formats

Setting Options

Starting the Relativity DBA


Table All

The Table ALL privilege is a shortcut method of assigning all the individual Table privileges (SELECT, INSERT, UPDATE, REFERENCES, and DELETE) at one time. When the Table:ALL privilege is selected, the table names are displayed in the leftmost applicable column; that is, if any Table privilege is not granted, the table names are displayed in the Not Granted column. If any Table privilege is not granted with grant, then table names are displayed in the Granted column. Finally, if all Table privileges are granted with grant, table names are displayed in the With Grant column.

When Table ALL is selected, a table name can be moved from the Not Granted column to the Granted column in order to grant all the individual Table privileges for that table to the selected group. Then the user may select an individual Table privilege, for example, Table:select, and move the same table name from the Granted column to the With Grant column. If the user then selects the Table:ALL privilege again, that table name will still be displayed in the Granted column (not the With Grant column), even though the group has with grant privilege for the Table:select privilege.

Then, the user may select an individual Table privilege, for example, Table:delete, and move the same table name from the Granted column to the Not Granted column. In this case, if the user then selects the Table:ALL privilege again, that table name will be displayed in the Not Granted column, even though the group still has the privileges other than Table:delete for that table. This is because the group no longer has all Table privileges for that table.

Moving a table name from the Granted column to the Not Granted column when Table:ALL is selected resets all the Table privileges to Not Granted (including any individual Table privileges that were assigned With Grant).


Table Definition (Edit Connections Form DBA)

The Table area on the Edit Connections form contains the names of the Relativity table definitions associated with one or more table connections. A table connection is composed of a table name (the name of an SQL table), a path name (the physical file-name of the data file), and a file label (if file labels are in effect).

· When the Edit Connections form is opened by choosing the Connections command from the Edit menu in the DBA window, this area displays a list of all the currently existing table definitions. To view an example, click here. A plus sign [+] precedes each table definition in the list. To expand an item and display the table connection for a specific table definition, click the plus sign. (Conversely, click the minus sign [-] to collapse an item in the expanded list.) The table connection, which is displayed in a hierarchical view, is composed of the following attributes:

-  a table name (the name of an SQL table; in this case, BackOrder)

-  a path name (the physical filename of the data file; in this case, PROD2FIL), or,

-  if file labels are in effect, a file label (in this case, label name:PROD2FIL)

· When the Edit Connections form is opened from the Tables tab in the Catalog window, this area displays only the associated table connection (that is, the table name, the path name, which is the physical file-name of the data file, and a file label, if file labels are in effect) for the selected Relativity table definition. Click the plus sign [+] to expand the list; click the minus sign [-] to collapse the list. To view an example, click here. To view an example with file labels in effect, click here.

Note In either situation, if you right-click any of the items in the list or expanded list, a pop-up context-sensitive menu is displayed for that item.


Table List (Edit Privileges Form DBA)

The Table list on the Edit Privileges form contains the names of all tables within the database. When a table is selected, the Not Granted column contains the names of all columns within the specified table. The Table list is displayed only when a Column privilege is selected.


Table Name (Add Table Connection Regular)

Within the Table Name box, type the table name of the SQL table to be associated with the table connection being added to the selected table definition in the Edit Connections form.


Table Name (Edit Connections Form DBA)

The Table Name attribute on the Edit Connections form is the name of an SQL table.


Table Name Replace With (Add Connections Matching Pattern)

· The Table Name Replace box contains the pattern to be matched within the table name for replacement in the generation of a table name for the new table connection.

· The Table Name with box contains the pattern that is to replace the matching characters specified in the Table Name Replace box. The resulting table name becomes the table name for the new table connection.


Tables List (Tables Tab DBA)

The Table Name area displays a list of tables currently defined in the catalog. A table may be selected by clicking once on the table name. Double-clicking a table name in the list is equivalent to selecting it and then clicking the Connections button.


Tables Tab DBA See Also

Establishing Table Connections

Relativity Catalogs


Toolbar Area (Save Export As)

This area contains several toolbar buttons that allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


Toolbar (Select Report)

The buttons on the toolbar allow you to perform the following tasks:

· Go To. When enabled, click to return to the last folder visited.

· Up One Level. Click to see the contents of the folder one level above the folder you are currently viewing. The contents of the folder appear in the List area.

· Create New Folder. Click to create a new folder within the folder you are currently viewing.

· View Menu. Click the down arrow to access each of the following view options for the files in the folder that is currently open:

-  The Thumbnails view displays the images a folder contains on a folder icon so you can quickly identify the contents of the folder. The complete folder name is displayed under the thumbnail.

-  The Tiles view displays your files and folders as icons. The icons are larger than those in Icon view, and the sort information you select is displayed under the file or folder name.

-  The Icons view displays your files and folders as icons. The name of the file is displayed under the icon; however, sort information is not displayed.

-  The List view, which is the default view, displays the contents of a folder as a list of file or folder names preceded by small icons.

-  The Details view lists the contents of the open folder and provides detailed information about your files, including name, size, file type, and date modified. You may click any of these column headings to sort the list by that category.


To select one or more table connections

To select:

· a single table connection, click the mouse button on the desired table connection row.

· two or more table connections, select the first table connection. Then hold down the Ctrl key as you select each additional table connection.

· a range of table connections, select the first table connection in the range and then hold down the Shift key while selecting the last table connection in the range. The Ctrl and Shift keys must be used together if table connections outside the range of consecutive table connections have already been selected.


Types of Report Data Elements

The following codes are used to describe the availability of the various types of data elements in reports:

F The data element is available as a Field in a report table object.

V The data element is available as a Variable in a report text object.

P A data element containing the value of the data element in the last report table line is available; the name of this element is “Previous” concatenated before the data element name (for example, Previous.File.Item.Name).

E The data element is available as an end-of-page variable in a report text object; the name of this element is “EOP” concatenated before the data element name (for example, EOP.File.Item.Name). In the Report Editor online Help file, see "Fundamentals", then "Linking Objects."

I The data element is available as an Input variable and field; the name of this element is “INPUT” concatenated before the data element name (for example, INPUT.COBOL.File.Name). If input data elements are used in a report (for example, in the report filter equation), then the operator will be prompted to enter a value for the input data element(s) before beginning the print run. The values entered will be maintained throughout the print run.


Use Expiration Area (Add Database Group)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this field or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


Use Expiration Area (Add Database User)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the user name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this box or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


Use Expiration Area (Change Password)

By selecting the Use Expiration check box and entering an expiration date in the Date box, you can make access to a catalog unavailable to the selected user name or group name after a specified date. By default, the date entered in the Date box is the current date.

You can type a different date in this field or you can click the Calendar button to select a date from the calendar. You also can enter a date format other than the default format shown.


User Name (Change Password)

In the User Name box, type the name of the new group or user whose password is to be changed.


User Name (Edit Users Form DBA)

The User Name attribute on the Edit Users form is the name of a user associated with the selected user group. Each user name and group name within a catalog must be unique.


User Name (System Options DBA)

The User Name box on the System page of the Options dialog box displays the name of the group or user logged on to use the data source.


Users List (Users Tab DBA)

The Users area displays a list of the groups and users currently defined in the catalog for the Relativity database. A group or user may be selected by clicking once on the group or user name. Double-clicking a group name is equivalent to selecting it and clicking the Privileges button. Double-clicking a user name simply selects the user name.

Note A group or user may be deleted from the catalog by selecting the group or user name and pressing the Del (Delete) key. If a user name has been selected, the user name is immediately deleted. A message box, however, will be displayed requesting confirmation of a delete group request. If you confirm the deletion, the group and all its users are deleted from the catalog.


Users Report Features DBA See Also

Defining Groups and Users

Reporting


Users Tab DBA See Also

Defining Group Privileges

Defining Groups and Users

Relativity Catalogs


Use White Background on Grids (System Options DBA)

When the Use White Background on Grids check box is selected on the System page of the Options dialog box, Relativity overrides the color choice (set on the Appearance tab of the Display Properties dialog box) with white on the grid area containing the table definitions, table names, and path names in the Edit Connections form. If this option is not selected, the background will be the same color as the top portion in the Edit Connections form.


Using Microsoft Query with Relativity Data Sources DBA See Also

Configuring a Relativity Data Source


Using Relativity Help DBA See Also

Help Button Bar


Verify Password (Add Database Group)

In the Verify Password box, type the password a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database Group dialog box must contain the same characters before the password is accepted for the group.


Verify Password (Add Database User)

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Add Database User dialog box must contain the same characters before the password is accepted for the user.


Verify Password (Change Password)

In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered. Both passwords entered in the Change Password dialog box must contain the same characters before the password is accepted for the group or user.


Welcome to Relativity Window DBA See Also

Opening a Data Source

Setting Up a New Data Source

Starting the Relativity DBA


With Grant (Edit Privileges Form DBA)

The With Grant column in the Edit Privileges form contains the privileges, tables, or columns of a table to which the specified group has access rights. The group also has the ability to grant those access rights to another group.


Working with the Catalog Window DBA See Also

Relativity Catalogs


'YY' Base Year

The 'YY' Base Year box is displayed on the second line of the Date Constants dialog box when the 'YY' Base Year option button is selected. The 'YY' Base Year is changed either by typing a two-digit year in the box or clicking on the arrows to indicate the two-digit year. This date constant specifies the base year used to interpret date values containing a two-digit year. The default base year is 1900. The base year is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.


'YY' Base Year Option Button

The selection of the 'YY' Base Year option button displays the 'YY' Base Year box on the second line of the Date Constants dialog box.


'YY' Century Cutoff

When the 'YY' Century Cutoff option button is selected, the 'YY' Century Cutoff box is displayed on the second line of the Date Constants dialog box in place of 'YY' Base Year. The 'YY' Century Cutoff is changed either by typing a two-digit value in the box or clicking on the arrows to indicate the two-digit century cutoff. This date constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.


'YY' Century Cutoff Option Button

The selection of the 'YY' Century Cutoff option button displays the 'YY' Century Cutoff box on the second line in the Date Constants dialog box in place of 'YY' Base Year.

The 'YY' Century Cutoff is changed either by typing a two-digit value in the box or clicking on the arrows to indicate the two-digit century cutoff. This date constant specifies the century cutoff year used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff. The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If this date constant is changed to 1930, then all COBOL two-digit year dates less than 1930, after adding the two-digit base year, will be incremented by 100; that is, the two-digit years 00 through 29 would be interpreted as the four-digit years 2000 through 2029. If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.


'YY' Dates

The structure of 'YY' Dates is selected from the 'YY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed. The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in their files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit-day of the month).


'YYYY' Base Year

The 'YYYY' Base Year is changed either by typing the value in the box or clicking on the arrows to indicate the four-digit base year. This date constant specifies the base year used to interpret date values containing a four-digit year. The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.


'YYYY' Dates

The structure of 'YYYY' Dates is selected from the 'YYYY' Dates list. This date constant specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed. The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in their files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).


88-level

A means of defining a condition-name in COBOL data description entries.


AirlineDate

An internal function that computes a date from an "airline travel date" (PIC X(5) in the form DDMMM), transaction date (transformed into a date), and a one-character transaction type (PIC X), respectively. The resulting date is formed by using the day and month of the travel date. If the travel month is less than the transaction month and the transaction type = "1", then add 1 to the transaction year to produce the resulting year.

The YYYYMMDD transform may be applied to resulting data item.

Note that this function is available only if the RELDBDSN.INI file has the following entry in the [Designer] section:

EnableAirlineDate=Yes


attribute

The term attribute refers to information about a Relativity form, such as the: FD form, Table form, Edit Connections form, Edit Users form, or Edit Privileges form.


catalog

The function of the Relativity catalog is similar to that of the "system catalog" in a relational database management system. It serves as a repository for information regarding the structure of relational tables as well as operational information required by runtime components of Relativity, such as the query optimizer.

Additionally, the Relativity catalog contains complete information regarding the physical COBOL file structure (that is, the COBOL file definition, or FD information) and information produced by the database design process (Relativity Designer) that defines the association between COBOL files and data elements, and the relational tables and their constituent columns. Together, all of this information allows Relativity to present the COBOL data files through the ODBC interface of an ODBC-enabled application as a Relativity database of well-normalized tables substantially independent of the original COBOL file structure of the application. See also Relativity DBMS and relational table.


COBOL schema

The file control entry, the file definition (FD) entry, and the associated data description entries for a COBOL data file extracted from a COBOL source file. See also COBOL schema file.


COBOL schema file

This file contains one or more COBOL schemas as extracted from a COBOL source file. The COBOL schema file is also called the Relativity Symbol Table file (or RST file). See also COBOL schema.


COBOL table

A COBOL group or elementary data item described with the OCCURS clause. Contrast with relational table. See also table and repeating data item.


CombineDateTime

An internal function that allows two data items to be combined into a single date/time stamp value. The first argument should be a date data item. The second argument should be a time data item.

The YYYYMMDDHHMMS transform may be applied to resulting data item.


Complement

An internal function that performs an arithmetic complement on a numeric data item. The first argument is the data item to be complemented; the second argument is an 88-level condition-name. If the 88-level condition-name value is false, the arithmetic complement is not performed.


ComputeCenturyDate

The ComputeCenturyDate internal function computes a date from data items and/or constants containing the century, the year of the century, the month, and the day of the month or year. When a constant zero is supplied for the month, ComputeCenturyDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.


ComputeCenturyDateTime

The ComputeCenturyDateTime internal function computes a date and time data item from data items and/or constants containing the century, the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.


ComputeDate

An internal function that computes a date from data items and/or constants containing the year, the month, and the day of the month. When a constant zero is supplied for the month, ComputeDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.


ComputeDateTime

An internal function that computes a date and time data item from data items and/or constants containing the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.


ComputeODO

An internal function that computes an occurrence count from the record length, the record offset of the (single) argument, and the length and span of the argument. The argument must be a repeating data item at the end of the record.


ComputeTime

An internal function that computes a time data item from data items and/or constants containing the hour of the day, the second of the minute, and the hundredth of the second.

The HHMMSShh transform may be applied to the resulting data item.


conditional variable

A data item that has one or more condition-names associated with it. The value of the conditional variable is used to determine whether the condition item named by the condition-name is true or false by comparing it to the values assigned to the condition-name.


condition item

A named subset of values that a conditional variable may assume. The condition item is true when the conditional variable assumes any of the true values. The condition item is false when the conditional variable assumes any other value. A condition item may optionally specify a single preferred value for which the condition item is false when the conditional variable assumes that value. The declaration of a condition item includes a condition-name that is used to refer to the condition item.

In Relativity, a column may be defined on a condition item, in which case the column has a value of 0 for false, and 1 for true. Relativity also uses condition items for specifying null values, specifying filters, and binding subscripts. To help support these uses of condition items, the Relativity Designer allows definition of additional condition items that were not in the COBOL source program.


condition-name

A user-defined word that names a condition item. In COBOL, a condition-name is declared in an 88-level description entry following the data description entry of its associated conditional variable.

Note Relativity does not make use of the alternative COBOL meaning of condition-name where the condition-name is assigned to the status of a switch or device.


Constrain property

A property that limits the value that a column may have during an INSERT or UPDATE operation to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. If the program did not define the appropriate 88-level condition-name(s), the Relativity Designer may be used to add the necessary condition-name(s).


database

In this document, particularly when qualified by "Relativity", a database refers to a relational database of tables and columns accessible as an ODBC data source, where the value for a column is derived from a data item in a COBOL file. An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database. The Relativity Designer is used to create and maintain the catalog. The Relativity DBA may be used to maintain a subset of the catalog relating to end-user administration features such as table connections, security, and date constants.


data item

A named unit of data (excluding literals) defined by the COBOL program in a data description entry. The declaration of a data item includes a data-name that is used to refer to the data item. The Relativity Designer allows additional data items to be defined that redefine data items defined by the COBOL source program. See also repeating data item.


data-name

A user-defined word that names a data item.


data source

In Relativity, a data source is the connection known to ODBC between a Windows workstation and a Relativity catalog. A data source name (DSN) is used to identify the data source on the workstation. See also database and ODBC-enabled application.

Note In client/server configurations of Relativity, a data source is defined on both the client workstation and on the server. The client data source is known to ODBC by its DSN and specifies the connection to the server data source. The server data source provides the connection to the Relativity catalog.


date constants

Values stored in the Relativity catalog that control the conversion in a date transform or an internal function of COBOL data item values to SQL column date values. The date constants can be adjusted using the Relativity Designer or Relativity DBA to reflect common algorithms used in COBOL procedural code.


domain

A named set of characteristics of a column including the data type, default value, constraints on the values in the column, and whether null values are allowed for the column. See also item pattern, ODBC data type, and user data type.


file connection

A file connection is used to store each unique path name specified in one or more table connections. When a table connection is added that specifies a file path name that is not in the file connection list of the catalog, a new file connection entry is created. The file connection entries are used to display the list for the Path Name box in the Add Table Connection dialog box.


file label item

A file label item is a special file definition item used in multi-file table support. Multi-file table support allows the records of more than one COBOL file to be combined to constitute the rows of a single table. A file label item controls the way in which the records are combined, and provides a way to distinguish the business unit from which the row originated in the ODBC application.

A given FD may have only one file label item. A file label item can have a column defined on it and this column will be part of the indexes defined on the table.


filter

A set of criteria applied to records in order to obtain a subset of records that will be used to supply rows to a table. Relativity uses two types of filters: record type filter and table filter. Relativity filters use an expression composed of a filter subexpression or several filter subexpressions to specify the condition under which a record passes through the filter.


filter subexpression

A connecting logical operator (AND or OR), an optional negation logical operator (NOT), and a condition-name used to compose a filter expression that specifies the condition under which a record passes through the filter. If a filter has no subexpressions, then all records pass through the filter.


function

See internal function.


function item

A data item that has been synthesized using an internal function.


indexed file

A file having a permanent logical file structure in which each record is identified by a value of one or more keys within that record.


internal function

A conversion process, built into Relativity DBMS, that is used to synthesize a COBOL data item using the value or values of one or more other COBOL data items within the same COBOL file definition (FD). The other COBOL data items, which may include a previously defined internal function, are specified as arguments to internal functions. The result of the internal function is used as the value for the synthesized COBOL data item, also known as a function item. Unlike a transform, an internal function may operate on more than one COBOL data item. Compare to transform.


ISAM file

A term used to refer to an indexed file.


IsNumeric

An internal function that evaluates the data item supplied as an argument to determine whether its value is a valid numeric value. If the data item is numeric, the function returns the value one, which is the logical value of true. If the data item is not numeric, the function returns the value zero, which is the logical value of false.


IsValidDate

An internal function that evaluates the data item supplied as an argument to determine whether its value conforms to that item’s date transform. If the date item value represents a valid date, the function returns the numeric value one, which is the logical value of true. If the data item value does not represent a valid date, the function returns the numeric value zero, which is the logical value of false.


item pattern

A set of properties common to data items for which columns based on those data items belong to a particular domain. The properties include a string pattern match on the COBOL data-name, the COBOL data type, the length, and, for numeric items, the precision and scale. Associated with each item pattern is a user data type and item transform. After item patterns are defined, the patterns can be used to assign the associated user data type and item transform to all data items whose descriptions match one of the specified patterns. As a result, columns based on the data items that match a particular item pattern will also have matching characteristics, that is, will belong to the same domain. A common use of item patterns is to treat all COBOL data items that represent a date value in a consistent manner. Other examples of sets of COBOL data items to which item patterns apply are customer numbers, company identifiers, prices, and inventory numbers.


item set

Two or more data items in a COBOL record that contain identical information but that have been identified to Relativity as sets of redundant data items. Redundant data items include situations such as where one data item is identical to the first characters of another data item. One place where redundant data items are defined is in keys, where different keys provide different look-up capabilities in a file. Using Relativity, an item set becomes one data item in a relational table.


LogicalAnd

An internal function that does a logical "and" operation on two to twenty 88-level condition-name data items or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If all of the arguments are true, a numeric value of one is returned as the column value. If any of the arguments are false, a numeric value of zero is returned.


LogicalOr

An internal function that does a logical "or" operation on two to twenty 88-level condition-name data items or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If any of the arguments are true, a numeric value of one is returned as the column value. If all of the arguments are false, a numeric value of zero is returned.


null

A value used in SQL to indicate that the column data value is incorrect, inapplicable, or unavailable. See also condition item and null.


nullable

An indicator that the column data value may be set to null.


ODBC

Abbreviation for Open Database Connectivity, a Microsoft Windows interface allowing applications to access data in database management systems (DBMS) using Structured Query Language (SQL). See also ODBC-enabled application.


ODBC data type

An SQL definition that governs the type of data that is valid for a column in a relational table. The following lists the data type names preassigned to ODBC data types in Relativity:

· Exact numeric data types are bit, smallint, integer, and decimal.

· Approximate numeric data types are single and double.

· Character (or text) data types are char, varchar, and longvarchar.

· Unstructured binary data type is longvarbinary.

· Date/time data types are date, time, and timestamp.

The preassigned data type names for the ODBC data type appear in a bold font on the Table form. See also user data type.


ODBC-enabled application

A Windows-based client application program (or tool) that has been designed to use the ODBC interface to access data external to the application. The ODBC interface requires that a data source be configured in order to allow data access. Examples of such programs include MS-Access, MS-Excel, Lotus 1,2,3, Crystal Reports, PowerBuilder, and so forth.


ODO control item

The data item referenced by the data-name specified in the DEPENDING ON phrase of the OCCURS clause.


Open Database Connectivity

A Microsoft interface allowing applications to access data in database management systems (DBMS) using Structured Query Language (SQL). Abbreviated ODBC.


parallel OCCURS

Two or more separate OCCURS clauses in a record description entry that each specify the same number of occurrences and where the COBOL tables created by the OCCURS clauses can be thought of as really being a single COBOL table accessed by a single subscript item.


RDBMS

Abbreviation for relational database management system, a program or set of programs for managing a relational database. Such a system normally includes a query capability that implements a query language. A common choice for the query language is Structured Query Language (SQL). See also Relativity DBMS.


record type

A particular layout of a record area when multiple layouts exist because of redefinition or varying interpretation of data items in the record area. Normally, record types are distinguished by a record type indicator data item that is either outside any redefinition or exists in every redefinition. Relativity uses an 88-level condition-name defined on the record type indicator to distinguish record types. If the program did not define the appropriate 88-level condition-name(s), the Relativity Designer may be used to add the necessary condition-name(s). See also record type filter.


record type filter

A filter associated with a record type that determines the conditions controlling the subset of records from the file that conform to that record type. When a table is based on the record type, only records that satisfy the specified conditions contribute rows to that table. Those records may be further filtered by a table filter if a table filter is associated with the table. Record type filters are specified on the Record Type Properties form accessed from the FD form in the Relativity Designer.


redundant data items

See item set.


relational database

A type of database that defines multiple and complex relations among different data using tables (rows and columns of data). In a relational database, the rows of a table represent records (collections of information about separate items) and columns represent data items (particular attributes of a record). Relationships among data items are not physically stored. Instead, data is stored in tables, and relationships between two or more records are established by matching the values of columns common to those tables. See also relational database management system.


relational database management system

A program or set of programs for managing a relational database. Such a system normally includes a query capability that implements a query language. A common choice for the query language is Structured Query Language (SQL). Abbreviated RDBMS. See also Relativity DBMS.


relational table

A set of rows where each row contains the same number of columns. In any one column of a table, all the rows have the same value type in that column. Contrast with COBOL table. See also database and table.


Relativity Data Client

The Relativity Data Client is the component of the Relativity DBMS that resides on the Windows client machine and provides the ODBC interface for the two-tier or client/server configuration of Relativity. ODBC-enabled applications running on the client machine access Relativity data on the server machine using the interface implemented in the Data Client. The Data Client is, essentially, the ODBC Driver for Relativity in this configuration. See also Relativity Data Server.


Relativity Data Manager

The Relativity Data Manager is used in the single-tier (or non-client/server) configuration of Relativity where the complete Relativity DBMS resides on a single Windows machine. This component implements the ODBC interface, the file to relational database transformations, and the application data file access routines. All the data files to be accessed must be accessible from the Windows machine, either because the files exist on disk drives attached to that machine or are accessible using the Windows network file system.


Relativity Data Server

The Relativity Data Server is the component of a two-tier or client/server Relativity DBMS that resides on the remote server machine and implements the file to relational database transformations and the application data file access routines. This component runs on the remote machine that has access to the COBOL data files, either directly or through the network file system of the remote machine. See also Relativity Data Client.


Relativity DBMS

The Relativity DBMS (Database Management System) is software that implements an ODBC-compliant and relational database view of actual, operational COBOL data files. The Relativity DBMS also can take instructions from the ODBC-enabled application to access and change data in the COBOL data files. The ODBC-enabled application issues a high-level command, called an SQL statement, describing the data that the application wants to access. The Relativity DBMS performs the same actions a COBOL program would perform in order to extract that data and then returns the data to the ODBC-enabled application in the form of "rows".

The Relativity DBMS comes in two different configurations. In the single-tier or non-client/server configuration, the complete Relativity DBMS resides on a single Windows machine. The single-tier configuration component of the Relativity DBMS is referred to as the Relativity Data Manager. In the two-tier or client/server configuration, the Relativity DBMS is split into two components so that the DBMS can reside on two machines. The two-tier components of the Relativity DBMS are referred to as the Relativity Data Client and the Relativity Data Server. See also data source and catalog.


Relativity Symbol Table file

A file containing one or more COBOL schemas extracted from a COBOL source file. The Relativity Symbol Table file (or RST file) is also called the COBOL schema file. See also COBOL schema.


repeating data item

A data item having a data description entry that either contains the OCCURS clause or is subordinate to a data description entry that contains the OCCURS clause. See COBOL table. A repeating data item is also referred to as a subscripted data item, since such data items generally require a subscript when specified in COBOL source statements.


SQL

Abbreviation for Structured Query Language, a language to access data in a database management system (DBMS). See also ODBC.


Structured Query Language

A language to access data in a database management system (DBMS). Abbreviated SQL. See also ODBC.


subscripted data item

A repeating data item (q.v.).


subscript item

A data item created by the Relativity Designer for each COBOL table. A subscript item, while not an actual part of the record, represents the subscript used to access repeating data items in the record. A column may be based on the subscript item by dragging the subscript item to a relational table in the Table form. Subscript items are given the data-name "SubscriptItem", and they are shown in the FD form immediately following any data item described with the OCCURS clause.


table

In Relativity, a table is usually a relational table composed of rows and columns. In certain cases, made clear by explicit qualification or context, a table is a COBOL table of repeating data items defined by use of the OCCURS clause. See also table filter.


table connection

A table connection is composed of a table name and a path name. (The table name is the name of an SQL table. The path name is the physical filename of a data file.) One or more table connections are associated with a Relativity table definition. Each table connection associated with the same Relativity table definition has identical characteristics except for the path name of the underlying COBOL data file.


table definition

A table definition is created by the Relativity Designer to define the structure of a relational table associated with a COBOL data file.


table filter

A filter associated with a table that determines the conditions controlling the subset of records from the file that contribute rows in that table. If the table is based on one or more record types, the table filter is applied after the record type filters, if any, associated with those record types. A table filter is appropriate when either record types are not used or the table is a subset of the records belonging to the record type upon which the table is based. Table filters are specified on the Table Filter Properties form accessed from the Table form or Table menu in the Relativity Designer.


table name

A table name is the name of an SQL table.


transform

A process of converting a single COBOL data item value to or from a relational database column value. An example would be taking a COBOL PIC 9(8) data item that contains 19970129 and converting it to an ODBC date column that contains January 29, 1997. Compare to internal function.


user data type

A Relativity representation of a domain. A user data type, which is defined by the user, is a named set of properties for a column, including its ODBC data type, length, default value, whether the column allows null values, whether the column is constrained to certain values, and, for numeric type columns, the precision and scale. After a user data type is defined, it can be used in place of ODBC data types in column definitions, thus giving all columns with the same user data type similar characteristics.